#include "file_editor.h"

void ChangeFontSel(GtkFontSelectionDialog *fontseldlg)
{
  fontchar=gtk_font_selection_dialog_get_font_name((GtkFontSelectionDialog *)fontseldlg);
  font= gdk_font_load(fontchar);

  gtk_editor_set_pattern_property((GtkEditor *)editor, "default",        font, color_tab[11], NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "comment",        font, color_tab[3],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "include",        font, color_tab[0],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "declare",        font, color_tab[1],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "base",           font, color_tab[2],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "objet",          font, color_tab[5],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "operation",      font, color_tab[6],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "texture",        font, color_tab[9],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "transformation", font, color_tab[8],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "constant",       font, color_tab[10], NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "operator",       font, color_tab[7],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "separator",      font, color_tab[4],  NULL);

  gtk_editor_hilite_buffer ((GtkEditor *)editor);
  gtk_widget_destroy(GTK_WIDGET(fontseldlg));
}

void ChangeFont(void)
{
  GtkWidget *fontseldlg;

  fontseldlg = gtk_font_selection_dialog_new ("Choose your font");
  gtk_font_selection_dialog_set_font_name((GtkFontSelectionDialog *)fontseldlg,
					  fontchar);
  
  gtk_signal_connect_object (GTK_OBJECT (GTK_FONT_SELECTION_DIALOG (fontseldlg)->cancel_button), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (fontseldlg)); 

  gtk_signal_connect_object (GTK_OBJECT (GTK_FONT_SELECTION_DIALOG (fontseldlg)->ok_button), 
			     "clicked", 
			     (GtkSignalFunc) ChangeFontSel, (gpointer)fontseldlg); 
  
  gtk_widget_show(fontseldlg);
}
