#ifndef FILE_EDITOR
#define FILE_EDITOR

#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <gtkeditor.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <gnome-xml/tree.h>
#include "xmlconf/xmlconf.h"

/********************
** Message d'erreur**
********************/
#define ERR_FILE_HELP  "pas d'entrer pour l'aide sur le composant file"
#define ERR_COLOR_HELP "pas d'entrer pour l'aide sur le composant colors"
#define ERR_FONT_HELP  "pas d'entrer pour l'aide sur le composant fonts"
#define ERR_INTER_HELP "pas d'entrer pour l'aide sur l'interface"
#define ERR_ACCEL_HELP "pas d'entrer pour l'aide sur les raccourcis"
#define ERR_BUG_HELP   "pas d'entrer sur le rapport de bug"
/*********************
** Message de l'aide**
*********************/
#define HELP_FILE    "Help on File menu..."
#define ENTRY_FILE   "Vous tes dans l'aide de File (appuyer sur Escape pour fermer l'aide)"
#define HELP_COLOR   "Help on Color menu..."
#define ENTRY_COLOR  "Vous tes dans l'aide de Color (appuyer sur Escape pour fermer l'aide)"
#define HELP_FONT    "Help on Font menu..."
#define ENTRY_FONT   "Vous tes dans l'aide de Font (appuyer sur Escape pour fermer l'aide)"
#define HELP_INTER   "Help on the Interface..."
#define ENTRY_INTER  "Vous tes dans l'aide de l'Interface (appuyer sur Escape pour fermer l'aide)"
#define HELP_ACCEL   "Help on the Accelerator..."
#define ENTRY_ACCEL  "Vous tes dans l'aide des raccourcis (appuyer sur Escape pour fermer l'aide)"
#define HELP_BUG     "Bugs Report..."
#define ENTRY_BUG    "Vous tes dans le rapport de bugs (appuyer sur Escape pour fermer l'aide)"
#define BUTTON_FILE  " Help on File menu "
#define BUTTON_COLOR " Help on Colors menu"
#define BUTTON_FONT  " Help on Fonts menu "
#define BUTTON_INTER " Help on Interface "
#define BUTTON_ACCEL " Help on Accelerator "
/***********************
** Dclaration globale**
***********************/
GtkWidget	*editor;
GtkWidget	*entry;
GdkColor	*color_tab [12];
char		*render_pov_display[3];
char		*render_pov_format [3];
char		*render_output[3];
char		*render_pov_h[3];
char		*render_pov_w[3];
GdkFont		*font;
char		*fontchar;	    
char		CURRENT_FILE[500];
guint		pos;
int		fichier_et_image;
int		format;
int		taille;
xmlDocPtr	conftree;
/***************************
** Prototype des fonctions**
***************************/

/* editor_event.c */
gint EditorEventHelp        (GtkWidget *window, GdkEvent *event, 
			     gpointer Menu);
gint EditorEvent            (GtkWidget *window, GdkEvent *event, 
			     gpointer Menu);
/* pov_renderer.c */
void RenderPov              (void);
void OptionPov              (void);
void SaveRender             (void);
/* help_reader.c */
void read_help_file         (FILE *fp, GtkWidget *text, GdkFont *Title
			     , GdkFont *normal, GdkFont *special);
/* help_menu.c */
void init_entry             (int menu, GtkWidget *text);
void HelpFile               (GtkWidget *widget, int menu);
void ListBug                (void);
void HelpEdit               (void);
/* save_param_util.c */
void SaveColorSyntaxe       (void);
void SaveFontType           (void);
/* change_font.c */
void ChangeFontSel          (GtkFontSelectionDialog *fontseldlg);
void ChangeFont             (void);
/* load_save_pov.c */
int  load_pov_file          (char *file);

void file_ok_sel2           (GtkWidget *widget, GtkFileSelection *fs);
void OpenFunc               (void);
void OpenFunc2              (void);
/* cahnge_color.c */
void ColorChanged_default   (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_comment   (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_include   (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_declare   (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_base      (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_objet     (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_operation (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_texture   (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_transfo   (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_constant  (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_operator  (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ColorChanged_separator (GtkWidget *widget, GtkColorSelectionDialog *colorseldlg);
void ChangeColor            (GtkWidget *widget, int obj);
/* interface.c */
void MakeInterface(void);
/* research_in_edit */
void GoToLigne              (void);
void GoToLigne2             (void);

void StartPovEdit	    (void);

#endif
