#include "file_editor.h"


void init_entry (int menu, GtkWidget *text)
{
  GdkFont *Title;
  GdkFont *normal;
  GdkFont *special;
  FILE    *fp;

  Title   = gdk_font_load("-adobe-helvetica-bold-r-narrow--17-164-75-75-p-79-iso8859-1");
  normal  = gdk_font_load("-Adobe-Helvetica-Medium-R-Normal--14-140-75-75-P-77-ISO8859-1");
  special = gdk_font_load("-adobe-helvetica-medium-i-normal--14-135-75-75-p-77-iso8859-1");
  switch (menu)
    {
    case 0:
      if ((fp = fopen("edit_file_menu_help.hlp", "r")) == NULL)
	{
	  gtk_text_insert (GTK_TEXT(text), special, NULL, NULL, ERR_FILE_HELP, strlen(ERR_FILE_HELP));
	  break;
	}
      read_help_file (fp, text,Title, normal, special);
      break;
    case 1:
      if ((fp = fopen("edit_color_menu_help.hlp", "r")) == NULL)
	{
	  gtk_text_insert (GTK_TEXT(text), special, NULL, NULL, ERR_COLOR_HELP, strlen(ERR_COLOR_HELP));
	  break;
	}
      read_help_file (fp, text,Title, normal, special);
      break;
    case 2:
      if ((fp = fopen("edit_font_menu_help.hlp", "r")) == NULL)
	{
	  gtk_text_insert (GTK_TEXT(text), special, NULL, NULL, ERR_FONT_HELP, strlen(ERR_FONT_HELP));
	  break;
	}
      read_help_file (fp, text,Title, normal, special);
      break;
    case 3:
      if ((fp = fopen("edit_inter_menu_help.hlp", "r")) == NULL)
	{
	  gtk_text_insert (GTK_TEXT(text), special, NULL, NULL, ERR_INTER_HELP, strlen(ERR_INTER_HELP));
	  break;
	}
      read_help_file (fp, text,Title, normal, special);
      break;
    case 4:
      if ((fp = fopen("edit_accel_menu_help.hlp", "r")) == NULL)
	{
	  gtk_text_insert (GTK_TEXT(text), special, NULL, NULL, ERR_ACCEL_HELP, strlen(ERR_ACCEL_HELP));
	  break;
	}
      read_help_file (fp, text,Title, normal, special);
      break;
    case 5:
      if ((fp = fopen("know_bugs.hlp", "r")) == NULL)
	{
	  gtk_text_insert (GTK_TEXT(text), special, NULL, NULL, ERR_BUG_HELP, strlen(ERR_BUG_HELP));
	  break;
	}
      read_help_file (fp, text,Title, normal, special);
      break;
    }
}

void SetHelpFile (GtkWidget *window, int menu, GtkWidget *text, char *title, char *entry_text)
{
  gtk_window_set_title (GTK_WINDOW(window), title);
  gtk_entry_set_text (GTK_ENTRY(entry), entry_text);
  init_entry(menu, text);
}

void HelpFile (GtkWidget *widget, int menu)
{
  GtkWidget *window;
  GtkWidget *text;
  GtkWidget *vscr;

  window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_signal_connect_object (GTK_OBJECT(window), "destroy", (GtkSignalFunc)gtk_widget_destroy, GTK_OBJECT(window));
  gtk_widget_set_usize(window, 600, 300);
  gtk_container_set_border_width(GTK_CONTAINER(window), 5);
  gtk_window_set_policy (GTK_WINDOW(window), 0, 0, 0);
  vscr = gtk_scrolled_window_new(NULL, NULL);
  gtk_container_add (GTK_CONTAINER(window), vscr);
  gtk_widget_set_events(window, GDK_KEY_PRESS_MASK);
  text = gtk_text_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER(vscr), text);
  switch (menu)
    {
    case 0: 
      SetHelpFile (window, menu, text, HELP_FILE, ENTRY_FILE);
      break;
    case 1:
      SetHelpFile (window, menu, text, HELP_COLOR, ENTRY_COLOR);
      break;
    case 2:
      SetHelpFile (window, menu, text, HELP_FONT, ENTRY_FONT);
      break;
    case 3:
      SetHelpFile (window, menu, text, HELP_INTER, ENTRY_INTER);
      break;
    case 4:
      SetHelpFile (window, menu, text, HELP_ACCEL, ENTRY_ACCEL);
      break;
    case 5:
      SetHelpFile (window, menu, text, HELP_BUG, ENTRY_BUG);
      break;
    }
  gtk_signal_connect(GTK_OBJECT(window), "event",
                     GTK_SIGNAL_FUNC(EditorEventHelp), NULL);
  gtk_widget_show_all (window);
}

void ListBug (void)
{
  GtkWidget *widget;
  int bug = 5;

  HelpFile (widget, bug);
}

void ButtonHelpMaker (GtkWidget *table, GtkWidget *window, char *title,
		      int elt, int x_min, int x_max, int y_min, int y_max)
{
  GtkWidget *button;

  button = gtk_button_new_with_label (title);
  gtk_signal_connect (GTK_OBJECT(button), "clicked", (GtkSignalFunc)HelpFile,(int *) elt);
  gtk_signal_connect_object (GTK_OBJECT(button), "clicked", (GtkSignalFunc)gtk_widget_destroy, GTK_OBJECT(window));
  gtk_widget_set_usize(button, 150, 30);
  gtk_table_attach (GTK_TABLE(table), button, x_min, x_max, y_min, y_max, GTK_SHRINK, GTK_SHRINK, 0, 1);
}

void HelpEdit (void)
{
  GtkWidget *window;
  GtkWidget *table;
  GtkWidget *button;
  int       file  = 0;
  int       color = 1;
  int       font  = 2;
  int       inter = 3;
  int       accel = 4;

  window = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW(window), "Help on Edit...");
  gtk_container_set_border_width(GTK_CONTAINER(window), 15);
  gtk_window_set_policy (GTK_WINDOW(window), 0, 0, 0);

  table = gtk_table_new(6, 1, FALSE);
  gtk_container_add (GTK_CONTAINER(window), table);
  
  ButtonHelpMaker (table, window, BUTTON_FILE, file, 0, 1, 0, 1); 
  ButtonHelpMaker (table, window, BUTTON_COLOR, color, 0, 1, 1, 2);
  ButtonHelpMaker (table, window, BUTTON_FONT, font, 0, 1, 2, 3);
  ButtonHelpMaker (table, window, BUTTON_INTER, inter, 0, 1, 3, 4); 
  ButtonHelpMaker (table, window, BUTTON_ACCEL, accel, 0, 1, 4, 5);
  button = gtk_button_new_with_label (" Quit Help ");
  gtk_signal_connect_object (GTK_OBJECT(button), "clicked", (GtkSignalFunc)gtk_widget_destroy, GTK_OBJECT(window));
  gtk_widget_set_usize(button, 150, 30);
  gtk_table_attach (GTK_TABLE(table), button, 0, 1, 5, 6, GTK_SHRINK, GTK_SHRINK, 0, 0);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);

  gtk_widget_show_all (window);
}









