#include "file_editor.h"

/* table of color for the propertu of the editor */
//GdkColor color_tab [12] = {
//  { 0, 00000, 00000, 65535},
//  { 0, 35328, 41472, 59904}, /* light_blue */
//  { 0, 00000, 65535, 65535}, /* turquoise */
//  { 0, 65535, 00000, 00000}, /* red */
//  { 0, 64512, 31488, 37120}, /* rose */
//  { 0, 00000, 65535, 00000}, /* green */
//  { 0, 31744, 57856, 45824}, /* light_green */
//  { 0, 65535, 00000, 65535}, /* violet */
//  { 0, 65535, 65535, 00000}, /* yellow */
//  { 0, 63232, 42240, 00512}, /* orange */
//  { 0, 39321, 39321, 39321}, /* gray */
//  { 0, 00000, 00000, 00000}  /* black */
//};



void SetColors(void)
{
  color_tab[11]=xmlconf_get_color(0);
  color_tab[3]=xmlconf_get_color(1);
  color_tab[0]=xmlconf_get_color(2);
  color_tab[1]=xmlconf_get_color(3);
  color_tab[2]=xmlconf_get_color(4);
  color_tab[5]=xmlconf_get_color(5);
  color_tab[6]=xmlconf_get_color(6);
  color_tab[9]=xmlconf_get_color(7);
  color_tab[8]=xmlconf_get_color(8);
  color_tab[10]=xmlconf_get_color(9);
  color_tab[7]=xmlconf_get_color(10);
  color_tab[4]=xmlconf_get_color(11);
}

void MakeInterface(void)
{
  GtkWidget        *window;
  GtkWidget        *Scr;
  GtkWidget        *menu;
  GtkWidget        *SubMenu;
  GtkWidget        *menu_items;
  GtkWidget        *FileMenu;
  GtkWidget        *table;
  GtkEditorScanner *scanner;
  int default_p        = 0;
  int comment_p        = 1;
  int include_p        = 2;
  int declare_p        = 3;
  int base_p           = 4;
  int objet_p          = 5;
  int operation_p      = 6;
  int texture_p        = 7;
  int transformation_p = 8;
  int constant_p       = 9;
  int operator_p       = 10;
  int separator_p      = 11;

  SetColors();

  /* load the font for the editor */
  font = gdk_font_load("-adobe-helvetica-bold-r-narrow--17-0-75-75-p-74-iso8859-1");

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width(GTK_CONTAINER(window), 8);
  gtk_window_set_title(GTK_WINDOW(window), "Rsultat du parsage");
  gtk_signal_connect_object(GTK_OBJECT(window), "delete_event",
		     (GtkSignalFunc)gtk_widget_destroy, GTK_OBJECT(window));
  gtk_signal_connect_object(GTK_OBJECT(window), "destroy",
		     (GtkSignalFunc)gtk_widget_destroy, GTK_OBJECT(window));
  /* creat a table*/
  table = gtk_table_new (2, 1, FALSE);
  gtk_container_add(GTK_CONTAINER(window), table);
  /* add a scrollwindow */
  Scr = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_set_usize(Scr, 600, 400);
  gtk_table_attach(GTK_TABLE(table), Scr, 0, 1, 0, 1, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, 0, 0);
  /* add the editor */
  editor = gtk_editor_new(NULL, NULL);
  gtk_container_add(GTK_CONTAINER(Scr), editor);
  gtk_text_set_editable(GTK_TEXT(editor), TRUE);
  /* load the scanner ~/.gtkeditor/scanners/pov-scanner.pov */
  scanner = gtk_editor_load_scanner ("pov-scanner");
  gtk_editor_install_scanner ((GtkEditor *)editor, scanner);
  /* set the property of the editor */
  gtk_editor_set_pattern_property((GtkEditor *)editor, "default",        font, color_tab[11], NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "comment",        font, color_tab[3],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "include",        font, color_tab[0],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "declare",        font, color_tab[1],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "base",           font, color_tab[2],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "objet",          font, color_tab[5],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "operation",      font, color_tab[6],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "texture",        font, color_tab[9],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "transformation", font, color_tab[8],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "constant",       font, color_tab[10], NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "operator",       font, color_tab[7],  NULL);
  gtk_editor_set_pattern_property((GtkEditor *)editor, "separator",      font, color_tab[4],  NULL);
  /* set the mask of event */
  gtk_widget_set_events(window, GDK_BUTTON_PRESS_MASK | GDK_KEY_PRESS_MASK);
  /* create a menu */
  menu = gtk_menu_new();
  /* the submenu */
  SubMenu = gtk_menu_new();
  /* create the first item */ 
  menu_items = gtk_menu_item_new_with_label("Open POV");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
                            GTK_SIGNAL_FUNC(OpenFunc), NULL);
  gtk_widget_show(menu_items);

  menu_items = gtk_menu_item_new_with_label("Save POV");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(OpenFunc2), NULL);
  gtk_widget_show(menu_items);
  /* separator */
  menu_items = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("Close POV Edit");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(window));
  gtk_widget_show(menu_items);
  menu_items = gtk_tearoff_menu_item_new ();
  gtk_widget_show(menu_items);
  gtk_menu_append(GTK_MENU(menu), menu_items);
  FileMenu = gtk_menu_item_new_with_label("Files");
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(FileMenu), SubMenu);
  gtk_widget_show(FileMenu);
  gtk_menu_append(GTK_MENU(menu), FileMenu);
  /* end of the first item */
  /* create the second item */
  SubMenu = gtk_menu_new();
  menu_items = gtk_menu_item_new_with_label("default");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
		     GTK_SIGNAL_FUNC(ChangeColor), (int *)default_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("comment");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)comment_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("include");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)include_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("declare");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)declare_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("base");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)base_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("objet");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)objet_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("operation");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)operation_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("texture");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)texture_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("transformation");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)transformation_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("constant");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)constant_p);
  gtk_widget_show(menu_items);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("operator");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)operator_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("separator");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeColor), (int *)separator_p);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("Save syntaxe color");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(SaveColorSyntaxe), NULL);
  gtk_widget_show(menu_items);
  FileMenu = gtk_menu_item_new_with_label("Colors");
  gtk_widget_show(FileMenu);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(FileMenu), SubMenu);
  gtk_menu_append(GTK_MENU(menu), FileMenu);
  /* end of the second item */
  /* start of the third item */
  SubMenu = gtk_menu_new();
  menu_items = gtk_menu_item_new_with_label("Choose new font");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ChangeFont), NULL);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new();
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("Save font type");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(SaveFontType), NULL);
  gtk_widget_show(menu_items);
  FileMenu = gtk_menu_item_new_with_label("Fonts");
  gtk_widget_show(FileMenu);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(FileMenu), SubMenu);
  gtk_menu_append(GTK_MENU(menu), FileMenu);
  /* end of the third item */
  /* start of the forth item */
  SubMenu = gtk_menu_new();
  menu_items = gtk_menu_item_new_with_label("Rendering");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(RenderPov), NULL);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("Option of render");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(OptionPov), NULL);
  gtk_widget_show(menu_items);
  FileMenu = gtk_menu_item_new_with_label("Renderer");
  gtk_widget_show(FileMenu);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(FileMenu), SubMenu);
  gtk_menu_append(GTK_MENU(menu), FileMenu);
  /* end of the forth item */
  /* start of the five item */
  SubMenu = gtk_menu_new();
  menu_items = gtk_menu_item_new_with_label("Rechercher mot...  ");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(GoToLigne2), NULL);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("aller  la ligne n...  ");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(GoToLigne), NULL);
  gtk_widget_show(menu_items);
  FileMenu = gtk_menu_item_new_with_label("Rechercher");
  gtk_widget_show(FileMenu);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(FileMenu), SubMenu);
  gtk_menu_append(GTK_MENU(menu), FileMenu);
  /* end of the five item */
  /* start of the six item */
  SubMenu = gtk_menu_new();

  menu_items = gtk_menu_item_new_with_label("help on edit...");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(HelpEdit), NULL);
  gtk_widget_show(menu_items);
  menu_items = gtk_menu_item_new_with_label("Knows bug...");
  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
  gtk_signal_connect(GTK_OBJECT(menu_items), "activate",
                     GTK_SIGNAL_FUNC(ListBug), NULL);
  gtk_widget_show(menu_items);
  FileMenu = gtk_menu_item_new_with_label("Help");
  gtk_widget_show(FileMenu);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(FileMenu), SubMenu);
  gtk_menu_append(GTK_MENU(menu), FileMenu);
  /* end of the six item */
  gtk_signal_connect(GTK_OBJECT(window), "event",
                     GTK_SIGNAL_FUNC(EditorEvent), menu);
  /* entry of status */
  entry = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(table), entry, 0, 1, 1, 2, GTK_FILL | GTK_EXPAND, 0, 0, 0);
  gtk_entry_set_editable (GTK_ENTRY(entry), 0);
  pos = gtk_editable_get_position (GTK_EDITABLE(entry));
  gtk_widget_show_all(window);
  gtk_editor_hilite_buffer ((GtkEditor *)editor);
}



