#include "file_editor.h"

char *render_pov_display[3] = {"Display=on", "Display=off", "Display=on"};
char *render_output[3] = {"", "", "/tmp/"};
char *render_pov_format [3] = {".tga", ".png", ".tiff"};
char *render_pov_h[3] = {"+H120", "+H200", "+H240"};
char *render_pov_w[3] = {"+W160", "+W266", "+W320"};

void RenderPov (void)
{
  int pid;
  int status;
  GtkWidget *dialog;
  GtkWidget *label, *button;

  if (CURRENT_FILE[0] == '\0')
    {
      dialog = gtk_dialog_new();
      gtk_window_set_title (GTK_WINDOW(dialog), "Erreur de rendering");
      gtk_container_set_border_width(GTK_CONTAINER(dialog), 10);
      label = gtk_label_new("Aucun fichier POV ouvert, ou veuillez sauvegarder votre fichier");
      gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox),
		      label);
      button = gtk_button_new_with_label("Okay");
      gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->action_area),
			 button);
      gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
				 GTK_SIGNAL_FUNC (gtk_widget_destroy), (gpointer) dialog);
      gtk_widget_show_all (dialog);
      return;
    }
  if (fork() > 0)
    gtk_entry_set_text (GTK_ENTRY(entry), "Rendering is Finished");    
  else
    sleep(1), execlp ("x-povray", "x-povray",
		      "+I", CURRENT_FILE,
		      g_strconcat("Output_File_Name=",render_output[fichier_et_image], 
						   CURRENT_FILE,render_pov_format[format],0),
		      "Display=On",
		      render_pov_display[fichier_et_image],
		      render_pov_h[taille], 
		      render_pov_w[taille],
		      0), wait (42);
  if (-1 == (pid = wait(&status)))
    exit(1);
}

void SetSortie (GtkWidget *button, int which)
{
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
    fichier_et_image = which;
}

void SetFormat (GtkWidget *button, int which)
{
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
    format = which;
}

void SetTaille (GtkWidget *button, int which)
{
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)))
    taille = which;
}

void OptionPov (void)
{
  GtkWidget *window;
  GtkWidget *label;
  GtkWidget *separator;
  GtkWidget *button;
  GtkWidget *vbox;
  GtkWidget *hbox;
  GSList    *group;
  
  gtk_entry_set_text (GTK_ENTRY(entry), "Vous tes dans l'option du renderer (chap pour quitter)");

  window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW(window), "Option de rendering");
  gtk_signal_connect(GTK_OBJECT(window), "destroy",
		     (GtkSignalFunc)SaveRender, NULL);
  gtk_signal_connect(GTK_OBJECT(window), "destroy",
		     (GtkSignalFunc)gtk_widget_destroy, window);
  gtk_container_set_border_width (GTK_CONTAINER (window), 5);

  hbox = gtk_hbox_new (0, 0);
  gtk_container_add (GTK_CONTAINER(window), hbox);

  vbox = gtk_vbox_new (0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, 0, 0, 0);

  label = gtk_label_new ("Sortie Rendering:");
  gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox), separator, 0, 0, 5);

  button = gtk_radio_button_new_with_label (NULL, "Fichier+Image");
  if (fichier_et_image == 0)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetSortie, (int *)0);  
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
  button = gtk_radio_button_new_with_label(group, "Fichier");
  if (fichier_et_image == 1)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetSortie, (int *)1);  
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  button = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (button)),
					   "Image");
  if (fichier_et_image == 2)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetSortie, (int *)2);  
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  separator = gtk_vseparator_new ();
  gtk_box_pack_start (GTK_BOX (hbox), separator, 0, 0, 0);

  vbox = gtk_vbox_new (0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, 0, 0, 0);

  label = gtk_label_new ("Format de fichier:");
  gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox), separator, 0, 0, 5);

  button = gtk_radio_button_new_with_label (NULL, "*.tga");
  if (format == 0)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetFormat, (int *)0);  
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
  button = gtk_radio_button_new_with_label(group, "*.png");
  if (format == 1)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetFormat, (int *)1);  
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  button = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (button)),
					   "*.tiff");
  if (format == 2)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetFormat, (int *)2);  
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  separator = gtk_vseparator_new ();
  gtk_box_pack_start (GTK_BOX (hbox), separator, 0, 0, 0);

  vbox = gtk_vbox_new (0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, 0, 0, 0);

  label = gtk_label_new ("Taille du rendu");
  gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, TRUE, 0);
  separator = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (vbox), separator, 0, 0, 5);

  button = gtk_radio_button_new_with_label (NULL, "H:120 W:160");
  if (taille == 0)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetTaille, (int *)0);  
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  group = gtk_radio_button_group (GTK_RADIO_BUTTON (button));
  button = gtk_radio_button_new_with_label(group, "H:200 W:266");
  if (taille == 1)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetTaille, (int *)1);  
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  button = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (button)),
					   "H:240 W:320");
  if (taille == 2)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     (GtkSignalFunc)SetTaille, (int *)2);  
  gtk_box_pack_start (GTK_BOX (vbox), button, TRUE, TRUE, 0);

  gtk_widget_show_all (window);
  
  gtk_signal_connect(GTK_OBJECT(window), "event",
                     GTK_SIGNAL_FUNC(EditorEventHelp), window);
}


