/* start condition definitions */
%x STRING

/* pattern definitions */
D			[0-9]
L			[a-zA-Z_]
H			[a-fA-F0-9]
E			[Ee][+-]?{D}+
FS			(f|F|l|L)
IS			(u|U|l|L)*

%%
 /* patterns */
"/*"           BEGIN_BLOCK("comment", 0, FALSE);
"*/"           END_BLOCK("comment");
\"             BEGIN_BLOCK("string", 0, FALSE); BEGIN(STRING);

<STRING>{
  \\\n         /* continued string */
  \n           END_BLOCK("string"); BEGIN(INITIAL);
  \\.          |
  \\[0-7]{1,3} TOKEN("escape_char", 0);
  \"           END_BLOCK("string"); BEGIN(INITIAL);
  .
}


^[ \t]*#[ \t]*include[ \t]*((\"[^<>\n]*\"?)|("<"[^\"\n]*">"?)) TOKEN("include", 0);

^[ \t]*#[ \t]*(declare) TOKEN("declare", 0);


"background"   |
"camera"       |
"light_source"          TOKEN("base", 0); 
	
"box"      |
"cone"     |
"cylinder" |
"sphere"                TOKEN("objet", 0);

"merge"        |
"union"        |
"difference"   |
"intersection"          TOKEN("operation", 0);

"pigment"   |
"texture"   |
"color"                 TOKEN("texture", 0); 
	
"*x"        |
"*y"        |
"*z"        | 
"scale"     |
"rotate"    |
"translate"             TOKEN("transformation", 0);

{L}({L}|{D})*		/* identifier ignore */

0[xX]{H}+{IS}?		|
0{D}+{IS}?		|
{D}+{IS}?		|
'(\\.|[^\\'])+'		|

{D}+{E}{FS}?		|
{D}*"."{D}+({E})?{FS}?	|
{D}+"."{D}*({E})?{FS}?	TOKEN("constant", 0);	


"-" |
"+" |
"*" |
"/" |
"%" |
"<" |
">" |
"="                     TOKEN("operator", 0);

"{" |
"}" |
"(" |
")" |
"[" |
"]"                     TOKEN("separator", 0); 

"."
","
":"
";" 
	
[ \t\v\n\f]		
.	     /* ignore bad characters */