#include "headers.h"

void DrawViewCAMfromTreeSelect(xmlNodePtr ptr)
{
  T_obj *obj = (T_obj *)ptr->ns;
  
  draw_scene_on_viewCAM(obj, GL_SELECT);
}

void DrawViewCAMfromTreeRender(xmlNodePtr ptr)
{
  T_obj *obj;
  
  obj=(T_obj *)ptr->ns;
  draw_scene_on_viewCAM(obj, GL_RENDER);
}

void DrawViewXZfromTreeSelect(xmlNodePtr ptr)
{
  T_obj *obj = (T_obj *)ptr->ns;
  
  draw_scene_on_viewXZ(obj, GL_SELECT);
}

void DrawViewXZfromTreeRender(xmlNodePtr ptr)
{
  T_obj *obj = (T_obj *)ptr->ns;
  
  draw_scene_on_viewXZ(obj, GL_RENDER);
}

void DrawViewXYfromTreeSelect(xmlNodePtr ptr)
{
  T_obj *obj = (T_obj *)ptr->ns;
  
  draw_scene_on_viewXY(obj, GL_SELECT);
}

void DrawViewXYfromTreeRender(xmlNodePtr ptr)
{
  T_obj *obj=NULL;
  
  obj = (T_obj *)ptr->ns;
  draw_scene_on_viewXY(obj, GL_RENDER);
}

void DrawViewYZfromTreeSelect(xmlNodePtr ptr)
{
  T_obj *obj = (T_obj *)ptr->ns;
  
  draw_scene_on_viewYZ(obj, GL_SELECT);
}

void DrawViewYZfromTreeRender(xmlNodePtr ptr)
{
  T_obj *obj = (T_obj *)ptr->ns;
  
  draw_scene_on_viewYZ(obj, GL_RENDER);
}


void BuildTreePrimitive(xmlNodePtr ptr)
{
  T_obj		*obj;
  VECT3D	*pt1;
  VECT3D	*pt2;
  VECT3D	*temp;
  int		open;
  int		i;
  printf("%s\n",xmlGetProp(ptr, "type"));
  switch (str2nodetype(xmlGetProp(ptr, "type")))
    {
    case NOD_CUBE:
      pt1 = xml_cube_get_point1(ptr);
      pt2 = xml_cube_get_point2(ptr);
      obj  = make_MeshTriangleBox(pt1, pt2);
      obj->prop_base->id = global_id_obj++;
      if (ptr->childs->next)
	{
	  if (!strcmp(ptr->childs->next->name, "TRANSFORM"))
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs,"value"));
	      obj->prop_base->translate->x = temp->x;
	      obj->prop_base->translate->y = temp->y;
	      obj->prop_base->translate->z = temp->z;
	    
	      temp=str2vect3d(xmlGetProp(ptr->childs->next->childs->next,"value"));
	      obj->prop_base->rotate->x = temp->x;
	      obj->prop_base->rotate->y = temp->y;
	      obj->prop_base->rotate->z = temp->z;
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs->next->next,"value"));
	      obj->prop_base->scale->x = temp->x;
	      obj->prop_base->scale->y = temp->y;
	      obj->prop_base->scale->z = temp->z;
	    }
      
	  if (ptr->childs->next->next)
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->next,"value"));
	      for (i = 0; i < obj->prop_base->nb_face; i++)
		{
		  obj->prop_base->color[i].x = temp->x;
		  obj->prop_base->color[i].y = temp->y;
		  obj->prop_base->color[i].z = temp->z;
		}
	    }
	}
      puts("m");
      ptr->ns = (xmlNs *)obj;
      break;
    case NOD_CONE:
      pt1 = xml_cone_get_center1(ptr);
      pt2 = xml_cone_get_center2(ptr);
      open = xml_cone_get_open(ptr);
      obj = make_MeshTriangleCone(pt1,
				  xml_cone_get_radius1(ptr),
				  open,
				  pt2,
				  xml_cone_get_radius2(ptr),
				  open,
				  open);
      obj->prop_base->id = global_id_obj++;
      if (ptr->childs->next)
	{
	  if (!strcmp(ptr->childs->next->name, "TRANSFORM"))
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs,"value"));
	      obj->prop_base->translate->x = temp->x;
	      obj->prop_base->translate->y = temp->y;
	      obj->prop_base->translate->z = temp->z;
	    
	      temp=str2vect3d(xmlGetProp(ptr->childs->next->childs->next,"value"));
	      obj->prop_base->rotate->x = temp->x;
	      obj->prop_base->rotate->y = temp->y;
	      obj->prop_base->rotate->z = temp->z;
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs->next->next,"value"));
	      obj->prop_base->scale->x = temp->x;
	      obj->prop_base->scale->y = temp->y;
	      obj->prop_base->scale->z = temp->z;
	    }
      
	  if (ptr->childs->next->next)
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->next,"value"));
	      for (i = 0; i < obj->prop_base->nb_face; i++)
		{
		  obj->prop_base->color[i].x = temp->x;
		  obj->prop_base->color[i].y = temp->y;
		  obj->prop_base->color[i].z = temp->z;
		}
	    }
	}

      ptr->ns = (xmlNs *)obj;
      break;
    case NOD_CYLINDRE:
      pt1 = xml_cone_get_center1(ptr);
      pt2 = xml_cone_get_center2(ptr);
      open = xml_cone_get_open(ptr);
      obj = make_MeshTriangleCone(pt1,
				  xml_cone_get_radius1(ptr),
				  open,
				  pt2,
				  xml_cone_get_radius1(ptr),
				  open,
				  open);
      obj->prop_base->id = global_id_obj++;
      if (ptr->childs->next)
	{
	  if (!strcmp(ptr->childs->next->name, "TRANSFORM"))
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs,"value"));
	      obj->prop_base->translate->x = temp->x;
	      obj->prop_base->translate->y = temp->y;
	      obj->prop_base->translate->z = temp->z;
	    
	      temp=str2vect3d(xmlGetProp(ptr->childs->next->childs->next,"value"));
	      obj->prop_base->rotate->x = temp->x;
	      obj->prop_base->rotate->y = temp->y;
	      obj->prop_base->rotate->z = temp->z;
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs->next->next,"value"));
	      obj->prop_base->scale->x = temp->x;
	      obj->prop_base->scale->y = temp->y;
	      obj->prop_base->scale->z = temp->z;
	    }
      
	  if (ptr->childs->next->next)
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->next,"value"));
	      for (i = 0; i < obj->prop_base->nb_face; i++)
		{
		  obj->prop_base->color[i].x = temp->x;
		  obj->prop_base->color[i].y = temp->y;
		  obj->prop_base->color[i].z = temp->z;
		}
	    }
	}

      ptr->ns = (xmlNs *)obj;
      break;
    case NOD_SPHERE:
      pt1 = xml_sphere_get_center(ptr);
      obj = make_MeshTriangleSphere(pt1, xml_sphere_get_radius(ptr));
      obj->prop_base->id = global_id_obj++;
      if (ptr->childs->next)
	{
	  if (!strcmp(ptr->childs->next->name, "TRANSFORM"))
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs,"value"));
	      obj->prop_base->translate->x = temp->x;
	      obj->prop_base->translate->y = temp->y;
	      obj->prop_base->translate->z = temp->z;
	    
	      temp=str2vect3d(xmlGetProp(ptr->childs->next->childs->next,"value"));
	      obj->prop_base->rotate->x = temp->x;
	      obj->prop_base->rotate->y = temp->y;
	      obj->prop_base->rotate->z = temp->z;
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs->next->next,"value"));
	      obj->prop_base->scale->x = temp->x;
	      obj->prop_base->scale->y = temp->y;
	      obj->prop_base->scale->z = temp->z;
	    }
      
	  if (ptr->childs->next->next)
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->next,"value"));
	      for (i = 0; i < obj->prop_base->nb_face; i++)
		{
		  obj->prop_base->color[i].x = temp->x;
		  obj->prop_base->color[i].y = temp->y;
		  obj->prop_base->color[i].z = temp->z;
		}
	    }
	}

      ptr->ns = (xmlNs *)obj;
      break;
    case NOD_TORUS:
      pt1 = (VECT3D *)malloc(sizeof(VECT3D));
      pt1->x = 0;
      pt1->y = 0;
      pt1->z = 0;
      obj = make_MeshTriangleTorus(pt1,
				   xml_torus_get_minor(ptr),
				   xml_torus_get_major(ptr));
      obj->prop_base->id = global_id_obj++;
      if (ptr->childs->next)
	{
	  if (!strcmp(ptr->childs->next->name, "TRANSFORM"))
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs,"value"));
	      obj->prop_base->translate->x = temp->x;
	      obj->prop_base->translate->y = temp->y;
	      obj->prop_base->translate->z = temp->z;
	    
	      temp=str2vect3d(xmlGetProp(ptr->childs->next->childs->next,"value"));
	      obj->prop_base->rotate->x = temp->x;
	      obj->prop_base->rotate->y = temp->y;
	      obj->prop_base->rotate->z = temp->z;
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs->next->next,"value"));
	      obj->prop_base->scale->x = temp->x;
	      obj->prop_base->scale->y = temp->y;
	      obj->prop_base->scale->z = temp->z;
	    }
      
	  if (ptr->childs->next->next)
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->next,"value"));
	      for (i = 0; i < obj->prop_base->nb_face; i++)
		{
		  obj->prop_base->color[i].x = temp->x;
		  obj->prop_base->color[i].y = temp->y;
		  obj->prop_base->color[i].z = temp->z;
		}
	    }
	}
      ptr->ns = (xmlNs *)obj;
      break;
    case NOD_PLANE:
      pt1 = xml_plane_get_normal(ptr->childs);
      pt2 = (VECT3D *)malloc(sizeof(VECT3D));
      pt2->x = 0;
      pt2->y = xml_plane_get_offset(ptr->childs);
      pt2->z = 0;
      obj = make_MeshTrianglePlane(pt1, pt2);
      obj->prop_base->id = global_id_obj++;
      if (ptr->childs->next)
	{
	  if (!strcmp(ptr->childs->next->name, "TRANSFORM"))
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs,"value"));
	      obj->prop_base->translate->x = temp->x;
	      obj->prop_base->translate->y = temp->y;
	      obj->prop_base->translate->z = temp->z;
	    
	      temp=str2vect3d(xmlGetProp(ptr->childs->next->childs->next,"value"));
	      obj->prop_base->rotate->x = temp->x;
	      obj->prop_base->rotate->y = temp->y;
	      obj->prop_base->rotate->z = temp->z;
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->childs->next->next,"value"));
	      obj->prop_base->scale->x = temp->x;
	      obj->prop_base->scale->y = temp->y;
	      obj->prop_base->scale->z = temp->z;
	    }
      
	  if (ptr->childs->next->next)
	    {
	      temp = str2vect3d(xmlGetProp(ptr->childs->next->next,"value"));
	      for (i = 0; i < obj->prop_base->nb_face; i++)
		{
		  obj->prop_base->color[i].x = temp->x;
		  obj->prop_base->color[i].y = temp->y;
		  obj->prop_base->color[i].z = temp->z;
		}
	    }
	}
      ptr->ns = (xmlNs *)obj;
      break;
    default:
      xmlUnlinkNode(ptr);
      return;
    }
}

void ChangeIdObjSel(xmlNodePtr treeptr)
{
  T_obj *obj = (T_obj *)treeptr->ns;

  if (current_id == obj->prop_base->id)
    obj->prop_base->is_selected = !obj->prop_base->is_selected;
}

int parse_level(xmlNodePtr tree, void(*func)(xmlNodePtr))
{
  if (tree == NULL) 
    return 1;
  func(tree);
  parse_level(tree->next,func);
  return 0;
}

int parse_level1(xmlNodePtr tree, void(*func)(xmlNodePtr))
{
  if (tree == NULL) 
    return 1;
  parse_level(tree->childs, func);
  return 0;
}


GList	*ParseGetSelectedObject(xmlNodePtr tree)
{
  T_obj		*obj;
  GList		*list;
  
  if (tree == NULL)
    return NULL;
  obj = (T_obj *)tree->ns;
  list = ParseGetSelectedObject(tree->next);
  if (obj->prop_base->is_selected)
    return g_list_append(list, (gpointer)obj);
  else
    return list;
}

t_list_obj_select *GetSelectedObject(xmlNodePtr tree)
{
  t_list_obj_select *obj_select;
  GList *list;
  int i;
  
  obj_select = (t_list_obj_select *)malloc(sizeof(t_list_obj_select));
  if (tree->childs == NULL) 
    return NULL;
  list = ParseGetSelectedObject(tree->childs);
  obj_select->size = g_list_length(list);
  obj_select->mem_obj = (T_obj **)malloc(sizeof(T_obj *) * obj_select->size);
  for (i = 0; i < g_list_length(list); i++)
    obj_select->mem_obj[i] = (T_obj *)((g_list_nth(list, i))->data);
  return obj_select;
}




void	expandtreeGL(void)
{
  parse_level1(gl_scene->root, BuildTreePrimitive);
}

