#include "headers.h"

gboolean DialogBoxBox(GtkWidget *widget, struct s_properties *prop)
{
  VECT3D MinCorner;
  VECT3D MaxCorner;
  xmlNodePtr node;
  T_obj *obj;


  if (!is_good_entry(prop))
    {
      quick_message("There is a bad value");
      on_cancel_prop(prop);
      return FALSE;
    }
    else
    {
      MinCorner.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[0])));
      MinCorner.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[1])));
      MinCorner.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[2])));
      MaxCorner.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[3])));
      MaxCorner.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[4])));
      MaxCorner.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[5])));
      node = xml_cube_new(&MinCorner, &MaxCorner);
      xmlAddChild(gl_scene->root, node);
      obj = make_MeshTriangleBox(&MinCorner, &MaxCorner);
      obj->prop_base->id = global_id_obj++;
      node->ns = (xmlNs *)obj;
      if (open_windows.vu3d_b) 
	gtk_widget_queue_draw(glarea_CAM);
      if (open_windows.face_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
    }
  on_cancel_prop(prop);
  return TRUE;
}

gboolean DialogBoxCone(GtkWidget *widget, struct s_properties *prop)
{
  VECT3D C1;
  VECT3D C2;
  float vradius;
  float mradius;
  T_obj	*obj;
  xmlNodePtr node;
    
  if (!is_good_entry(prop))
    {
      quick_message("There is a bad value");
      on_cancel_prop(prop);
      return FALSE;
    }
    else
    {
      C1.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[0])));
      C1.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[1])));
      C1.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[2])));
      C2.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[4])));
      C2.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[5])));
      C2.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[6])));
      vradius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[3])));
      mradius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[7])));
      node = xml_cone_new(&C1, vradius, &C2, mradius, 0);
      xmlAddChild(gl_scene->root, node);
      obj = make_MeshTriangleCone(&C1, vradius, 0, &C2, mradius, 0, 0);
      obj->prop_base->id = global_id_obj++;
      node->ns = (xmlNs *)obj;
      if (open_windows.vu3d_b) 
	gtk_widget_queue_draw(glarea_CAM);
      if (open_windows.face_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
    }
  on_cancel_prop(prop);
  return TRUE;
}

gboolean DialogBoxCylindre(GtkWidget *widget, struct s_properties *prop)
{
  VECT3D C1;
  VECT3D C2;
  float radius;
  T_obj *obj;
  xmlNodePtr node;
  
  if (!is_good_entry(prop))
    {
      quick_message("There is a bad value");
      on_cancel_prop(prop);
      return FALSE;
    }
  else
    {
      C1.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[0])));
      C1.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[1])));
      C1.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[2])));
      C2.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[3])));
      C2.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[4])));
      C2.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[5])));
      radius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[6])));
      node = xml_cone_new(&C1, radius, &C2, radius, 0);
      xmlAddChild(gl_scene->root, node);
      obj = make_MeshTriangleCone(&C1, radius, 0, &C2, radius, 0, 0);
      obj->prop_base->id = global_id_obj++;
      node->ns = (xmlNs *)obj;
      if (open_windows.vu3d_b) 
	gtk_widget_queue_draw(glarea_CAM);
      if (open_windows.face_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
    }
  on_cancel_prop(prop);
  return TRUE;
}
gboolean DialogBoxSphere(GtkWidget *widget, struct s_properties *prop)
{
  VECT3D C1;
  float radius;
  T_obj *obj;
  xmlNodePtr node;
    
  if (!is_good_entry(prop))
    {
      quick_message("There is a bad value");
      on_cancel_prop(prop);
      return FALSE;
    }
  else
    {
      C1.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[0])));
      C1.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[1])));
      C1.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[2])));
      radius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[3])));
      node = xml_sphere_new(&C1, radius);
      xmlAddChild(gl_scene->root, node);
      obj = make_MeshTriangleSphere(&C1, radius);
      obj->prop_base->id = global_id_obj++;
      node->ns = (xmlNs *)obj;
      if (open_windows.vu3d_b) 
	gtk_widget_queue_draw(glarea_CAM);
      if (open_windows.face_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
    }
  on_cancel_prop(prop);
  return TRUE;
}

gboolean DialogBoxPlane(GtkWidget *widget, struct s_properties *prop)
{
  VECT3D B1;
  VECT3D P;
  T_obj *obj;
  xmlNodePtr node;

  if (!is_good_entry(prop))
    {
      quick_message("There is a bad value");
      on_cancel_prop(prop);
      return FALSE;
    }
    else
    {
      P.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[0])));
      P.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[1])));
      P.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[2])));
      B1.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[3])));
      B1.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[4])));
      B1.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[5])));
      node = xml_plane_new(&B1, P.y);
      xmlAddChild(gl_scene->root, node);
      obj->prop_base->id = global_id_obj++;
      obj = make_MeshTrianglePlane(&B1, &P);
      node->ns = (xmlNs *)obj;
      if (open_windows.vu3d_b) 
	gtk_widget_queue_draw(glarea_CAM);
      if (open_windows.face_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
    }
  on_cancel_prop(prop);
  return TRUE;
}

gboolean DialogBoxTorus(GtkWidget *widget, struct s_properties *prop)
{
  VECT3D C1;
  float MinorRadius;
  float MajorRadius;
  T_obj *obj;
  xmlNodePtr node;
  
  if (!is_good_entry(prop))
    {
      quick_message("There is a bad value");
      on_cancel_prop(prop);
      return FALSE;
    }
  else
    {
      C1.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[0])));
      C1.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[1])));
      C1.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[2])));
      MinorRadius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[3])));
      MajorRadius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[4])));
      node = xml_torus_new(MinorRadius, MajorRadius);
      xmlAddChild(gl_scene->root, node);
      obj = make_MeshTriangleTorus(&C1, MajorRadius, MinorRadius);
      obj->prop_base->id = global_id_obj++;
      node->ns = (xmlNs *)obj;
      if (open_windows.vu3d_b) 
	gtk_widget_queue_draw((GtkWidget *)glarea_CAM);
      if (open_windows.face_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
    }
  on_cancel_prop(prop);
  return TRUE;
}

gboolean DialogBoxTube(GtkWidget *widget, t_dialog_properties *prop)
{
  VECT3D C1;
  VECT3D C2;
  float radius;
  T_obj *obj;
  xmlNodePtr node;

  if (!is_good_entry(prop))
    {
      quick_message("There is a bad value");
      on_cancel_prop(prop);
      return FALSE;
    }
    else
    {
      C1.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[0])));
      C1.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[1])));
      C1.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[2])));
      C2.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[3])));
      C2.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[4])));
      C2.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[5])));
      radius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[6])));
      node = xml_cone_new(&C1, radius, &C2, radius, 1);
      xmlAddChild(gl_scene->root, node);
      obj->prop_base->id = global_id_obj++;
      obj = make_MeshTriangleCone(&C1, radius, 1, &C2, radius, 1, 1);
      node->ns = (xmlNs *)obj;
      if (open_windows.vu3d_b) 
	gtk_widget_queue_draw(glarea_CAM);
      if (open_windows.face_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
    }
  on_cancel_prop(prop);
  return TRUE;
}

gboolean DialogBoxOpenCone(GtkWidget *widget, struct s_properties *prop)
{
  VECT3D C1;
  VECT3D C2;
  float vradius;
  float mradius;
  T_obj	*obj;
  xmlNodePtr node;

  if (!is_good_entry(prop))
    {
      quick_message("There is a bad value");
      on_cancel_prop(prop);
      return FALSE;
    }
    else
    {
      C1.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[0])));
      C1.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[1])));
      C1.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[2])));
      C2.x = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[4])));
      C2.y = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[5])));
      C2.z = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[6])));
      vradius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[3])));
      mradius = atof(gtk_entry_get_text(GTK_ENTRY(prop->entry[7])));
      node = xml_cone_new(&C1, vradius, &C2, mradius, 1);
      xmlAddChild(gl_scene->root, node);
      obj = make_MeshTriangleCone(&C1, vradius, 1, &C2, mradius, 1, 1);
      obj->prop_base->id = global_id_obj++;
      node->ns = (xmlNs *)obj;
      if (open_windows.vu3d_b) 
	gtk_widget_queue_draw(glarea_CAM);
      if (open_windows.face_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
    }
  on_cancel_prop(prop);
  return TRUE;
}

int CreateBox(float x, float y, float z)
{
  t_dialog_properties	*prop;
  char			*label_text[]={"X1:", "Y1:", "Z1:", 
				       "X2:", "Y2:", "Z2:"};
  VECT3D MinCorner;
  VECT3D MaxCorner;
  
  MinCorner.x = -10;
  MinCorner.y = -25;
  MinCorner.z = -5;
  MaxCorner.x = 10;
  MaxCorner.y = 15;
  MaxCorner.z = 25;
  
  prop = (t_dialog_properties *)malloc(sizeof(t_dialog_properties));
  prop->window_title = g_strdup("BOX");
  prop->nb = 6;
  prop->label_text = label_text;
  prop->entry = (GtkWidget **)malloc(sizeof(GtkWidget *) * prop->nb);
  prop->value_entry = (float *)malloc(sizeof(float) * prop->nb);
  prop->value_entry[0] = 0;
  prop->value_entry[1] = 0;
  prop->value_entry[2] = 0;
  prop->value_entry[3] = x;
  prop->value_entry[4] = y;
  prop->value_entry[5] = z;
  prop->fcn = DialogBoxBox;

  /* we prepare an object torus for the properties dialog and we draw it */
  obj_prop = make_MeshTriangleBox(&MinCorner, &MaxCorner);
  PrepareIt(prop);
  return TRUE;
}

int CreateCone(float x, float y, float z)
{
  t_dialog_properties	*prop;
  char			*label_text[]={"center X1:", "center Y1:", "center Z1:", 
				       "radius 1:",
				       "center X2:", "center Y2:", "center Z2:",
				       "radius 2"};
  VECT3D C1;
  VECT3D C2;

  C1.x = 0;
  C1.y = -20;
  C1.z = 0;
  
  C2.x = 0;
  C2.y = 20;
  C2.z = 0;
  prop = (t_dialog_properties *)malloc(sizeof(t_dialog_properties));
  prop->window_title = g_strdup("CONE");
  prop->nb = 8;
  prop->label_text = label_text;
  prop->entry = (GtkWidget **)malloc(sizeof(GtkWidget *) * prop->nb);
  prop->value_entry = (float *)malloc(sizeof(float) * prop->nb);
  prop->value_entry[0] = 0;
  prop->value_entry[1] = 0;
  prop->value_entry[2] = 0;
  prop->value_entry[3] = 10;
  prop->value_entry[4] = x;
  prop->value_entry[5] = y;
  prop->value_entry[6] = z;
  prop->value_entry[7] = 20;
  prop->fcn = DialogBoxCone;

  /* we prepare an object torus for the properties dialog and we draw it */
  obj_prop = make_MeshTriangleCone(&C1, 10, 0, &C2, 20, 0, 0);
  PrepareIt(prop);
  return TRUE;
}

int CreateCylindre(float x, float y, float z)
{
  t_dialog_properties	*prop;
  char			*label_text[]={"center X1:", "center Y1:", "center Z1:", 
				       "center X2:", "center Y2:", "center Z2:",
				       "radius"};
  VECT3D C1;
  VECT3D C2;

  C1.x = 0;
  C1.y = -40;
  C1.z = 0;
  
  C2.x = 0;
  C2.y = 40;
  C2.z = 0;
  
  prop = (t_dialog_properties *)malloc(sizeof(t_dialog_properties));
  prop->window_title = g_strdup("CYLINDRE");
  prop->nb = 7;
  prop->label_text = label_text;
  prop->entry = (GtkWidget **)malloc(sizeof(GtkWidget *) * prop->nb);
  prop->value_entry = (float *)malloc(sizeof(float) * prop->nb);
  prop->value_entry[0] = 0;
  prop->value_entry[1] = 0;
  prop->value_entry[2] = 0;
  prop->value_entry[3] = x;
  prop->value_entry[4] = y;
  prop->value_entry[5] = z;
  prop->value_entry[6] = 10;
  prop->fcn = DialogBoxCylindre;

  obj_prop = make_MeshTriangleCone(&C1, 20, 0, &C2, 20, 0, 0);
  PrepareIt(prop);
  return TRUE;
}

int CreateSphere(float x, float y, float z)
{
  t_dialog_properties	*prop;
  char			*label_text[]={"Center X:", "Center Y:", "Center Z:", 
				       "radius:"};

  VECT3D P;

  P.x = 0;
  P.y = 0;
  P.z = 0;
  prop = (t_dialog_properties *)malloc(sizeof(t_dialog_properties));
  prop->window_title = g_strdup("SPHERE");
  prop->nb = 4;
  prop->label_text = label_text;
  prop->entry = (GtkWidget **)malloc(sizeof(GtkWidget *) * prop->nb);
  prop->value_entry = (float *)malloc(sizeof(float) * prop->nb);
  prop->value_entry[0] = x;
  prop->value_entry[1] = y;
  prop->value_entry[2] = z;
  prop->value_entry[3] = 30;
  prop->fcn = DialogBoxSphere;
  
  obj_prop = make_MeshTriangleSphere(&P, 30);
  PrepareIt(prop);
  return TRUE;
}

int CreatePlane(float x, float y, float z)
{
  t_dialog_properties	*prop;
  char			*label_text[]={"X:", "Y:", "Z:"
				       "Nx:", "Ny:", "Nz:"};
  VECT3D B1, P;

  P.x = 0;
  P.y = 0;
  P.z = 0;
  
  B1.x = 0;
  B1.y = 1;
  B1.z = 0;
  
  prop = (t_dialog_properties *)malloc(sizeof(t_dialog_properties));
  prop->window_title = g_strdup("PLANE");
  prop->nb = 6;
  prop->label_text = label_text;
  prop->entry = (GtkWidget **)malloc(sizeof(GtkWidget *) * prop->nb);
  prop->value_entry = (float *)malloc(sizeof(float) * prop->nb);
  prop->value_entry[0] = 0;
  prop->value_entry[1] = 0;
  prop->value_entry[2] = 0;
  prop->value_entry[3] = x;
  prop->value_entry[4] = y;
  prop->value_entry[5] = z;
  prop->fcn = DialogBoxPlane;
  obj_prop = make_MeshTrianglePlane(&B1, &P);
  PrepareIt(prop);
  return TRUE;
}

int CreateTorus(float x, float y, float z)
{
  t_dialog_properties	*prop;
  char			*label_text[]={"X:", "Y:", "Z:", "vradius:", "mradius:"};
  VECT3D C1;

  C1.x = 0;
  C1.y = 0;
  C1.z = 0;
  prop = (t_dialog_properties *)malloc(sizeof(t_dialog_properties));
  prop->window_title = g_strdup("TORUS");
  prop->nb = 5;
  prop->label_text = label_text;
  prop->entry = (GtkWidget **)malloc(sizeof(GtkWidget *) * prop->nb);
  prop->value_entry = (float *)malloc(sizeof(float) * prop->nb);
  prop->value_entry[0] = x;
  prop->value_entry[1] = y;
  prop->value_entry[2] = z;
  prop->value_entry[3] = 10;
  prop->value_entry[4] = 20;
  prop->fcn = DialogBoxTorus;

  /* we prepare an object torus for the properties dialog and we draw it */
  obj_prop = make_MeshTriangleTorus(&C1, 20, 10);
  PrepareIt(prop);
  return TRUE;
}

int CreateTube(float x, float y, float z)
{
  t_dialog_properties	*prop;
  char			*label_text[]={"X1:", "Y1:", "Z1:", 
				       "X2:", "Y2:", "Z2:",
				       "radius"};
  VECT3D C1;
  VECT3D C2;

  C1.x = 0;
  C1.y = -40;
  C1.z = 0;
  
  C2.x = 0;
  C2.y = 40;
  C2.z = 0;
  
  prop = (t_dialog_properties *)malloc(sizeof(t_dialog_properties));
  prop->window_title = g_strdup("TUBE");
  prop->nb = 7;
  prop->label_text = label_text;
  prop->entry = (GtkWidget **)malloc(sizeof(GtkWidget *) * prop->nb);
  prop->value_entry = (float *)malloc(sizeof(float) * prop->nb);
  prop->value_entry[0] = 0;
  prop->value_entry[1] = 0;
  prop->value_entry[2] = 0;
  prop->value_entry[3] = x;
  prop->value_entry[4] = y;
  prop->value_entry[5] = z;
  prop->value_entry[6] = 20;
  prop->fcn = DialogBoxTube;
  obj_prop = make_MeshTriangleCone(&C1, 20, 1, &C2, 20, 1, 1);
  PrepareIt(prop);
  return TRUE;
}

int CreateOpenCone(float x, float y, float z)
{
  t_dialog_properties	*prop;
  char			*label_text[]={"center X1:", "center Y1:", "center Z1:", 
				       "radius 1:",
				       "center X2:", "center Y2:", "center Z2:",
				       "radius 2"};
  VECT3D C1;
  VECT3D C2;

  C1.x = 0;
  C1.y = -40;
  C1.z = 0;
  
  C2.x = 0;
  C2.y = 40;
  C2.z = 0;
  
  prop = (t_dialog_properties *)malloc(sizeof(t_dialog_properties));
  prop->window_title = g_strdup("OPEN CONE");
  prop->nb = 8;
  prop->label_text = label_text;
  prop->entry = (GtkWidget **)malloc(sizeof(GtkWidget *) * prop->nb);
  prop->value_entry = (float *)malloc(sizeof(float) * prop->nb);
  prop->value_entry[0] = 0;
  prop->value_entry[1] = 0;
  prop->value_entry[2] = 0;
  prop->value_entry[3] = 10;
  prop->value_entry[4] = x;
  prop->value_entry[5] = y;
  prop->value_entry[6] = z;
  prop->value_entry[7] = 20;
  prop->fcn = DialogBoxOpenCone;
  obj_prop = make_MeshTriangleCone(&C1, 10, 1, &C2, 20, 1, 1);
  PrepareIt(prop);
  return TRUE;
}


/* function tools for creation of sor and his box properties */
t_menu_popup_sor	*menu_popup_on_sor[NB_MENU_ON_SOR];
t_features_menu		prop_menu_on_sor[NB_MENU_ON_SOR] ={{"Zoom", 2,},{"Point", 3, }};
int		count;
VECT3D		size;
T_pt_sor	*pt_sor;
GtkWidget	*lbl_X;
GtkWidget	*lbl_Y;
GtkWidget	*lbl_Zoom;
float		SorZoom = 2; /*No zoom for begin */
T_mode_tool_sor	mode_tool_sor;
int		nb_point_on_sor;
GList		*list_point_sor;
int		current_id_selected;

gint my_list_comp(gconstpointer a, gconstpointer b)
{
  T_pt_sor	*pt1 = (T_pt_sor *)a;
  T_pt_sor	*pt2 = (T_pt_sor *)b;
  
  if ((pt1->y - pt2->y) > 0)
    return 1;
  if ((pt1->y - pt2->y) == 0)
    return 0;
  if ((pt1->y - pt2->y) < 0)
    return -1;
  return 0;
}


T_pt_sor *ReadPointOnListSor(GList *list, int index_face)
{
  T_pt_sor	*point;
  GList		*current;

  current = g_list_nth(list, index_face);
  point = (T_pt_sor *)current->data;
  return point;
}

void draw_plots(GLenum mode)
{
  int i;
  float x1;
  float y1;
  T_pt_sor	*pt;

  for (i = 0; i < nb_point_on_sor ; i++)
    {
      pt = ReadPointOnListSor(list_point_sor, i);
      x1 = pt->x * SorZoom + SIZE_WIN_X/2;
      y1 = (pt->y * SorZoom) + SIZE_WIN_Y/2;
      glColor3f(0.0, 0.0, 0.0);
      if (mode == GL_SELECT)
	glLoadName(pt->id);
      glRectf(x1 - PT_OFFSET_X, y1 - PT_OFFSET_Y, 
	      x1 + PT_OFFSET_X, y1 + PT_OFFSET_Y);
    }
}

void draw_line_between_plots()
{
  int i;
  float x1;
  float y1;
  float x2;
  float y2;
  T_pt_sor *pt;
    
  for (i = 0; i < nb_point_on_sor - 1; i++)
    {
      pt = ReadPointOnListSor(list_point_sor, i); 
      x1 = pt->x * SorZoom + SIZE_WIN_X/2; 
      y1 = (pt->y * SorZoom) + SIZE_WIN_Y/2; 
      pt = ReadPointOnListSor(list_point_sor, i + 1); 
      x2 = pt->x * SorZoom + SIZE_WIN_X/2; 
      y2 = (pt->y * SorZoom) + SIZE_WIN_Y/2; 
      drawOneLine(x1, y1, x2, y2); 
    }
}

int  processHitsOnSor(GLint hits, GLuint buffer[])
{
  unsigned int i, j;
  GLuint names, *ptr;

  ptr = (GLuint *) buffer;
  for (i = 0; i < hits; i++) 
    { 
      names = *ptr;
      ptr += 3;
      for (j = 0; j < names; j++) 
	return ( *ptr);
    }
  return -1;
}

int pickRects(float x, float y)
{
  GLuint selectBuf[BUFSIZE];
  GLint hits;
  GLint viewport[4];

  glGetIntegerv(GL_VIEWPORT, viewport);
  glSelectBuffer(BUFSIZE, selectBuf);
  glRenderMode(GL_SELECT);
  glInitNames();
  glPushName(-1);
  glViewport (0, 0, (GLsizei) SIZE_WIN_X, (GLsizei) SIZE_WIN_Y); 
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluPickMatrix((GLdouble)x, (GLdouble) y, 2.0, 2.0, viewport);
  gluOrtho2D(0.0, SIZE_WIN_X, 0.0, SIZE_WIN_Y);
  glMatrixMode(GL_MODELVIEW);
  draw_plots(GL_SELECT);
  glPopMatrix();
  hits = glRenderMode(GL_RENDER);
  return processHitsOnSor(hits, selectBuf);
}


int glarea_display_of_sor(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  GtkGLArea *glarea = GTK_GL_AREA(widget);

  if (gtk_gl_area_make_current(glarea))
    {
      glClearColor(1.0,1.0,1.0,1.0);  
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      glViewport (0, 0, (GLsizei) SIZE_WIN_X, (GLsizei) SIZE_WIN_Y); 
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      gluOrtho2D(0.0, SIZE_WIN_X, 0.0, SIZE_WIN_Y);
      glMatrixMode(GL_MODELVIEW);
      glColor3f(0.0, 0.0, 0.0);
      drawOneLine(0, 150, SIZE_WIN_X, 150);
      drawOneLine(100, 0, 100, SIZE_WIN_Y);
      draw_plots(GL_RENDER);
      draw_line_between_plots();
      gtk_gl_area_swapbuffers(glarea);
    }
  return 1;
}

void SetAddToolSor(void)
{
  mode_tool_sor = SOR_ADD_POINT;
}

void SetDelToolSor(void)
{
  mode_tool_sor = SOR_DEL_POINT;
}

void SetMovToolSor(void)
{
  mode_tool_sor = SOR_MOV_POINT;
}

void SetZoomInToolSor(void)
{
  mode_tool_sor = SOR_ZOOM_IN;
}

void SetZoomOutToolSor(void)
{
  mode_tool_sor = SOR_ZOOM_OUT;
}


int SorAddPoint(GtkWidget *glarea_on_sor)
{
  gchar	*value;
  T_pt_sor *pt;

  pt = (T_pt_sor *)g_malloc(sizeof(T_pt_sor));
  gtk_label_get(GTK_LABEL(lbl_X), &value);
  pt->x = atof(value);
  gtk_label_get(GTK_LABEL(lbl_Y), &value);
  pt->y = atof(value);
  pt->id = nb_point_on_sor;
  list_point_sor = g_list_append(list_point_sor, (gpointer)pt);
  nb_point_on_sor++;
  list_point_sor = g_list_sort(list_point_sor, my_list_comp);
  gtk_widget_queue_draw(glarea_on_sor);
  return pt->id;
}

int SorDeletePoint(GtkWidget *glarea_on_sor)
{
  float	X_win_gl;
  float	Y_win_gl;
  gchar	*value;
  int	i;
  T_pt_sor	*pt;
  int		id_selected;
  GList		*current;
  
  if (nb_point_on_sor == 2)
    return -1;
  gtk_label_get(GTK_LABEL(lbl_X), &value);
  X_win_gl = atof(value) * SorZoom + SIZE_WIN_X/2;
  gtk_label_get(GTK_LABEL(lbl_Y), &value);
  Y_win_gl = atof(value) * SorZoom + SIZE_WIN_Y/2;
  id_selected = pickRects(X_win_gl, Y_win_gl); 
  if (id_selected != -1)
    for (i = 0; i < nb_point_on_sor; i++)
      {
	current = g_list_nth(list_point_sor, i);
	pt = (T_pt_sor *)current->data;
	if (pt->id == id_selected)
	  {
	    list_point_sor = g_list_remove(list_point_sor, current->data);
	    nb_point_on_sor--;
	  }
      }
  gtk_widget_queue_draw(glarea_on_sor);
  return id_selected;
}

int SorMoveGetIdPoint(GtkWidget *glarea_on_sor)
{
  float	X_win_gl;
  float	Y_win_gl;
  gchar	*value;
  int		id_selected;

  gtk_label_get(GTK_LABEL(lbl_X), &value);
  X_win_gl = atof(value) * SorZoom + SIZE_WIN_X/2;
  gtk_label_get(GTK_LABEL(lbl_Y), &value);
  Y_win_gl = atof(value) * SorZoom + SIZE_WIN_Y/2;
  id_selected = pickRects(X_win_gl, Y_win_gl); 
  if (id_selected != -1)
    mode_tool_sor = SOR_ON_MOV_POINT;
  return id_selected;
}

gboolean update_position_cursor(GtkWidget *widget, GdkEventMotion *mevent)
{
  gchar		*tmp;
  gdouble	Xreal;
  gdouble	Yreal;
  
  Xreal = (mevent->x - SIZE_WIN_X/2) / SorZoom;
  Yreal = (-(mevent->y - SIZE_WIN_Y/2)) / SorZoom;
  tmp = g_strdup_printf("%f", Xreal);
  gtk_label_set_text(GTK_LABEL(lbl_X), (const gchar *) tmp);
  tmp = g_strdup_printf("%f", Yreal);
  gtk_label_set_text(GTK_LABEL(lbl_Y), (const gchar *)tmp);
  return TRUE;
}

void SorOnMovePoint(GtkWidget *glarea_on_sor)
{
  float X_win_gl;
  float Y_win_gl;
  gchar	*valueX;
  gchar	*valueY;
  T_pt_sor	*pt;
  GList		*current;
  int		i;
  
  gtk_label_get(GTK_LABEL(lbl_X), &valueX);
  X_win_gl = atof(valueX) * SorZoom + SIZE_WIN_X/2;
  gtk_label_get(GTK_LABEL(lbl_Y), &valueY);
  Y_win_gl = atof(valueY) * SorZoom + SIZE_WIN_Y/2;
  for (i = 0; i < nb_point_on_sor; i++)
    {
      current = g_list_nth(list_point_sor, i);
      pt = (T_pt_sor *)current->data;
      if (pt->id == current_id_selected)
	break;
    }
  pt->x = atof(valueX);
  pt->y = atof(valueY);
  gtk_widget_queue_draw(glarea_on_sor);
}

void SorEndMovePoint(GtkWidget *glarea_on_sor)
{
  mode_tool_sor = SOR_MOV_POINT;
  gtk_widget_queue_draw(glarea_on_sor);
}

void SorZoomIn(GtkWidget *glarea_on_sor)
{
  /*    gchar	*buf; */
  
  /*    SorZoom *= 2; */
  /*    buf = g_strdup_printf("%f", SorZoom); */
  /*    gtk_label_set_text(GTK_LABEL(lbl_Zoom), */
  /*  		     (const gchar *)buf); */
  /*    g_free(buf); */
}

void SorZoomOut(GtkWidget *glarea_on_sor)
{
  /*    gchar	*buf; */

  /*    SorZoom /=  2; */
  /*    buf = g_strdup_printf("%f", SorZoom); */
  /*    gtk_label_set_text(GTK_LABEL(lbl_Zoom), */
  /*  		     (const gchar *)buf); */
  /*    g_free(buf); */
}

int SorToolDispatcher(GtkWidget *glarea_sor)
{
  switch (mode_tool_sor)
    {
    case SOR_ADD_POINT:
      return SorAddPoint(glarea_sor);
    case SOR_DEL_POINT:
      return SorDeletePoint(glarea_sor);
    case SOR_MOV_POINT:
      return SorMoveGetIdPoint(glarea_sor);
      break;
    case SOR_ZOOM_IN:
      SorZoomIn(glarea_sor);
      break;
    case SOR_ZOOM_OUT:
      SorZoomOut(glarea_sor);
      break;
    case SOR_NONE:		/* nothing to do */
      break;
    case SOR_ON_MOV_POINT:
      break;
    }
  return -1;	/* no operation on plot */
}

gboolean CameraViewEventDispatcherOnSor(GtkWidget *glarea_sor, GdkEvent *event, 
				    gpointer Menu)
{ 
  GdkEventMotion *mevent = (GdkEventMotion *)event;

  switch (event->type)
    {
    case GDK_BUTTON_PRESS:
      {
        GdkEventButton *bevent = (GdkEventButton *) event;
        if (bevent->button == 3) /* Right Button ==> Popup Menu */
	  gtk_menu_popup(GTK_MENU(Menu), NULL, NULL, NULL, NULL,
			 bevent->button, bevent->time);

	if (bevent->button == 1)
	  current_id_selected = SorToolDispatcher(glarea_sor);
        break;
      }
    case GDK_MOTION_NOTIFY:
      {
	if (mode_tool_sor == SOR_ON_MOV_POINT)
	  SorOnMovePoint(glarea_sor);
	update_position_cursor(glarea_sor, mevent);
	break;
      }
      case GDK_BUTTON_RELEASE:
	{
	  if(mode_tool_sor == SOR_ON_MOV_POINT)
	    SorEndMovePoint(glarea_sor);
	  break;
	}
    default:
      return FALSE;
    }
  return TRUE;
}

void	on_button_ok(GtkWidget *new_sor)
{
  T_obj *obj;
  xmlNodePtr node;
  GList *list_for_tree = NULL;
  int i;
  VECT2D	*tmp;
  T_pt_sor	*pt_sor;
  GList		*current;
  
  for (i=0; i < g_list_length(list_point_sor); i++)
    {
      current = g_list_nth(list_point_sor, i);
      pt_sor = (T_pt_sor *)current->data;
      tmp = (VECT2D *)malloc(sizeof(VECT2D));
      tmp->x = pt_sor->x;
      tmp->y = pt_sor->y;
      list_for_tree = g_list_append(list_for_tree, (gpointer)tmp);
    }

  node = xml_sor_new(list_for_tree, nb_point_on_sor);
  obj = make_MeshTriangleSor(list_point_sor, nb_point_on_sor);
  obj->prop_base->id = global_id_obj++;
  xmlAddChild(gl_scene->root, node);
  node->ns = (xmlNs *)obj;
  gtk_widget_queue_draw(glarea_CAM);
  if (open_windows.vu3d_b) 
    gtk_widget_queue_draw(glarea_CAM);
  if (open_windows.face_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  gtk_widget_destroy(new_sor);
  g_list_free(list_point_sor); 
}

void	on_button_cancel(GtkWidget *new_sor)
{
  gtk_widget_destroy(new_sor);
  g_list_free(list_point_sor); 
}


/* create SOR */
int CreateSor(float x, float y, float z)
{
  GtkWidget	*new_sor;
  GtkWidget	*table;
  GtkWidget	*glarea_sor;
  GtkWidget	*button;
  GtkWidget	*vbox;
  GtkWidget	*hbox;
  GtkWidget	*label;
  GtkWidget	*vtable;
  GtkWidget	*menu;
  GtkWidget	*menu_items;
  GtkWidget	*SubMenu;
  GtkWidget	*XXXMenu;
  int		i, j;

  nb_point_on_sor = 0;
  mode_tool_sor = SOR_ADD_POINT;
  new_sor = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(new_sor), "new sor");
  gtk_window_set_policy(GTK_WINDOW(new_sor), 0, 0, 0);
  gtk_window_set_modal(GTK_WINDOW(new_sor), 1);
  table = gtk_table_new(3, 2, 0);
  vtable = gtk_table_new(2, 2, 0);
  
  gtk_container_add (GTK_CONTAINER(new_sor), table); 

  glarea_sor = gtk_gl_area_new_vargs(NULL,   /*,  no sharing */  
				     GDK_GL_RGBA,
				     GDK_GL_DOUBLEBUFFER,
				     GDK_GL_DEPTH_SIZE,1,
				     GDK_GL_NONE); /* last argument must be GDK_GL_NONE */
  gtk_widget_set_events(glarea_sor,
			GDK_EXPOSURE_MASK|
			GDK_BUTTON_PRESS_MASK|
			GDK_BUTTON_RELEASE_MASK|
			GDK_POINTER_MOTION_MASK|
			GDK_KEY_PRESS_MASK);
  gtk_widget_set_usize(GTK_WIDGET(glarea_sor), SIZE_WIN_X, SIZE_WIN_Y);
  gtk_signal_connect(GTK_OBJECT(glarea_sor), "expose_event",
		     GTK_SIGNAL_FUNC(glarea_display_of_sor), NULL);
  gtk_signal_connect(GTK_OBJECT(glarea_sor), "button-press-event",
		     GTK_SIGNAL_FUNC(CameraViewEventDispatcherOnSor), NULL);
  gtk_table_attach(GTK_TABLE(table), GTK_WIDGET(glarea_sor), 0, 1, 0, 3,
		   GTK_SHRINK, GTK_SHRINK, 5, 5);
  vbox = gtk_vbox_new(0, 0);
  gtk_table_attach(GTK_TABLE(table), vbox, 1, 2, 0, 1, GTK_SHRINK, GTK_SHRINK, 5, 5);
  gtk_box_pack_start (GTK_BOX(vbox), vtable, 0, 0, 0);
  
  label = gtk_label_new("X:");
  gtk_table_attach(GTK_TABLE(vtable), label, 0, 1, 0, 1, GTK_SHRINK, GTK_SHRINK, 0, 0);
  label = gtk_label_new("Y:");
  gtk_table_attach(GTK_TABLE(vtable), label, 0, 1, 1, 2, GTK_SHRINK, GTK_SHRINK, 0, 0);
  lbl_X = gtk_label_new("");
  gtk_table_attach(GTK_TABLE(vtable), lbl_X, 1, 2, 0, 1, GTK_SHRINK, GTK_SHRINK, 0, 0);
  lbl_Y = gtk_label_new("");
  gtk_table_attach(GTK_TABLE(vtable), lbl_Y, 1, 2, 1, 2, GTK_SHRINK, GTK_SHRINK, 0, 0);

  hbox = gtk_hbox_new(0, 0);
  gtk_table_attach (GTK_TABLE(table), hbox, 1, 2, 1, 2, GTK_SHRINK, GTK_SHRINK, 5, 5);
  label = gtk_label_new("Zoom:");
  gtk_box_pack_start (GTK_BOX(hbox), label, 0, 0, 0);
  lbl_Zoom = gtk_label_new(g_strdup_printf("%f",SorZoom));
  gtk_box_pack_start (GTK_BOX(hbox), lbl_Zoom, 0, 0, 0);
  hbox = gtk_hbox_new(0, 0);
  gtk_table_attach (GTK_TABLE(table), hbox, 1, 2, 2, 3, GTK_SHRINK, GTK_SHRINK, 5, 5);

  button = gtk_button_new_with_label("   OK   ");
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
			    GTK_SIGNAL_FUNC(on_button_ok), (gpointer)new_sor);
  gtk_box_pack_start (GTK_BOX(hbox), button, 0, 0, 0);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (button);
  button = gtk_button_new_with_label("Cancel");
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
			    GTK_SIGNAL_FUNC(on_button_cancel), (gpointer)new_sor);
  gtk_box_pack_start (GTK_BOX(hbox), button, 0, 0, 0);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);

  /* define popup on glarea of sor*/
  for (i = 0; i < NB_MENU_ON_SOR; i++)
    menu_popup_on_sor[i] = (t_menu_popup_sor *)malloc(sizeof(t_menu_popup_sor) *
						  prop_menu_on_sor[i].nb_submenu);

  menu_popup_on_sor[0][0].item = "In +";	
  menu_popup_on_sor[0][0].fcn = SetZoomInToolSor;
  menu_popup_on_sor[0][1].item = "Out -";	
  menu_popup_on_sor[0][1].fcn = SetZoomOutToolSor;
  menu_popup_on_sor[1][0].item = "Add";		
  menu_popup_on_sor[1][0].fcn = SetAddToolSor;
  menu_popup_on_sor[1][1].item = "Delete";	
  menu_popup_on_sor[1][1].fcn = SetDelToolSor;
  menu_popup_on_sor[1][2].item = "Move";	
  menu_popup_on_sor[1][2].fcn = SetMovToolSor;
  
  /* set popup */
  menu = gtk_menu_new();
  for (i = 0 ; i < NB_MENU_ON_SOR; i++)
    {
      SubMenu = gtk_menu_new();
      for (j = 0; j < prop_menu_on_sor[i].nb_submenu; j++)
	{
	  if (j == 0)		/* on the first menu items*/
	    menu_items = gtk_radio_menu_item_new_with_label(NULL, menu_popup_on_sor[i][j].item);
	  else
	    menu_items = 
	      gtk_radio_menu_item_new_with_label(gtk_radio_menu_item_group(GTK_RADIO_MENU_ITEM(menu_items)),
						 menu_popup_on_sor[i][j].item);
	  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
	  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
				    GTK_SIGNAL_FUNC(menu_popup_on_sor[i][j].fcn), NULL);
	  gtk_widget_show(menu_items);
	  
	}
      free(menu_popup_on_sor[i]);
      /* XXXMenu <=> FileMenu, EditMenu, ToolMenu....XXX={file, edit, ...} */
      XXXMenu = gtk_menu_item_new_with_label(prop_menu_on_sor[i].name_menu);
      gtk_widget_show(XXXMenu);
      gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenu), SubMenu);
      gtk_menu_append(GTK_MENU(menu), XXXMenu);
    }
  gtk_signal_connect(GTK_OBJECT(glarea_sor), "event",
		     GTK_SIGNAL_FUNC(CameraViewEventDispatcherOnSor), menu);
  gtk_widget_show_all(new_sor);
  list_point_sor = NULL;
  /* by default : 2 points on the sor */
  
  pt_sor = (T_pt_sor *)g_malloc(sizeof(T_pt_sor));
  pt_sor->x = 0;
  pt_sor->y = 40;
  pt_sor->id = nb_point_on_sor;
  nb_point_on_sor++;
  list_point_sor = g_list_append(list_point_sor, (gpointer)pt_sor);
  pt_sor = (T_pt_sor *)g_malloc(sizeof(T_pt_sor));
  pt_sor->x = 0;
  pt_sor->y = -40;
  pt_sor->id = nb_point_on_sor;
  list_point_sor = g_list_append(list_point_sor, (gpointer)pt_sor);
  nb_point_on_sor++;
  return TRUE;
}
