#include "headers.h"

GtkWidget *plug_table_create(struct plugins* a, GtkWidget *window)
{
  int i,j,n=0;
  GtkWidget *table;
  GtkWidget *button;

  
  table=gtk_table_new(((a->nb_plugs-1)/3)+1,3,1);
  gtk_table_set_row_spacings (GTK_TABLE(table),0);
  gtk_table_set_col_spacings (GTK_TABLE(table),0);
  for(i=0;i<=((a->nb_plugs-1)/3)+1;i++)
    {
      for (j=0;j<3;j++)
	{
	  button = (a->create[n])();
	  toggle_button[5 + 3 * i + j] = button;
	  gtk_widget_set_usize(button,BTN_SIZE,BTN_SIZE);
	  gtk_table_attach(GTK_TABLE(table),button,j,j+1,i,i+1,
			   GTK_EXPAND | GTK_FILL ,GTK_EXPAND | GTK_FILL,1,1);
	  gtk_signal_connect(GTK_OBJECT(button),"toggled",
			     GTK_SIGNAL_FUNC(on_select_clicked), NULL);
  	  gtk_signal_connect_after(GTK_OBJECT(button), "clicked", 
  				   GTK_SIGNAL_FUNC(so_core_init), 
  				   (gpointer)a->name[n]); 
	  gtk_widget_show(button);
	  if(n >= a->nb_plugs-1)
	    return table;
	  else
	    n++;
	}
    } 
  return table;
}

GtkWidget *create_pix(GtkWidget *window, gchar *file)
{
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GdkColor transparent;
  GtkStyle *style;

  style = gtk_widget_get_style(window);
  pixmap = gdk_pixmap_create_from_xpm(window->window, 
				      &mask, &transparent, 
				      g_strconcat(g_get_current_dir(),
						  "/pixmaps/",file,NULL)
				      );
  
  pixmapwid = gtk_pixmap_new(pixmap, mask);
  gdk_pixmap_unref(pixmapwid);
  gtk_widget_show(pixmapwid);
  return pixmapwid;
  
}

t_proporties_button	prop_btn[5] =
{
  {
    "select", 0, 1, 0, 1,
    on_select_clicked,
  },
  {
    "move", 1, 2, 0, 1,
    on_select_clicked,
  },
  {
    "resize", 0, 1, 1, 2,
    on_select_clicked,
  },
  {
    "rotate", 1, 2, 1, 2,
    on_select_clicked,
  },
};


GtkWidget *toolbox_create(GtkWidget *window)
{
  GtkWidget	*pixmap;
  GtkWidget	*table;
  GtkTooltips	*tips;
  int		i;
  
  table=gtk_table_new(2, 2, 1);
  gtk_widget_show(table);
  tips = gtk_tooltips_new();
  gtk_tooltips_enable(tips);
  gtk_tooltips_set_delay(tips, DELAY);
  for (i = 0; i < 4; i++) /* nb of button on interface*/
    {
      toggle_button[i] = gtk_toggle_button_new();
      gtk_tooltips_set_tip(tips, GTK_WIDGET(toggle_button[i]), 
			   prop_btn[i].name_button, NULL);
      pixmap = create_pix(window, 
			  g_strdup_printf("%s%s", prop_btn[i].name_button, ".xpm"));
      gtk_container_add(GTK_CONTAINER(toggle_button[i]), pixmap);
      gtk_widget_set_usize(GTK_WIDGET(toggle_button[i]), 50, 50);
      gtk_widget_show(GTK_WIDGET(toggle_button[i]));
      gtk_signal_connect(GTK_OBJECT(toggle_button[i]), "toggled",
			 GTK_SIGNAL_FUNC(prop_btn[i].fcn), NULL);
      gtk_table_attach(GTK_TABLE(table), GTK_WIDGET(toggle_button[i]), 
		       prop_btn[i].a,  
		       prop_btn[i].b, 
		       prop_btn[i].c, 
		       prop_btn[i].d,
		       GTK_EXPAND | GTK_FILL,
		       GTK_EXPAND | GTK_FILL, 1, 1);
    }
  return table;
}

GtkWidget *main_interface(struct plugins* a, GtkWidget *window)
{
  GtkWidget *vbox;
  GtkWidget *bbox;
  GtkWidget *table;
  GtkWidget *hbox;
  GtkWidget *pixmap;
  
  vbox = gtk_vbox_new(0,5);
  gtk_widget_show(vbox);
  bbox = toolbox_create(window);
  gtk_box_pack_start(GTK_BOX(vbox),bbox,0,0,0);
  gtk_widget_show(bbox);  
  hbox = gtk_hbox_new(0, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, 0, 0, 0);
  (GtkWidget *)toggle_button[4] = gtk_toggle_button_new();
  gtk_box_pack_start(GTK_BOX(hbox), GTK_WIDGET(toggle_button[4]), 1, 1, 0);
  pixmap = create_pix(window, 
		      g_strdup("light.xpm"));
  gtk_container_add(GTK_CONTAINER(toggle_button[4]), pixmap);
  gtk_signal_connect(GTK_OBJECT(toggle_button[4]), "toggled",
		     GTK_SIGNAL_FUNC(on_select_clicked), NULL);
  gtk_widget_show_all(hbox);
  table=plug_table_create(a, window);
  gtk_box_pack_start(GTK_BOX(vbox),table,1,1,0);
  gtk_widget_show(table);

  return vbox;
}







