#include "headers.h"

GtkWidget *entry_light[3];
GtkWidget *window;

gboolean ok_light_color_and_pos(GtkWidget *colorsel)
{
  int i;
  int is_good_entry = 1;
  double res_color[3];

  for (i = 0; i < 3; i++)
    if (!str_is_number(gtk_entry_get_text(GTK_ENTRY(entry_light[i]))))
      is_good_entry = 0;
  if (!is_good_entry)
    {
      gtk_widget_destroy(window);
      return FALSE;
    }
  else
    {
      light0_pos[0] = atof(gtk_entry_get_text(GTK_ENTRY(entry_light[0])));
      light0_pos[1] = atof(gtk_entry_get_text(GTK_ENTRY(entry_light[1])));
      light0_pos[2] = atof(gtk_entry_get_text(GTK_ENTRY(entry_light[2])));
      light0_pos[3] = 0.0;
      gtk_color_selection_get_color((GtkColorSelection *)colorsel, res_color);
      light0_color[0] = res_color[0];
      light0_color[1] = res_color[1];
      light0_color[2] = res_color[2];
      light0_color[3] = 0.0;
      nb_light = 1;
      if (gtk_gl_area_make_current((GtkGLArea *)glarea_CAM))
	{
	  glLightfv(GL_LIGHT0, GL_POSITION, light0_pos);
	  glLightfv(GL_LIGHT0, GL_DIFFUSE, light0_color);  
	  glEnable(GL_LIGHTING);
	  glEnable(GL_LIGHT0);
	  gtk_widget_queue_draw(glarea_CAM);
	}
      gtk_widget_destroy(window);
    }
  return TRUE;
}

/* (x, y, z) = position light */
gboolean SetColorLight(float x, float y, float z)
{
  GtkWidget *colorsel;
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *table;
  
  window = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(window), "LIGHT COLOR AND POSITION");
  gtk_window_set_policy(GTK_WINDOW(window), 0, 0, 0);
  gtk_window_set_modal(GTK_WINDOW(window), 1);
  gtk_signal_connect_object(GTK_OBJECT(window), "destroy", 
			    GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(window));
  

  table = gtk_table_new(3, 7, 0);
  gtk_container_add (GTK_CONTAINER(window), table);
  label = gtk_label_new("Position");
  gtk_table_attach(GTK_TABLE(table), label, 0, 1, 0, 1, GTK_SHRINK, GTK_SHRINK, 5, 2);
  label = gtk_label_new("X: ");
  gtk_table_attach(GTK_TABLE(table), label, 1, 2, 0, 1, GTK_SHRINK, GTK_SHRINK, 2, 2);
  entry_light[0] = gtk_entry_new();
  gtk_entry_set_text((GtkEntry *)entry_light[0], g_strdup_printf("%f\n", x));
  gtk_widget_set_usize(entry_light[0], 100, 25);
  gtk_table_attach(GTK_TABLE(table), entry_light[0], 2, 3, 0, 1, GTK_SHRINK, GTK_SHRINK, 2, 2);
  label = gtk_label_new("  Y: ");
  gtk_table_attach(GTK_TABLE(table), label, 3, 4, 0, 1, GTK_SHRINK, GTK_SHRINK, 2, 2);
  entry_light[1] = gtk_entry_new();
  gtk_entry_set_text((GtkEntry *)entry_light[1], g_strdup_printf("%f\n", y));
  gtk_widget_set_usize(entry_light[1], 100, 25);
  gtk_table_attach(GTK_TABLE(table), entry_light[1], 4, 5, 0, 1, GTK_SHRINK, GTK_SHRINK, 2, 2);
  label = gtk_label_new("  Z:");
  gtk_table_attach(GTK_TABLE(table), label, 5, 6, 0, 1, GTK_SHRINK, GTK_SHRINK, 5, 2);
  entry_light[2] = gtk_entry_new();
  gtk_entry_set_text((GtkEntry *)entry_light[2], g_strdup_printf("%f\n", z));
  gtk_widget_set_usize(entry_light[2], 100, 25);
  gtk_table_attach(GTK_TABLE(table), entry_light[2], 6, 7, 0, 1, GTK_SHRINK, GTK_SHRINK, 2, 2);
  
  colorsel = gtk_color_selection_new();
  gtk_table_attach(GTK_TABLE(table), colorsel, 0, 7, 1, 2, GTK_SHRINK, GTK_SHRINK, 2, 2);

  button = gtk_button_new_with_label("  OK  ");
  gtk_table_attach(GTK_TABLE(table), button, 2, 3, 2, 3, GTK_SHRINK, GTK_SHRINK, 2, 2);
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default(button);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
			    GTK_SIGNAL_FUNC(ok_light_color_and_pos), GTK_OBJECT(colorsel));
  button = gtk_button_new_with_label("Cancel");
  gtk_table_attach(GTK_TABLE(table), button, 3, 4, 2, 3, GTK_SHRINK, GTK_SHRINK, 2, 2);
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
			    GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(window));
  
  label = gtk_label_new("LIGHT 1");
  gtk_table_attach(GTK_TABLE(table), label, 6, 7, 2, 3, GTK_SHRINK, GTK_SHRINK, 2, 2);
  gtk_widget_show_all(window);
  return TRUE;
}

void ChangeColorLight(void)
{
  ;
}

