/* 
**   
**   Modlight
**   
**   Made by : 
**             <houday_l@epita.fr>
**             <leroy_e@epita.fr>
**	       <migeot_o@epita.fr>
**
**   started		: Fri 28 02 00 14:30:21
**   Last update	: Sun 12 03 00 13:21:04
 */


#include "headers.h"


void set_pos_line(FILE *f,int nb_line_next)
{
  char c;
  int i;
  for (i=1;i<=nb_line_next;i++)
    while ( (c = fgetc(f)) != '\n')
      ;
}


double strtodouble(char *s)
{
  int i=0;
  while (s[i] != ',')
    i++;
  s[i] = '.';
  return(atof(s));
}


int extract_int_from_str(char *s)
{
  int i=0;
  char *str="";
  while (s[i] != ':')
    i++;
  i++;
  while (s[i] != '\0')
    {
      str = g_strdup_printf("%s%c",str,s[i]);
      i++;
    }
  return(atoi(str));
}


AscObject *load_object_asc(char *path_file)
{
  char c1[50],c2[50],c3[50],c4[50],c5[50],c6[50],c7[50],c8[50];
  FILE *f;
  char x[50],y[50],z[50];
  int i;
  stock_tmp_obj *st_obj;
  AscObject *asc_obj;
  
  st_obj = (stock_tmp_obj *)malloc(sizeof(stock_tmp_obj));
  f = fopen(path_file,"r");
  set_pos_line(f,2);
  fscanf(f,"%s%s%d%s%d",c1,c2,&st_obj->nb_vertex,c3,&st_obj->nb_face);
  set_pos_line(f,2);
  
  st_obj->vertexX = (float *)malloc(sizeof(float)*st_obj->nb_vertex); 
  st_obj->vertexY = (float *)malloc(sizeof(float)*st_obj->nb_vertex); 
  st_obj->vertexZ = (float *)malloc(sizeof(float)*st_obj->nb_vertex);
  for (i=0;i<st_obj->nb_vertex;i++)
    {  
      fscanf(f,"%s%s%s%s%s%s%s%s",c1,c2,c3,x,c4,y,c5,z);
      st_obj->vertexX[i] = strtodouble(x);
      st_obj->vertexY[i] = strtodouble(y);
      st_obj->vertexZ[i] = strtodouble(z);
    }
  
  st_obj->indexA = (int *)malloc(sizeof(int)*st_obj->nb_face);
  st_obj->indexB = (int *)malloc(sizeof(int)*st_obj->nb_face);
  st_obj->indexC = (int *)malloc(sizeof(int)*st_obj->nb_face);
  for (i=0;i<st_obj->nb_face;i++)
    {
      fscanf(f,"%s%s",c1,c2);
      fscanf(f,"%s%s%s%s%s%s%s%s",c1,c2,c3,c4,c5,c6,c7,c8);
      st_obj->indexA[i]   = extract_int_from_str(c3);
      st_obj->indexB[i]   = extract_int_from_str(c4);
      st_obj->indexC[i]   = extract_int_from_str(c5);
    }
  fclose(f);
  
  asc_obj = (AscObject *)malloc(sizeof(AscObject));
  asc_obj->list_vertex = NULL;
  for (i = 0; i < st_obj->nb_face; i++)
    {
      asc_obj->list_vertex = AddTriangleToMesh(asc_obj->list_vertex,
					       asc_obj->vertexX[indexA[i]],
					       asc_obj->vertexY[indexA[i]],
					       asc_obj->vertexZ[indexA[i]]);
      asc_obj->list_vertex = AddTriangleToMesh(asc_obj->list_vertex,
					       asc_obj->vertexX[indexB[i]],
					       asc_obj->vertexY[indexB[i]],
					       asc_obj->vertexZ[indexB[i]]);
      asc_obj->list_vertex = AddTriangleToMesh(asc_obj->list_vertex,
					       asc_obj->vertexX[indexC[i]],
					       asc_obj->vertexY[indexC[i]],
					       asc_obj->vertexZ[indexC[i]]);
    }
  return(asc_obj);
}



/* DEBUG */


void print_res_vertex(AscObject *obj)
{
  int i;
  
  read_list(obj->list_vertex);
}


