#include "headers.h"

int z_cam_prop = 40;
GLfloat light0_pos_prop  [4] = {.0, 10.0, -10.0, 0.0};
GLfloat light0_color_prop[4] = {0.0, 133/255, 255/255, 1.0}; 
int     rotx = 0;


gboolean rotate_angle(gpointer data)
{
  rotx += 5 % 360;
  if (is_timeout)
    {
      gtk_widget_queue_draw(glarea_prop);
      return TRUE;
    }
  else
    return FALSE;
}


void initGL_prop(GtkGLArea *glarea)
{
  int i;
  T_face *face;
  
  glShadeModel(GL_SMOOTH);

  glEnable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST);
  glClearColor(1.0,1.0,1.0,1.0);      
  glLightfv(GL_LIGHT0, GL_POSITION,light0_pos_prop);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light0_color_prop);  
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
  gtk_gl_area_swapbuffers(glarea);

  offset_list = glGenLists(1);
  glNewList(offset_list, GL_COMPILE_AND_EXECUTE);
  CalculateNormal(obj_prop);
  glBegin(GL_TRIANGLES);
  for (i = 0; i < obj_prop->prop_base->nb_face; i++)
    {
      glNormal3f(obj_prop->prop_base->normal[i].x,
		 obj_prop->prop_base->normal[i].y,
		 obj_prop->prop_base->normal[i].z); 
      glColor3f(1, 0.0, 0.0);
      face = ReadTriangleOfMesh(obj_prop->prop_base->list_vertex, i);
      glVertex3f(face->A->x, face->A->y, face->A->z);
      glVertex3f(face->B->x, face->B->y, face->B->z);      
      glVertex3f(face->C->x, face->C->y, face->C->z);
    }
  glEnd();
  glEndList();

}

int glarea_display_prop(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  GtkGLArea *glarea = GTK_GL_AREA(widget);
  
  if (gtk_gl_area_make_current(glarea))
    {
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
      if (do_init_glarea_prop)
	{
	  initGL_prop(glarea);
	  do_init_glarea_prop = 0;
	}
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      gluPerspective(90, 1 , 1, 2000);
      gluLookAt(0,40, z_cam_prop, 0.0, 0,0.0,0.0,1.0,0.0);
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      glRotatef(rotx, 1, 1, 1);
      glCallList(offset_list);
      gtk_gl_area_swapbuffers(glarea);
    }
  return TRUE;
}

void on_cancel_prop(t_dialog_properties *prop)
{
  gtk_widget_destroy(prop->window);
  is_timeout = 0;
  do_init_glarea_prop = 1;
}  

int PrepareIt(t_dialog_properties *prop)
{
  GtkWidget *table;
  GtkWidget *hbox;
  GtkWidget *vbox;
  GtkWidget *button;
  GtkWidget *label;
  int i;
  
  is_timeout = 0; /* timer isn't yet active */
  do_init_glarea_prop = 1;
  glarea_prop = gtk_gl_area_new_vargs(NULL,
				      GDK_GL_RGBA,
				      GDK_GL_DOUBLEBUFFER,
				      GDK_GL_DEPTH_SIZE,
				      1,
				      GDK_GL_NONE);
  gtk_widget_set_events(glarea_prop, GDK_EXPOSURE_MASK);
  gtk_signal_connect(GTK_OBJECT(glarea_prop), "expose-event",
		     GTK_SIGNAL_FUNC(glarea_display_prop), NULL);
  prop->window = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(prop->window), prop->window_title);
  gtk_window_set_policy(GTK_WINDOW(prop->window), 0, 0, 0);
  gtk_signal_connect(GTK_OBJECT(prop->window), "destroy", gtk_widget_destroy, 
		     prop->window);
  /* set modal ?? */ /*NON !!!!!!!!!!!!!!!!!*/
  
  hbox = gtk_hbox_new(0, 5);
  gtk_container_add(GTK_CONTAINER(prop->window), hbox);

  vbox = gtk_vbox_new(0, 5);
  gtk_box_pack_start(GTK_BOX(hbox), vbox, 0, 0, 0);

  table = gtk_table_new(prop->nb + 2, 2, 0);
  gtk_box_pack_start(GTK_BOX(vbox), table, 1, 0, 5);

  for (i = 0; i < prop->nb; i++)
    {
      label = gtk_label_new(prop->label_text[i]);
      gtk_widget_set_usize(GTK_WIDGET(label), 80, 25);
      prop->entry[i] = gtk_entry_new();
      gtk_entry_set_text((GtkEntry *)prop->entry[i], 
			 g_strdup_printf("%f", prop->value_entry[i]));
      gtk_widget_set_usize(GTK_WIDGET(prop->entry[i]), 80, 25);
      gtk_table_attach(GTK_TABLE(table), label, 0, 1, i, i + 1, GTK_SHRINK, 
		       GTK_SHRINK, 0, 0);
      gtk_table_attach(GTK_TABLE(table), prop->entry[i], 1, 2, i, i + 1, 
		       GTK_SHRINK, GTK_SHRINK, 0, 0);
    }
  button = gtk_button_new_with_label("   OK   ");
  gtk_widget_set_usize(GTK_WIDGET(button), 60, 35);
  gtk_signal_connect(GTK_OBJECT(button), "clicked", 
		     GTK_SIGNAL_FUNC(prop->fcn), prop);
  gtk_table_attach(GTK_TABLE(table), button, 0, 1, prop->nb, prop->nb + 1, 
		   GTK_SHRINK, GTK_SHRINK, 10, 5);
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default(button);

  button = gtk_button_new_with_label(" Cancel ");
  gtk_widget_set_usize(GTK_WIDGET(button), 60, 35);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
			    GTK_SIGNAL_FUNC(on_cancel_prop), 
			    (gpointer)prop);
  gtk_table_attach(GTK_TABLE(table), button, 1, 2, prop->nb, prop->nb + 1, 
		   GTK_SHRINK, GTK_SHRINK, 10, 5);
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);

  vbox = gtk_vbox_new(0, 5);
  gtk_box_pack_start(GTK_BOX(hbox), vbox, 1, 1, 10);
  gtk_box_pack_start(GTK_BOX(vbox), glarea_prop, 0, 0, 15);
  gtk_widget_set_usize(GTK_WIDGET(glarea_prop), 100, 100);
  /* mettre le GL */
  
  is_timeout = 1;
  g_timeout_add(30, &rotate_angle, NULL);
  gtk_widget_show_all(prop->window);
  return 0;
}


