#include "headers.h"
#include "xpm/yes.xpm"
#include "xpm/warning.xpm"


int file_size (FILE *fp)
{
  long i=0;
  char *c="";
  while ((int)(c = (char *)fgetc(fp)) != EOF)
    {
      ++i;
    }
  return i;
}

void init_conf ()
{
  FILE *fp;
  fp = fopen("mod.cfg","w");
  conf_user.start_window_b=1;
  strcpy(conf_user.default_path,"/tmp");

  fprintf(fp,"dmarrage: %d\ndefault_path: %s\n", 
	  conf_user.start_window_b, 
	  conf_user.default_path);
}

void read_default_path ()
{
  FILE *fp;
  char essai[51];
  long size;
  
  fp = fopen("mod.cfg","r");
  size = file_size(fp);
  size = size - 1;
  fseek(fp,0L,0);
  while( ftell(fp) <  size)
    {
      fscanf(fp,"%s",essai);
      if (g_strncasecmp(essai,"default_path",12) == 0)
	{
	  while (g_strncasecmp(essai,"/",1) != 0 )
	    {
	      fscanf(fp,"%s",essai);
	      if (ftell(fp) >  size)
	  	{
	  	  strcpy(conf_user.default_path,"/tmp");
	  	  break;
	  	}
	    } 
	  break;
	}
    }
  if (g_strncasecmp(essai,"/",1) == 0 )
    strcpy(conf_user.default_path,essai);


  fclose (fp);
}

void read_general(char *cond_1, int nb_1, 
		  char *cond_2, int nb_2, 
		  int *window_b)
{
  FILE *fp;
  char essai[51];
  long size;
  
  fp = fopen("mod.cfg","r");
  size = file_size(fp);
  size = size - 1;
  fseek(fp,0L,0);
  while( ftell(fp) <  size)
    {
      fscanf(fp,"%s",essai);
      if (g_strncasecmp(essai,cond_1,nb_1) == 0)
	{
	  while ((g_strncasecmp(essai,"0",1) != 0))
	    {
	      fscanf(fp,"%s",essai);
	      if ((g_strncasecmp(essai,cond_2,nb_2) == 0))
		{
		  break;
		}
	    } 
	  break;
	}
    }
  if ((g_strncasecmp(essai,"0",1) == 0))
    *window_b=0;
  else
    *window_b=1;
  

  fclose (fp);
}

void read_vu3d_window()
{
  FILE *fp;
  char essai[51];
  long size;
  
  fp = fopen("mod.cfg","r");
  size = file_size(fp);
  size = size - 1;
  fseek(fp,0L,0);
  while( ftell(fp) <  size)
    {
      fscanf(fp,"%s",essai);
      if (g_strncasecmp(essai,"3D",6) == 0)
	{
	  while ((g_strncasecmp(essai,"0",1) != 0))
	    {
	      fscanf(fp,"%s",essai);
	      if (ftell(fp) > size)
		{
		  break;
		}
	    } 
	  break;
	}
    }
  if ((g_strncasecmp(essai,"0",1) == 0))
    open_windows.vu3d_b=0;
  else
    open_windows.vu3d_b=1;

  fclose (fp);
}

void read_conf()
{
  int rep_v;

  read_general("dmarrage", 9, "droite", 6, &conf_user.start_window_b);
  read_default_path ();
  read_general("droite", 6, "face", 4,  &open_windows.right_b);
  read_general("face",4,"dessus",6,&open_windows.face_b);
  read_general("dessus",6,"3D",2,&open_windows.over_b);
  read_vu3d_window();

  windows_openning (1);
  windows_openning (2);
  windows_openning (3);
  windows_openning (4);

  rep_v = verif_rep();
  if (rep_v == 0)
    strcpy(conf_user.default_path,"/tmp");
}



int verif_rep ()
{
  DIR *dir;
  FILE *fp;
  char *file;
  dir = opendir( conf_user.default_path );
  if (dir == NULL)
    return 0;
  else
    {
      file=g_strconcat( conf_user.default_path, "/mod.essai", NULL);
      fp = fopen(file,"a");
      if(fp == NULL)
	return 0;
      else
	return 1;
    }
}

void error_conf_new ()
{
  GtkWidget *Fenetre;
  GtkWidget *table;
  GtkWidget *pixmap;
  GdkPixmap *gdk_pixmap;
  GdkBitmap *mask;
  GtkWidget *bouton;
  GdkColor transparent;
  GtkWidget *label;
  GtkWidget *main_hbox;
  

  Fenetre = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_signal_connect_object (GTK_OBJECT (Fenetre), 
			     "destroy", 
			     GTK_SIGNAL_FUNC (gtk_widget_destroy), 
			     GTK_OBJECT (Fenetre));
  
  gtk_window_set_title (GTK_WINDOW (Fenetre), 
			"Erreur au changement de configuration");
  gtk_window_set_position ( GTK_WINDOW( Fenetre ),  GTK_WIN_POS_CENTER);
  gtk_window_set_policy ( GTK_WINDOW ( Fenetre ) , 0, 0, 0);

  table = gtk_table_new ( 2, 3, FALSE);
  gtk_container_add (GTK_CONTAINER (Fenetre), table);

  gdk_pixmap = gdk_pixmap_create_from_xpm_d(Fenetre->window, 
					    &mask, 
					    &transparent, 
					    warning);
  
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_widget_show(pixmap);
  gtk_table_attach (GTK_TABLE(table), 
		    pixmap, 0, 1, 0, 1 , 
		    GTK_SHRINK, GTK_SHRINK, 5 , 5 );

  
  /* desole cete partie resteras trop porc tant que je ne retrouverais 
     pas ma doc sur les alignements et ajustements en Gtk */
  label = gtk_label_new (g_strconcat( conf_user.default_path,":","                                                    \n",
				      "n'xiste pas ou vous n'avez pas les droits\n",
				      "Le chemin a t remis par dfaut  /tmp   ",NULL));
  gtk_table_attach (GTK_TABLE(table), 
		    label, 1, 3, 0, 1 , 
		    GTK_SHRINK | GTK_FILL, 
		    GTK_SHRINK | GTK_FILL, 15 , 5 );
  gtk_widget_show (label);

  bouton = gtk_button_new();
  gtk_signal_connect_object (GTK_OBJECT (bouton), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (Fenetre));
  main_hbox = gtk_hbox_new(FALSE, 1);
  gtk_container_add(GTK_CONTAINER(bouton), main_hbox);
  gtk_widget_show(main_hbox);
  gdk_pixmap = gdk_pixmap_create_from_xpm_d(Fenetre->window, &mask, &transparent, yes);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_box_pack_start(GTK_BOX(main_hbox), pixmap, 1, 0, 4);
  gtk_widget_show(pixmap);
  label = gtk_label_new("D'accord");
  gtk_box_pack_start(GTK_BOX(main_hbox), label, 1, 0, 0);
  gtk_widget_show(label);
  gtk_widget_show(bouton);
  gtk_table_attach (GTK_TABLE(table), bouton, 2, 3, 1, 2 , GTK_SHRINK, GTK_SHRINK, 5 , 8 );
 
  gtk_widget_show(table);
  gtk_widget_show_all (Fenetre);

}

void new_conf()
{
  FILE *fp;
  int i;
  fp = fopen("mod.cfg","w");
  i=verif_rep();
  if (i==1)
    fprintf(fp,"dmarrage: %d\ndefault_path: %s\n", 
	    conf_user.start_window_b, 
	    conf_user.default_path);
  else
    {
      error_conf_new ();
      strcpy(conf_user.default_path,"/tmp");
      fprintf(fp,"dmarrage: %d\ndefault_path: %s\n", 
	      conf_user.start_window_b, 
	      conf_user.default_path);
    }
  fclose(fp);
}

int verif_conf ()
{
  FILE *fp;
  fp = fopen("mod.cfg","r");
  if (fp == NULL)
    return 0;
  else
    return 1;
}

void open_conf()
{
  int i;
  i=verif_conf();
  if (i == 1)
    read_conf();
  else
    init_conf();
}
