#include "headers.h"
#include "mlMessage.h"

void remove_ns(xmlNodePtr tree)
{
  if (tree->ns !=NULL)
    {
      free_obj((T_obj *)tree->ns);
    }
  if (tree->childs->ns !=NULL)
    {
      free_obj((T_obj *)tree->childs->ns);
    }
}

void to_save(xmlNodePtr tree)
{
  T_obj *obj;
  xmlNodePtr alter,temp;

  obj = (T_obj *)(tree->ns);
  alter=xmlNewNode(NULL,"TRANSFORM");
  temp=xmlNewNode(NULL,"translate");
  xmlSetProp(temp,"value",
	     g_strdup_printf("%f, %f, %f",
			     obj->prop_base->translate->x,
			     obj->prop_base->translate->y,
			     obj->prop_base->translate->z));
  xmlAddChild(alter,temp);
  temp=xmlNewNode(NULL,"rotate");
  xmlSetProp(temp,"value",
	     g_strdup_printf("%f, %f, %f",
			     obj->prop_base->rotate->x,
			     obj->prop_base->rotate->y,
			     obj->prop_base->rotate->z));
  xmlAddChild(alter,temp);
  temp=xmlNewNode(NULL,"scale");
  xmlSetProp(temp,"value",
	     g_strdup_printf("%f, %f, %f",
			     obj->prop_base->scale->x,
			     obj->prop_base->scale->y,
			     obj->prop_base->scale->z));
  xmlAddChild(alter,temp);	     
  xmlAddChild(tree,alter);
  alter = xmlNewNode(NULL,"COLOR");
  xmlSetProp(alter,"value",
	     g_strdup_printf("%f, %f, %f",
			     obj->prop_base->color[0].x,
			     obj->prop_base->color[0].y,
			     obj->prop_base->color[0].z));
  xmlAddChild(tree,alter);

}

void save_xmlfile(GtkWidget *filew, gpointer data3)
{
  xmlDocPtr temp;
  parse_level1(gl_scene->root, to_save);   
  temp = xmlCopyDoc(gl_scene,1);
  parse_level1(temp->root, remove_ns);

  xmlSaveFile(xmlGetProp(gl_scene->root,"filename"),temp);
  xmlFreeDoc(temp);
}

void file_ok_sel (GtkWidget *widget, GtkFileSelection *fs)
{
  char *file_name = gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));
  gl_scene=xmlParseFile(file_name);
  if (!gl_scene)
    puts("ERROR: Not a scene file!!!");
  else
    {
      global_id_obj = 1;
      expandtreeGL();
    }
  /* gerer ici l'ouverture des fichier */
  gtk_widget_destroy( GTK_WIDGET(fs));
  gtk_widget_queue_draw(glarea_CAM);
}

void close_fileselection ()
{
  open_windows.Fileselection_b=FALSE;
}

/* fonction de selection de fichier */
void selection ( GtkWidget *filew, gpointer data3 )
{
  filew = gtk_file_selection_new ("Fichier selection");

  gtk_signal_connect (GTK_OBJECT (filew), 
		      "destroy", 
		      (GtkSignalFunc) close_fileselection, 
		      GTK_OBJECT (filew));
  
  gtk_signal_connect (GTK_OBJECT (filew), 
		      "destroy", 
		      (GtkSignalFunc) gtk_widget_destroy, 
		      GTK_OBJECT (filew));
  
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), 
		      "clicked", 
		      (GtkSignalFunc) close_fileselection, 
		      filew );
  
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), 
		      "clicked", 
		      (GtkSignalFunc) file_ok_sel, 
		      filew );
  
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), 
			     "clicked", 
			     (GtkSignalFunc) close_fileselection, 
			     GTK_OBJECT (filew)); 
  
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (filew));
  
  gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), 
				   g_strconcat(Nom_doc,".mlo",NULL)); 

  if ( open_windows.Fileselection_b == TRUE )
    gtk_widget_destroy( filew );
  open_windows.Fileselection_b=TRUE;
  gtk_widget_show(filew);

}

