#include "headers.h"
#include "xpm/yes.xpm"

void default_open (void)
{
  open_windows.right_b=TRUE;  
  open_windows.face_b=TRUE;
  open_windows.over_b=TRUE;
  open_windows.vu3d_b=TRUE;

  windows_openning( 1 );
  windows_openning( 2 );
  windows_openning( 3 );
  windows_openning( 4 );
}

void make_check_started(GtkWidget *table, GtkWidget *check,
			int x_min, int x_max, int y_min, 
			 int y_max,int type_mess, 
			gboolean toggled_button ,char *label)
{
  
  check = gtk_check_button_new_with_label (label);
  if (toggled_button)
    gtk_toggle_button_set_active ( GTK_TOGGLE_BUTTON (check) , 1);
  gtk_signal_connect (GTK_OBJECT (check), 
		      "toggled", 
		      GTK_SIGNAL_FUNC (affiche_gestion), 
		      (gpointer) type_mess );
  gtk_table_attach (GTK_TABLE (table), check, 
		    x_min, x_max, y_min, y_max, 
		    GTK_EXPAND | GTK_FILL, 
		    GTK_EXPAND | GTK_FILL, 5, 5);
  gtk_widget_show (check);

}


void  start_mod (void)
{
  GtkWidget *window;
  GtkWidget *hbox;
  GtkWidget *table;
  GtkWidget *pixmap;
  GtkWidget *label;
  GdkPixmap *gdk_pixmap;
  GdkBitmap *mask;
  GtkWidget *button;
  GdkColor transparent;
  int right=1;
  int face=2;
  int over=3;
  int vu3d=4;

  /* build interface */
  window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_signal_connect (GTK_OBJECT ( window ), 
		      "destroy", 
		      (GtkSignalFunc) gtk_widget_destroy, 
		      GTK_OBJECT ( window ));
  
  gtk_window_set_title (GTK_WINDOW (window),"Dmarrage" );
  gtk_window_set_position ( GTK_WINDOW( window ),  GTK_WIN_POS_CENTER );
  gtk_window_set_policy ( GTK_WINDOW ( window ) , 0, 0, 0);
  
  table = gtk_table_new ( 6, 2, FALSE);
  gtk_container_add (GTK_CONTAINER (window), table);
  
  label = gtk_label_new ("Choix des vues au dmarage:");
  gtk_table_attach (GTK_TABLE(table), 
		    label, 0, 1, 0, 1 , 
		    GTK_SHRINK, GTK_SHRINK, 2 , 2 );
  gtk_widget_show (label);

  make_check_started(table, windows_view.check_r, 
		     0, 1, 1, 2, right, 
		     open_windows.right_b, "Vue de droite");
  
  make_check_started(table, windows_view.check_f, 
		     0, 1, 2, 3, face, 
		     open_windows.face_b,"Vue de face");

  make_check_started(table, windows_view.check_o, 
		     0, 1, 3, 4, over, 
		     open_windows.over_b,"Vue de dessus");
  
  make_check_started(table, windows_view.check_d, 
		     0, 1, 4, 5, vu3d, 
		     open_windows.vu3d_b,"Vue 3D");
 
  button = gtk_button_new ();
  gtk_signal_connect_object (GTK_OBJECT (button), 
			     "clicked", 
			     GTK_SIGNAL_FUNC (gtk_widget_destroy), 
			     GTK_OBJECT(window));
  
  hbox = gtk_hbox_new(FALSE, 1);
  gtk_container_add(GTK_CONTAINER(button), hbox);
  gtk_widget_show(hbox);
  gdk_pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask, &transparent, yes);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  gdk_pixmap_unref(gdk_pixmap);
  gtk_box_pack_start(GTK_BOX(hbox), pixmap, 1, 0, 4);
  gtk_widget_show(pixmap);
  label = gtk_label_new("OK");
  gtk_box_pack_start(GTK_BOX(hbox), label, 1, 0, 0);
  gtk_widget_show(label);
  gtk_table_attach (GTK_TABLE(table), button, 1,2,5,6, GTK_SHRINK, GTK_SHRINK, 5,5);
  gtk_widget_show(button);

  gtk_widget_show(table);
  gtk_widget_show(window);
}




