typedef enum
{
  OBJ_BOX,
  OBJ_SPHERE,
  OBJ_CONE,
  OBJ_TORUS,
  OBJ_PLANE,
  OBJ_OPEN_CONE,
  OBJ_SOR
}T_type_obj;


typedef struct
{  
  int		id;
  int		is_selected;
  int		nb_face;
  GSList	*list_vertex;
  VECT3D	*normal;
  VECT3D	*color;    /* x=R, y=G, z=B */
  VECT3D	*rotate;
  VECT3D	*translate;
  VECT3D	*scale;
} ObjectBase;

typedef struct
{
  VECT3D	*MinCorner;	/* MinCorner */
  VECT3D	*MaxCorner;	/* MaxCorner */
} ObjectBox;


typedef struct
{
  VECT3D	*center;
  float		radius;
  int		detail_level;
} ObjectSphere;

typedef struct
{
  VECT3D	*center1;
  float		radius1;
  VECT3D	*center2;
  float		radius2;
  int		detail_level;
} ObjectCone;

typedef struct
{
  VECT3D	*center;
  float		radius;
  float		vradius;
  int		detail_level;
} ObjectTorus;

typedef struct
{
  VECT3D	*N;
  VECT3D	*P;
} ObjectPlane;

typedef struct
{
  VECT3D	*center1;
  VECT3D	*center2;
  float		radius1;
  float		radius2;
  int		detail_level;
} ObjectOpenCone;

typedef struct
{
  GList		*list;	/* the n points primitive */
  int		detail_level;
} ObjectSor;

typedef union
{
  ObjectBox		box;
  ObjectSphere		sphere;
  ObjectCone		cone;
  ObjectTorus		torus;
  ObjectPlane		plane;
  ObjectOpenCone	open_cone;
  ObjectSor		sor;
} T_prop_;


typedef struct
{
  char		*name;
  T_type_obj	type_obj;
  T_prop_	*prop;
  ObjectBase	*prop_base;	/*propriete de l'object commune a tous les obj */
} T_obj;


T_obj *obj_prop;
