#include "headers.h"

/****************************************
 *	COLOR OBJECT			*
 ****************************************/

gboolean GetColorObject(GtkWidget *widget, GtkColorSelectionDialog *colorseldlg)
{
  double color[3];
  t_list_obj_select *obj_select;
  int i;
  int j;

  obj_select = (t_list_obj_select *)gtk_object_get_data(GTK_OBJECT(colorseldlg), "obj");
  gtk_color_selection_get_color((GtkColorSelection *)\
				GTK_COLOR_SELECTION_DIALOG(colorseldlg)->colorsel, 
				color);
  for (i = 0; i < obj_select->size; i++)
    {
      for (j = 0; j < obj_select->mem_obj[i]->prop_base->nb_face; j++)
	{
	  obj_select->mem_obj[i]->prop_base->color[j].x = color[0];
	  obj_select->mem_obj[i]->prop_base->color[j].y = color[1];
	  obj_select->mem_obj[i]->prop_base->color[j].z = color[2];
	}
    }
  gtk_widget_queue_draw(glarea_CAM);
  gtk_widget_destroy((GtkWidget *)colorseldlg);
  return TRUE;
}

void SetColorObject(void)
{
  GtkWidget *colorseldlg;
  t_list_obj_select *obj_select;
  
  if (!gl_scene->root->childs)
    return;
  obj_select = GetSelectedObject(gl_scene->root);
  if (!obj_select->size)
    return;
  colorseldlg = gtk_color_selection_dialog_new("COLOR SELECT");
  gtk_object_set_data(GTK_OBJECT(colorseldlg), "obj", (gpointer)obj_select);
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(colorseldlg)->ok_button),
			    "clicked", GTK_SIGNAL_FUNC(GetColorObject), 
			    GTK_OBJECT(colorseldlg));
  gtk_signal_connect_object(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(colorseldlg)->cancel_button),
			    "clicked", gtk_widget_destroy, GTK_OBJECT(colorseldlg));
  gtk_widget_show_all(colorseldlg);
}

/*******************************************
 *         ROTATE                          *
 *******************************************/

gboolean OnRotateObject(GtkWidget *window)
{
  t_list_obj_select *obj_select;
  int i;
  int good_entry = 1;
  

  if (!gl_scene->root->childs)
    {
      quick_message("No object present");
      gtk_widget_destroy(window);
      return FALSE;
    }
  obj_select = GetSelectedObject(gl_scene->root);
  if (!obj_select->size)
    {
      quick_message("No selected");
      gtk_widget_destroy(window);
      return FALSE;
    }
  for (i = 0; i < 3; i++)
    if (!gtk_entry_get_text((GtkEntry *)EntryRotate[i]))
      good_entry = 0;
  
  if (!good_entry)
    {
      gtk_widget_destroy(window);
      return FALSE;
    }
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->rotate->x += \
	atof(gtk_entry_get_text((GtkEntry *)EntryRotate[0]));
      obj_select->mem_obj[i]->prop_base->rotate->y += \
	atof(gtk_entry_get_text((GtkEntry *)EntryRotate[1]));
      obj_select->mem_obj[i]->prop_base->rotate->z += \
	atof(gtk_entry_get_text((GtkEntry *)EntryRotate[2]));
    }
  if (open_windows.vu3d_b) 
    gtk_widget_queue_draw(glarea_CAM);
  if (open_windows.face_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  gtk_widget_destroy(window);
  return (TRUE);
}
void    RotateObject(void)
{
  GtkWidget *window;
  GtkWidget *table;
  GtkWidget *label;
  GtkWidget *button;
  GtkWidget *hbox;
	 
  window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_policy (GTK_WINDOW(window), 0, 0, 0);
  gtk_window_set_title  (GTK_WINDOW(window), "Rotate Object");
  gtk_signal_connect_object(GTK_OBJECT(window), "destroy",
			    gtk_widget_destroy, GTK_OBJECT(window));

  table = gtk_table_new(5, 2, 0);
  gtk_container_add (GTK_CONTAINER(window), table);
  
  label = gtk_label_new ("Rotate:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 2, 0, 1, GTK_SHRINK, GTK_SHRINK, 10, 5);

  label = gtk_label_new ("on X:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 1, 2, GTK_SHRINK, GTK_SHRINK, 5, 0);

  EntryRotate[0] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryRotate[0], 1, 2, 1, 2, GTK_SHRINK, GTK_SHRINK, 5, 5);

  label = gtk_label_new ("on Y:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 2, 3, GTK_SHRINK, GTK_SHRINK, 5, 5);

  EntryRotate[1] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryRotate[1], 1, 2, 2, 3, GTK_SHRINK, GTK_SHRINK, 5, 5);

  label = gtk_label_new ("on Z:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 3, 4, GTK_SHRINK, GTK_SHRINK, 5, 5);

  EntryRotate[2] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryRotate[2], 1, 2, 3, 4, GTK_SHRINK, GTK_SHRINK, 5, 5);

  hbox = gtk_hbox_new(0, 0);
  gtk_table_attach (GTK_TABLE(table), hbox, 1, 2, 4, 5, GTK_SHRINK, GTK_SHRINK, 5, 5);

  button = gtk_button_new_with_label("   OK   ");
  gtk_box_pack_start(GTK_BOX(hbox), button, 0, 0, 5);
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default(button);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
			    /* callback */GTK_SIGNAL_FUNC(OnRotateObject) ,
			    /* parametre */ GTK_OBJECT(window));

  button = gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(hbox), button, 0, 0, 5);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
			     gtk_widget_destroy, GTK_OBJECT(window));
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);

  gtk_widget_show_all(window);
}

/*******************************************
 *         SCALE                           *
 *******************************************/

gboolean OnScaleObject(GtkWidget *window)
{
  int i;
  int good_entry = 1;
  t_list_obj_select *obj_select;
  
  if (!gl_scene->root->childs)
    {
      quick_message("No object present");
      gtk_widget_destroy(window);
      return FALSE;
    }
  obj_select = GetSelectedObject(gl_scene->root);
  if (!obj_select->size)
    {
      quick_message("No selected object");
      gtk_widget_destroy(window);
      return FALSE;
    }
    
  for (i = 0; i < 3; i++)
    if (!gtk_entry_get_text((GtkEntry *)EntryScale[i]))
      good_entry = 0;
  
  if (!good_entry)
    {
      gtk_widget_destroy(window);
      return FALSE;
    }
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->scale->x *= \
	atof(gtk_entry_get_text((GtkEntry *)EntryScale[0]));
      obj_select->mem_obj[i]->prop_base->scale->y *= \
	atof(gtk_entry_get_text((GtkEntry *)EntryScale[1]));
      obj_select->mem_obj[i]->prop_base->scale->z *= \
	atof(gtk_entry_get_text((GtkEntry *)EntryScale[2]));
    }
  if (open_windows.vu3d_b) 
    gtk_widget_queue_draw(glarea_CAM);
  if (open_windows.face_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  gtk_widget_destroy(window);
  return (TRUE);
}
void    ScaleObject(void)
{
  GtkWidget *window;
  GtkWidget *table;
  GtkWidget *label;
  GtkWidget *button;
  GtkWidget *hbox;
	 
  window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_policy (GTK_WINDOW(window), 0, 0, 0);
  gtk_window_set_title  (GTK_WINDOW(window), "Scale Object");
  gtk_signal_connect_object(GTK_OBJECT(window), "destroy",
			    gtk_widget_destroy, GTK_OBJECT(window));

  table = gtk_table_new(5, 2, 0);
  gtk_container_add (GTK_CONTAINER(window), table);
  
  label = gtk_label_new ("Scale:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 2, 0, 1, GTK_SHRINK, GTK_SHRINK, 10, 5);

  label = gtk_label_new ("on X:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 1, 2, GTK_SHRINK, GTK_SHRINK, 5, 0);

  EntryScale[0] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryScale[0], 1, 2, 1, 2, GTK_SHRINK, GTK_SHRINK, 5, 5);

  label = gtk_label_new ("on Y:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 2, 3, GTK_SHRINK, GTK_SHRINK, 5, 5);

  EntryScale[1] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryScale[1], 1, 2, 2, 3, GTK_SHRINK, GTK_SHRINK, 5, 5);

  label = gtk_label_new ("on Z:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 3, 4, GTK_SHRINK, GTK_SHRINK, 5, 5);

  EntryScale[2] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryScale[2], 1, 2, 3, 4, GTK_SHRINK, GTK_SHRINK, 5, 5);

  hbox = gtk_hbox_new(0, 0);
  gtk_table_attach (GTK_TABLE(table), hbox, 1, 2, 4, 5, GTK_SHRINK, GTK_SHRINK, 5, 5);

  button = gtk_button_new_with_label("   OK   ");
  gtk_box_pack_start(GTK_BOX(hbox), button, 0, 0, 5);
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default(button);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
			    /* callback */GTK_SIGNAL_FUNC(OnScaleObject) ,
			    /* parametre */ GTK_OBJECT(window));

  button = gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(hbox), button, 0, 0, 5);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
			     gtk_widget_destroy, GTK_OBJECT(window));
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);

  gtk_widget_show_all(window);
}

/*******************************************
 *         TRANSLATE                       *
 *******************************************/

gboolean OnTranslateObject(GtkWidget *window)
{
  int i;
  int good_entry = 1;
  t_list_obj_select *obj_select;
  
  if (!gl_scene->root->childs)
    {
      quick_message("No object present");
      gtk_widget_destroy(window);
      return FALSE;
    }
  obj_select = GetSelectedObject(gl_scene->root);
  if (!obj_select->size)
    {
      quick_message("No selected object");
      gtk_widget_destroy(window);
      return FALSE;
    }
  for (i = 0; i < 3; i++)
    if (!gtk_entry_get_text((GtkEntry *)EntryTranslate[i]))
      good_entry = 0;
  
  if (!good_entry)
    {
      gtk_widget_destroy(window);
      return FALSE;
    }
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->translate->x += \
	atof(gtk_entry_get_text((GtkEntry *)EntryTranslate[0]));
      obj_select->mem_obj[i]->prop_base->translate->y += \
	atof(gtk_entry_get_text((GtkEntry *)EntryTranslate[1]));
      obj_select->mem_obj[i]->prop_base->translate->z += \
	atof(gtk_entry_get_text((GtkEntry *)EntryTranslate[2]));
    }
  if (open_windows.vu3d_b) 
    gtk_widget_queue_draw(glarea_CAM);
  if (open_windows.face_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);

  gtk_widget_destroy(window);
  return (TRUE);
}

void    TranslateObject(void)
{
  GtkWidget *window;
  GtkWidget *table;
  GtkWidget *label;
  GtkWidget *button;
  GtkWidget *hbox;
	 
  window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_policy (GTK_WINDOW(window), 0, 0, 0);
  gtk_window_set_title  (GTK_WINDOW(window), "Translate Object");
  gtk_signal_connect_object(GTK_OBJECT(window), "destroy",
			    gtk_widget_destroy, GTK_OBJECT(window));

  table = gtk_table_new(5, 2, 0);
  gtk_container_add (GTK_CONTAINER(window), table);
  
  label = gtk_label_new ("Translate:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 2, 0, 1, GTK_SHRINK, GTK_SHRINK, 10, 5);

  label = gtk_label_new ("on X:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 1, 2, GTK_SHRINK, GTK_SHRINK, 5, 0);

  EntryTranslate[0] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryTranslate[0],
		    1, 2, 1, 2, GTK_SHRINK, GTK_SHRINK, 5, 5);

  label = gtk_label_new ("on Y:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 2, 3, GTK_SHRINK, GTK_SHRINK, 5, 5);

  EntryTranslate[1] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryTranslate[1], 
		    1, 2, 2, 3, GTK_SHRINK, GTK_SHRINK, 5, 5);

  label = gtk_label_new ("on Z:");
  gtk_table_attach (GTK_TABLE(table), label, 0, 1, 3, 4, GTK_SHRINK, GTK_SHRINK, 5, 5);

  EntryTranslate[2] = gtk_entry_new();
  gtk_table_attach (GTK_TABLE(table), EntryTranslate[2], 
		    1, 2, 3, 4, GTK_SHRINK, GTK_SHRINK, 5, 5);

  hbox = gtk_hbox_new(0, 0);
  gtk_table_attach (GTK_TABLE(table), hbox, 1, 2, 4, 5, GTK_SHRINK, GTK_SHRINK, 5, 5);

  button = gtk_button_new_with_label("   OK   ");
  gtk_box_pack_start(GTK_BOX(hbox), button, 0, 0, 5);
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
  gtk_widget_grab_default(button);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
			    /* callback */GTK_SIGNAL_FUNC(OnTranslateObject) ,
			    /* parametre */ GTK_OBJECT(window));

  button = gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(hbox), button, 0, 0, 5);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked", 
			     gtk_widget_destroy, GTK_OBJECT(window));
  GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);

  gtk_widget_show_all(window);
}
