%x background camera_f inc light_f  global
%x sor_f plane_f torus_f box_f cone_f cylindre_f sphere_f 
%x pigment_f scale_f rotate_f translate_f texture_f pigment_t scale_t rotate_t translate_t 
%x operations difference_f

DIGIT	[0-9]
ALPHA	[a-zA-Z]
WORD	({ALPHA}|{DIGIT}|\$)({ALPHA}|{DIGIT}|[_.\-/$])*
NUM1	[-+]?{DIGIT}+\.?{DIGIT}*
NUM2	[-+]?{DIGIT}*\.{DIGIT}*
NUMBER	{NUM1}|{NUM2}
SPACE	[ ]+
SLASH	[\n|\r|\t|\0]
OTHER	['':!\?,`\(\)\"]
COM1	[^*]*
COM2	[^*/]*
COM3	"*"+"/"
COM4	"/""*"+
COM5	"//"
COM6	[^\n]*
AXES	[xyz]
			
VECT3  "<"{SPACE}*{NUMBER}{SPACE}*{OTHER}{SPACE}*{NUMBER}{SPACE}*{OTHER}{SPACE}*{NUMBER}{SPACE}*">"
VECT2  "<"{SPACE}*{NUMBER}{SPACE}*{OTHER}{SPACE}*{NUMBER}{SPACE}*">"
	
COLOR     {WORD}|"rgb"?{SPACE}*({VECT3}|{DIGIT})
FILTER    {NUMBER}
TYPE_TEXT {WORD}
STRING	  {OTHER}{WORD}{OTHER}
COMMENT	  {COM4}{COM2}{COM3}
COMMENT2  {SPACE}*{COM5}{COM6}{SPACE}*
SCALE	  "scale"
ROTATE	  "rotate"
TRANSLATE "translate"
TRANSF	  {SCALE}|{ROTATE}|{TRANSLATE}
OBJS	  "cone"	

%{
#include "xmlight/xmlight.h"
%}


	int		operation, objet, text, in_op = 0, tmp1, tmp2, xyz; 
	xmlDocPtr	doc;
	xmlNodePtr	tree,private,current,pigment,texture,alter;
%%

%{
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
%}

{COMMENT}
{COMMENT2}
"global_settings"({SPACE}*[\t|\n]*[\{])	{printf("\nglobal setting is detected\n"); }	BEGIN(global);
<global>"assumed_gamma"{SPACE}*{NUMBER} {
  int i, j=0;
  char ag_result[50];
  char *yycopy = strdup( yytext );
  memset(ag_result, 0, 50);
  for (i=0; !isdigit(yycopy[i]); i++);
  for (i; yycopy[i] != '\0'; i++)
    ag_result[j++] = yycopy[i];
  free (yycopy);
  printf("\tassumed gamma value: %s\n", ag_result);
  xmlSetProp(doc->root,"gamma",ag_result);}	
<global>{COMMENT}|{COMMENT2}
<global>{SLASH}|{SPACE}*
<global>"}"				BEGIN(INITIAL);
"background"({SPACE}*[\t|\n]*[\{])	{printf("\nbackground is detected\n"); }	BEGIN(background);
<background>"color"{SPACE}*{COLOR}	{
  int i, j=0;
  char b_c_result[50];
  char *b_c_copy = strdup( yytext );
  memset(b_c_result, 0, 50);
  for (i=0; b_c_copy[i] != ' '; i++);
  for (i; b_c_copy[i] != '\0'; i++)
    b_c_result[j++] = b_c_copy[i];
  free (b_c_copy);
  if (strstr(b_c_result, "rgb"))
    {
      for (i=0; b_c_result[i] == ' '; i++);
      b_c_result[i++] = '\1';
      b_c_result[i++] = '\1';
      b_c_result[i++] = '\1';
    }
  if (yytext[yyleng - 1] == '>')
    {
      for (i=0; b_c_result[i] != '<'; i++);
      b_c_result[i] ='\1';
      for (i=0; b_c_result[i] != '>'; i++);
      b_c_result[i] ='\0';
    }
  printf("\tback_color: %s\n", b_c_result); 
  xmlSetProp(doc->root,"bg",b_c_result);}
<background>{COMMENT}|{COMMENT2}
<background>{SLASH}|{SPACE}*
<background>"}"				BEGIN(INITIAL);
"light_source"({SPACE}*[\t|\n]*[\{])	{printf("\nlight is detected\n"); 
 tree=xml_light_new_char("0,0,0");
 xmlAddChild(current,tree);}	BEGIN(light_f);
<light_f>{VECT3}				{
   int i, j=0;
   char l_p_result[50];
   char *l_p_copy = strdup( yytext );
   memset(l_p_result, 0, 50);
   for (i=0; !isdigit(l_p_copy[i]); i++);
   for (i; l_p_copy[i] != '\0'; i++)
     l_p_result[j++] = l_p_copy[i];
   free (l_p_copy);
   for (i=0; l_p_result[i] != '>'; i++);
   l_p_result[i] ='\0';
   printf("\tlight pos: %s\n", l_p_result); 
   xmlSetProp(tree->childs,"location",l_p_result);}
<light_f>"color"{SPACE}+{COLOR}		{
  int i, j=0;
  char l_c_result[50];
  char *l_c_copy = strdup( yytext );
  xmlNodePtr tmp;
  memset(l_c_result, 0, 50);
  for (i=0; l_c_copy[i] != ' '; i++);
  for (i; l_c_copy[i] != '\0'; i++)
    l_c_result[j++] = l_c_copy[i];
  free (l_c_copy);
  if (strstr(l_c_result, "rgb"))
    {
      for (i=0; l_c_result[i] == ' '; i++);
      l_c_result[i++] = '\1';
      l_c_result[i++] = '\1';
      l_c_result[i++] = '\1';
    }
  if (yytext[yyleng - 1] == '>')
    {
      for (i=0; l_c_result[i] != '<'; i++);
      l_c_result[i] ='\1';
      for (i=0; l_c_result[i] != '>'; i++);
      l_c_result[i] ='\0';
    }
  printf("\tlight color: %s\n", l_c_result); 
  tmp=xmlNewNode(NULL,"COLOR");
  xmlSetProp(tmp,"value",l_c_result);
					  xmlAddChild(tree,tmp);}
<light_f>{COMMENT}|{COMMENT2}
<light_f>{SLASH}|{SPACE}*
<light_f>"}"				BEGIN(INITIAL); 
"camera"({SPACE}*[\t|\n]*[\{])		{printf("\ncamera is detected\n");
					tree=xml_camera_new_char("0,0,0","0,0,0","0,1,0","90");
					xmlAddChild(current,tree); 
}	BEGIN(camera_f);
<camera_f>"location"({SPACE}*{VECT3})|({SPACE}{NUMBER})  {
  int i, j=0;
  char c_l_result[50];
  char *c_l_copy = strdup( yytext );
  memset(c_l_result, 0, 50);
  for (i=0; !isdigit(c_l_copy[i]); i++);
  for (i; c_l_copy[i] != '\0'; i++)
    c_l_result[j++] = c_l_copy[i];
  free (c_l_copy);
  if (yytext[yyleng - 1] == '>')
    {
      for (i=0; c_l_result[i] != '>'; i++);
      c_l_result[i] ='\0';
    }
  printf("\tlocation: %s\n", c_l_result); 
  xmlSetProp(tree->childs,"location",c_l_result);}
<camera_f>"look_at"({SPACE}*{VECT3})|({SPACE}{NUMBER})	{
  int i, j=0;
  char c_l_result[50];
  char *c_l_copy = strdup( yytext );
  memset(c_l_result, 0, 50);
  for (i=0; !isdigit(c_l_copy[i]); i++);
  for (i; c_l_copy[i] != '\0'; i++)
    c_l_result[j++] = c_l_copy[i];
  free (c_l_copy);
  if (yytext[yyleng - 1] == '>')
    {
      for (i=0; c_l_result[i] != '>'; i++);
      c_l_result[i] ='\0';
    }
  printf("\tlook_at: %s\n", c_l_result);
  xmlSetProp(tree->childs,"look_at",c_l_result); }
<camera_f>"angle"{SPACE}*{NUMBER}	{
  int i, j=0;
  char c_a_result[50];
  char *c_a_copy = strdup( yytext );
  memset(c_a_result, 0, 50);
  for (i=0; !isdigit(c_a_copy[i]); i++);
  for (i; c_a_copy[i] != '\0'; i++)
    c_a_result[j++] = c_a_copy[i];
  free(c_a_copy);
  printf("\tangle: %s\n", c_a_result);
  xmlSetProp(tree->childs,"angle",c_a_result);}
<camera_f>"sky"({SPACE}*{VECT3})		{
  int i, j=0;
  char c_s_result[50];
  char *c_s_copy = strdup( yytext );
  memset(c_s_result, 0, 50);
  for (i=0; !isdigit(c_s_copy[i]); i++);
  for (i; c_s_copy[i] != '\0'; i++)
    c_s_result[j++] = c_s_copy[i];
  free (c_s_copy);
  for (i=0; c_s_result[i] != '>'; i++);
  c_s_result[i] ='\0';
  printf("\tsky vector: %s\n", c_s_result);
  xmlSetProp(tree->childs,"sky",c_s_result);}
<camera_f>{COMMENT}|{COMMENT2}
<camera_f>{SLASH}|{SPACE}*
<camera_f>"}"				BEGIN(INITIAL);
"#include"{SPACE}*			{printf("\ninclude is detected\n"); 
 tree = xmlNewNode(NULL,"INCLUDE");}	BEGIN(inc);
<inc>"\""
<inc>{WORD}"\""				{
  yytext[yyleng - 1] = '\0';
  printf("\tin : %s\n",yytext);
  xmlSetProp(tree,"file",yytext);
  xmlAddChild(current,tree);
}  BEGIN(INITIAL);				
"sor"({SPACE}*[\t|\n]*[\{])		{printf("\nsor is detected\n"); }	operation = INITIAL;	BEGIN(sor_f);
<sor_f>{DIGIT}{SPACE}*","			{
  int i, j=0;
  char s_n_result[50];
  char *s_n_copy = strdup( yytext );
  memset(s_n_result, 0, 50);
  for (i=0; (s_n_copy[i] != ' ') && (s_n_copy[i] != ','); i++)
    s_n_result[j++] = s_n_copy[i];
  free (s_n_copy);
  printf("\tnombre de point: %s\n", s_n_result);
  tree=xml_sor_new_char(s_n_result);
  xmlAddChild(current,tree);
} 
<sor_f>{VECT2}{SPACE}*","?		{
  int i, j=0;
  char s_v_result[50];
  char *s_v_copy = strdup( yytext );
  xmlNodePtr tmp;
  memset(s_v_result, 0, 50);
  for (i=0; !isdigit(s_v_copy[i]); i++);
  for (i; s_v_copy[i] != '\0'; i++)
    s_v_result[j++] = s_v_copy[i];
  free (s_v_copy);
  for (i=0; s_v_result[i] != '>'; i++);
  s_v_result[i] ='\0';
  printf("\tpoint du sor: %s\n", s_v_result); 
  tmp=xmlNewNode(NULL,"POINT");
  xmlSetProp(tmp,"value",s_v_result);
  xmlAddChild(tree,tmp);}
<sor_f>"scale"		{printf("\ttransformation of the sor\n");	objet = sor_f; BEGIN(scale_f);}
<sor_f>"rotate"		{printf("\ttransformation of the sor\n");	objet = sor_f; BEGIN(rotate_f);}
<sor_f>"translate"	{printf("\ttransformation of the sor\n");	objet = sor_f; BEGIN(translate_f);}
<sor_f>"pigment"	{printf("\tpigment\n");				objet = sor_f; BEGIN(pigment_f); }
<sor_f>"texture"	{printf("\ttexture\n");				objet = sor_f; BEGIN(texture_f); }
<sor_f>{COMMENT}|{COMMENT2}
<sor_f>{SLASH}|{SPACE}*
<sor_f>"}"				BEGIN(operation);
"plane"({SPACE}*[\t|\n]*[\{])		{printf("\nplane is detected\n"); 
 tree=xml_plane_new_char("0,0,0","0");
 xmlAddChild(current,tree);}	operation = INITIAL;	BEGIN(plane_f);
<plane_f>{VECT3}{SPACE}*","		{
  int i, j=0;
  char p_v_result[50];
  char *p_v_copy = strdup( yytext );
  memset(p_v_result, 0, 50);
  for (i=0; !isdigit(p_v_copy[i]); i++);
  for (i; p_v_copy[i] != '\0'; i++)
    p_v_result[j++] = p_v_copy[i];
  free (p_v_copy);
  for (i=0; p_v_result[i] != '>'; i++);
  p_v_result[i] ='\0';
  printf("\tvect of plane: %s\n", p_v_result); 
  xmlSetProp(tree->childs,"normal",p_v_result);}
<plane_f>{NUMBER}	{printf("\tdist from origin: %s\n", yytext);
 xmlSetProp(tree->childs,"offset",yytext);}
<plane_f>"scale"	{printf("\ttransformation of the plane\n");	objet = plane_f; BEGIN(scale_f);}
<plane_f>"rotate"	{printf("\ttransformation of the plane\n");	objet = plane_f; BEGIN(rotate_f);}
<plane_f>"translate"	{printf("\ttransformation of the plane\n");	objet = plane_f; BEGIN(translate_f);}
<plane_f>"pigment"	{printf("\tpigment\n");				objet = plane_f; BEGIN(pigment_f); }
<plane_f>"texture"	{printf("\ttexture\n");				objet = plane_f; BEGIN(texture_f); }
<plane_f>{COMMENT}|{COMMENT2}
<plane_f>{SLASH}|{SPACE}*
<plane_f>"}"				BEGIN(operation);
"torus"({SPACE}*[\t|\n]*[\{])		{printf("\ntorus is detected\n"); 
 tree=xml_torus_new_char("0","0");
 xmlAddChild(current,tree); 
}	operation = INITIAL;	BEGIN(torus_f);
<torus_f>{NUMBER}{SPACE}*","		{
  int i, j=0;
  char t_n_result[50];
  char *t_n_copy = strdup( yytext );
  xmlNodePtr temp;
  
  memset(t_n_result, 0, 50);
  for (i=0; (t_n_copy[i] != ' ') && (t_n_copy[i] != ','); i++)
    t_n_result[j++] = t_n_copy[i];
  free (t_n_copy);
  printf("\tmajor radius: %s\n", t_n_result); 
  xmlSetProp(tree->childs,"major", t_n_result);}
<torus_f>{NUMBER}	{printf("\tminor radius: %s\n", yytext);
 xmlSetProp(tree->childs,"minor", yytext); }
<torus_f>"scale"	{printf("\ttransformation of the torus\n");	objet = torus_f; BEGIN(scale_f);}
<torus_f>"rotate"	{printf("\ttransformation of the torus\n");	objet = torus_f; BEGIN(rotate_f);}
<torus_f>"translate"	{printf("\ttransformation of the torus\n");	objet = torus_f; BEGIN(translate_f);}
<torus_f>"pigment"	{printf("\tpigment\n");				objet = torus_f; BEGIN(pigment_f); }
<torus_f>"texture"	{printf("\ttexture\n");				objet = torus_f; BEGIN(texture_f); }
<torus_f>{COMMENT}|{COMMENT2}
<torus_f>{SLASH}|{SPACE}*
<torus_f>"}"				BEGIN(operation);
"box"({SPACE}*[\t|\n]*[\{])		{
  tree=xml_cube_new_char("0,0,0","0,0,0");
  xmlAddChild(current,tree);
  printf("\nbox is detected\n"); }	operation = INITIAL;	BEGIN(box_f);
<box_f>{VECT3}{SPACE}*","			{
  int i, j=0;
  char b_v_result[50];
  char *b_v_copy = strdup( yytext );
  memset(b_v_result, 0, 50);
  for (i=0; !isdigit(b_v_copy[i]); i++);
  for (i; b_v_copy[i] != '\0'; i++)
    b_v_result[j++] = b_v_copy[i];
  for (i=0; b_v_result[i] != '>'; i++);
  b_v_result[i] ='\0';
  free (b_v_copy);
  printf("\tNear lower left corner: %s\n", b_v_result); 
  xmlSetProp(tree->childs,"point1",b_v_result); }
<box_f>{VECT3}				{
  int i, j=0;
  char b_v_result[50];
  char *b_v_copy = strdup( yytext );
  memset(b_v_result, 0, 50);
  for (i=0; !isdigit(b_v_copy[i]); i++);
  for (i; b_v_copy[i] != '\0'; i++)
    b_v_result[j++] = b_v_copy[i];
  for (i=0; b_v_result[i] != '>'; i++);
  b_v_result[i] ='\0';
  free (b_v_copy);
  printf("\tFar upper right corner: %s\n", b_v_result);
  xmlSetProp(tree->childs,"point2",b_v_result);}
<box_f>"scale"		{printf("\ttransformation of the box\n");	objet = box_f; BEGIN(scale_f);}
<box_f>"rotate"		{printf("\ttransformation of the box\n");	objet = box_f; BEGIN(rotate_f);}
<box_f>"translate"	{printf("\ttransformation of the box\n");	objet = box_f; BEGIN(translate_f);}
<box_f>"pigment"	{printf("\tpigment\n");				objet = box_f; BEGIN(pigment_f); }
<box_f>"texture"	{printf("\ttexture\n");				objet = box_f; BEGIN(texture_f); }
<box_f>{COMMENT}|{COMMENT2}
<box_f>{SLASH}|{SPACE}*
<box_f>"}"				BEGIN(operation);
"cone"({SPACE}*[\t|\n]*[\{])		{printf("\ncone is detected\n");
 tree=xml_cone_new_char("0,0,0","0","0,0,0","0", 0);
 xmlAddChild(current,tree);}	operation = INITIAL;	BEGIN(cone_f);
<cone_f>{VECT3}{SPACE}*","		{
  int i, j=0;
  char c_v_result[50];
  char *c_v_copy = strdup( yytext );
  memset(c_v_result, 0, 50);
  for (i=0; !isdigit(c_v_copy[i]); i++);
  for (i; c_v_copy[i] != '\0'; i++)
    c_v_result[j++] = c_v_copy[i];
  for (i=0; c_v_result[i] != '>'; i++);
  c_v_result[i] ='\0';
  free (c_v_copy);
  printf("\tpoint of the cone: %s\n", c_v_result); 
  if (tmp1)
    xmlSetProp(tree->childs,"center1",c_v_result);
  else
    xmlSetProp(tree->childs,"center2",c_v_result);
  tmp1=!tmp1;
  
}
<cone_f>{NUMBER}	{printf("\tradius of the point: %s\n", yytext); 
 if (tmp2)
   xmlSetProp(tree->childs,"radius1", yytext);
 else
   xmlSetProp(tree->childs,"radius2", yytext);
 tmp2=!tmp2;}
<cone_f>"open"		{printf("\tcone is open\n"); 
 xmlSetProp(tree->childs,"open","open");}
<cone_f>"scale"		{printf("\ttransformation of the cone\n");	objet = cone_f; BEGIN(scale_f);}
<cone_f>"rotate"	{printf("\ttransformation of the cone\n");	objet = cone_f; BEGIN(rotate_f);}
<cone_f>"translate"	{printf("\ttransformation of the cone\n");	objet = cone_f; BEGIN(translate_f);}
<cone_f>"pigment"	{printf("\tpigment\n");				objet = cone_f; BEGIN(pigment_f); }
<cone_f>"texture"	{printf("\ttexture\n");				objet = cone_f; BEGIN(texture_f); }
<cone_f>{COMMENT}|{COMMENT2}
<cone_f>{SLASH}|{SPACE}*
<cone_f>"}"				BEGIN(operation);
"cylinder"({SPACE}*[\t|\n]*[\{])	{printf("\ncylindre is detected\n"); 
 tree=xml_cone_new_char("0,0,0","0","0,0,0","0", 0);
 xmlAddChild(current,tree);}	operation = INITIAL;	BEGIN(cylindre_f);
<cylindre_f>{VECT3}			{
   int i, j=0;
   char c_v_result[50];
   char *c_v_copy = strdup( yytext );
   memset(c_v_result, 0, 50);
   for (i=0; !isdigit(c_v_copy[i]); i++);
   for (i; c_v_copy[i] != '\0'; i++)
     c_v_result[j++] = c_v_copy[i];
   for (i=0; c_v_result[i] != '>'; i++);
   c_v_result[i] ='\0';
   free (c_v_copy);
   printf("\tcylindre first point: %s\n", c_v_result); 
   xmlSetProp (tree->childs,"center1",c_v_result);}
<cylindre_f>{VECT3}{SPACE}*","		{
  int i, j=0;
  char c_v_result[50];
  char *c_v_copy = strdup( yytext );
  memset(c_v_result, 0, 50);
  for (i=0; !isdigit(c_v_copy[i]); i++);
  for (i; c_v_copy[i] != '\0'; i++)
    c_v_result[j++] = c_v_copy[i];
  for (i=0; c_v_result[i] != '>'; i++);
  c_v_result[i] ='\0';
  free (c_v_copy);
  printf("\tcylindre second point: %s\n", c_v_result); 
  xmlSetProp(tree->childs,"center2",c_v_result);}
<cylindre_f>{NUMBER}			{printf("\tcylindre radius: %s\n", yytext); 
 xmlSetProp(tree->childs,"radius1",yytext);
 xmlSetProp(tree->childs,"radius2",yytext);}
<cylindre_f>"open"	{printf("\tcylindre is open\n"); 
 xmlSetProp(tree->childs,"open","open");}
<cylindre_f>"scale"	{printf("\ttransformation of the cylindre\n");objet = cylindre_f; BEGIN(scale_f);}
<cylindre_f>"rotate"	{printf("\ttransformation of the cylindre\n");objet = cylindre_f; BEGIN(rotate_f);}
<cylindre_f>"translate"	{printf("\ttransformation of the cylindre\n");objet = cylindre_f; BEGIN(translate_f);}
<cylindre_f>"pigment"	{printf("\tpigment\n");	objet = cylindre_f; BEGIN(pigment_f); }
<cylindre_f>"texture"	{printf("\ttexture\n");	objet = cylindre_f; BEGIN(texture_f); }
<cylindre_f>{COMMENT}|{COMMENT2}
<cylindre_f>{SLASH}|{SPACE}*
<cylindre_f>"}"				BEGIN(operation);
"sphere"({SPACE}*[\t|\n]*[\{])		{printf("\nsphere is detected\n");
 tree=xml_sphere_new_char("0,0,0","0");
 xmlAddChild(current,tree);}	 operation = INITIAL;	BEGIN(sphere_f);
<sphere_f>{VECT3}{SPACE}*","		{int i, j=0;
 char s_v_result[50];
 char *s_v_copy = strdup( yytext );
 memset(s_v_result, 0, 50);
 for (i=0; !isdigit(s_v_copy[i]); i++);
 for (i; s_v_copy[i] != '\0'; i++)
   s_v_result[j++] = s_v_copy[i];
 for (i=0; s_v_result[i] != '>'; i++);
 s_v_result[i] ='\0';
 free (s_v_copy);
 printf("\tcenter of the sphere: %s\n", s_v_result); 
 xmlSetProp(tree->childs,"center",s_v_result);}
<sphere_f>{NUMBER}			{printf("\tradius of the sphere: %s\n", yytext); 
 xmlSetProp(tree->childs,"radius",yytext);}
<sphere_f>"scale"	{printf("\ttransformation of the sphere\n");	objet = sphere_f; BEGIN(scale_f);}
<sphere_f>"rotate"	{printf("\ttransformation of the sphere\n");	objet = sphere_f; BEGIN(rotate_f);} 
<sphere_f>"translate"	{printf("\ttransformation of the sphere\n");	objet = sphere_f; BEGIN(translate_f);}
<sphere_f>"pigment"	{printf("\tpigment\n");				objet = sphere_f; BEGIN(pigment_f); }
<sphere_f>"texture"	{printf("\ttexture\n");				objet = sphere_f; BEGIN(texture_f); }
<sphere_f>{COMMENT}|{COMMENT2}
<sphere_f>{SLASH}|{SPACE}*
<sphere_f>"}"				BEGIN(operation);
<texture_f>"{"				{texture=xml_texture_add(tree,"arf");}
<texture_f>"scale"			{printf("\t\ttransformation of the texture\n");	
 alter=xml_object_alter_new_char(texture,"scale","0,0,0"); 
 text = texture_f;	BEGIN(scale_t);}
<texture_f>"rotate"			{printf("\t\ttransformation of the texture\n");	 
 alter=xml_object_alter_new_char(texture,"rotate","0,0,0");
 text = texture_f;	BEGIN(rotate_t);}
<texture_f>"translate"			{printf("\t\ttransformation of the texture\n");	
 alter=xml_object_alter_new_char(texture,"translate","0,0,0");
 text = texture_f;	BEGIN(translate_t);}
<texture_f>"pigment"			{printf("\t\tpigment\n");			 text = texture_f;	BEGIN(pigment_t); }
<texture_f>{WORD}				{printf("\t\ttype of texture: %s\n", yytext); 
 xmlSetProp(texture,"value",yytext);}
<texture_f>{COMMENT}|{COMMENT2}
<texture_f>{SLASH}|{SPACE}*
<texture_f>"}"				BEGIN(objet);
<scale_t>({VECT3})|(({NUMBER}|[-+]?{AXES})"*"({NUMBER}|[-+]?{AXES}))  {
  char r_v_result[50];
  char *tmp_result, *tmp_result2;
  int i, j=0;
  char *r_v_copy = strdup ( yytext );
  memset(r_v_result, 0, 50);
  if (yytext[yyleng - 1] == '>')
    for (i=1; r_v_copy[i] != '>'; i++)
      r_v_result[j++] = r_v_copy[i];
  else
    {
      if (r_v_copy[0] == '+' || r_v_copy[0] == '-')
	if (r_v_copy[1] == 'x' || r_v_copy[1] == 'y'
	    || r_v_copy[1] == 'z')
	  {
	    for (i=3; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0", NULL);
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0", NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result, NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
      else
	if (r_v_copy[0] == 'x' || r_v_copy[0] == 'y'
	    || r_v_copy[0] == 'z')
	  {
	    for (i=2; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,",r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,",r_v_result,NULL);
	  }
      memset(r_v_result, 0, 50);
      i = 0;
      while (*tmp_result2 != '\0')
	r_v_result[i++] = *tmp_result2++;
      r_v_result[i] = '\0';
    }
  printf("\t\tscale: %s\n", r_v_result);
  xmlSetProp(alter,"value",r_v_result);
}  BEGIN(text);
<rotate_t>({VECT3})|(({NUMBER}|[-+]?{AXES})"*"({NUMBER}|[-+]?{AXES}))  { 
  char r_v_result[50];
  char *tmp_result, *tmp_result2;
  int i, j=0;
  char *r_v_copy = strdup ( yytext );
  memset(r_v_result, 0, 50);
  if (yytext[yyleng - 1] == '>')
    for (i=1; r_v_copy[i] != '>'; i++)
      r_v_result[j++] = r_v_copy[i];
  else
    {
      if (r_v_copy[0] == '+' || r_v_copy[0] == '-')
	if (r_v_copy[1] == 'x' || r_v_copy[1] == 'y'
	    || r_v_copy[1] == 'z')
	  {
	    for (i=3; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0", NULL);
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0", NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result, NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
      else
	if (r_v_copy[0] == 'x' || r_v_copy[0] == 'y'
	    || r_v_copy[0] == 'z')
	  {
	    for (i=2; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,",r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,",r_v_result,NULL);
	  }
      memset(r_v_result, 0, 50);
      i = 0;
      while (*tmp_result2 != '\0')
	r_v_result[i++] = *tmp_result2++;
      r_v_result[i] = '\0';
    }
  printf("\t\trotate: %s\n", r_v_result);
  xmlSetProp(alter,"value",r_v_result);
} BEGIN(text);
<translate_t>({VECT3})|(({NUMBER}|[-+]?{AXES})"*"({NUMBER}|[-+]?{AXES})) {
  char r_v_result[50];
  char *tmp_result, *tmp_result2;
  int i, j=0;
  char *r_v_copy = strdup ( yytext );
  memset(r_v_result, 0, 50);
  if (yytext[yyleng - 1] == '>')
    for (i=1; r_v_copy[i] != '>'; i++)
      r_v_result[j++] = r_v_copy[i];
  else
    {
      if (r_v_copy[0] == '+' || r_v_copy[0] == '-')
	if (r_v_copy[1] == 'x' || r_v_copy[1] == 'y'
	    || r_v_copy[1] == 'z')
	  {
	    for (i=3; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0", NULL);
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0", NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result, NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
      else
	if (r_v_copy[0] == 'x' || r_v_copy[0] == 'y'
	    || r_v_copy[0] == 'z')
	  {
	    for (i=2; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,",r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,",r_v_result,NULL);
	  }
      memset(r_v_result, 0, 50);
      i = 0;
      while (*tmp_result2 != '\0')
	r_v_result[i++] = *tmp_result2++;
      r_v_result[i] = '\0';
    }
  printf("\t\trotate: %s\n", r_v_result);
  xmlSetProp(alter,"value",r_v_result);
}BEGIN(text);
<pigment_t>"{"
<pigment_t>"checker"{SPACE}+"color"{SPACE}+{COLOR}{SPACE}+"color"{SPACE}+{COLOR} {
  int i, k, j=0;
  char p_c_result[50];
  char *p_c_copy = strdup( yytext );
  xmlNodePtr tmp1,tmp2;
  tmp1=xmlNewNode(NULL,"CHECKER");
  memset(p_c_result, 0, 50);
  printf("\t\t\tchecker colors: ");
  
  for (i=0; p_c_copy[i] != ' '; i++);
  for (i; !isalpha(p_c_copy[i]); i++);
  for (i; p_c_copy[i] != ' '; i++);
  for (i; p_c_copy[i] == ' '; i++);
  for (i; p_c_copy[i] != ' '; i++)
    p_c_result[j++] = p_c_copy[i];
  if (strstr(p_c_result, "rgb"))
    {
      for (k=0; p_c_result[k] == ' '; k++);
      p_c_result[k++] = '\1';
      p_c_result[k++] = '\1';
      p_c_result[k++] = '\1';
    }
  if (yytext[yyleng - 1] == '>')
    {
      for (k=0; p_c_result[k] != '<'; k++);
      p_c_result[k] ='\1';
      for (k=0; p_c_result[k] != '>'; k++);
      p_c_result[k] ='\0';
    }
  printf("[ color1: %s", p_c_result);
  tmp2=xmlNewNode(NULL,"COLOR");
  xmlSetProp(tmp2,"value",p_c_result);
  xmlAddChild(tmp1,tmp2);
  memset(p_c_result, 0, 50);
  for (i; !isalpha(p_c_copy[i]); i++);
  for (i; p_c_copy[i] != ' '; i++);
  for (i; p_c_copy[i] != '\0'; i++)
    p_c_result[j++] = p_c_copy[i];
  free (p_c_copy);
  if (strstr(p_c_result, "rgb"))
    {
      for (k=0; p_c_result[k] == ' '; k++);
      p_c_result[k++] = '\1';
      p_c_result[k++] = '\1';
      p_c_result[k++] = '\1';
    }
  if (yytext[yyleng - 1] == '>')
    {
      for (k=0; p_c_result[k] != '<'; k++);
      p_c_result[i] ='\1';
      for (k=0; p_c_result[k] != '>'; k++);
      p_c_result[k] ='\0';
    }
  printf(" color2: %s ]\n", p_c_result);
  tmp2=xmlNewNode(NULL,"COLOR");
  xmlSetProp(tmp2,"value",p_c_result);
  xmlAddChild(tmp1,tmp2); 
  xmlAddChild(texture,tmp1);
} 

<pigment_t>"color"{SPACE}+{COLOR}       { 
  int i, j=0;
  char p_c_result[50];
  char *p_c_copy = strdup( yytext );
  xmlNodePtr tmp;
  memset(p_c_result, 0, 50);
  for (i=0; p_c_copy[i] != ' '; i++);
  for (i; p_c_copy[i] != '\0'; i++)
    p_c_result[j++] = p_c_copy[i];
  free (p_c_copy);
  if (strstr(p_c_result, "rgb"))
    {
      for (i=0; p_c_result[i] == ' '; i++);
      p_c_result[i++] = '\1';
      p_c_result[i++] = '\1';
      p_c_result[i++] = '\1';
    }
  if (yytext[yyleng - 1] == '>')
    {
      for (i=0; p_c_result[i] != '<'; i++);
      p_c_result[i] ='\1';
      for (i=0; p_c_result[i] != '>'; i++);
      p_c_result[i] ='\0';
    }
  printf("\t\t\tcolor: %s\n", p_c_result); 
  tmp=xmlNewNode(NULL,"COLOR");
  xmlSetProp(tmp,"value",p_c_result);
  xmlAddChild(texture,tmp);
}
<pigment_t>"filter"{SPACE}+{NUMBER}	{ 
  int i, j=0;
  char p_f_result[50];
  char *p_f_copy = strdup( yytext );
  xmlNodePtr tmp;
  memset(p_f_result, 0, 50);
  for (i=0; !isdigit(p_f_copy[i]); i++);
  for (i; p_f_copy[i] != '\0'; i++)
    p_f_result[j++] = p_f_copy[i];
  free (p_f_copy);
  printf("\t\t\tfilter: %s\n", p_f_result); 
  tmp=xmlNewNode(NULL,"FILTER");
  xmlSetProp(tmp,"value",p_f_result);
  xmlAddChild(texture,tmp);
}
<pigment_t>{COMMENT}|{COMMENT2}
<pigment_t>{SLASH}|{SPACE}*
<pigment_t>"}"				BEGIN(text);
<scale_f>({VECT3})|(({NUMBER}|[-+]?{AXES})"*"({NUMBER}|[-+]?{AXES}))    {
  char r_v_result[50];
  char *tmp_result, *tmp_result2;
  int i, j=0;
  char *r_v_copy = strdup ( yytext );
  memset(r_v_result, 0, 50);
  if (yytext[yyleng - 1] == '>')
    for (i=1; r_v_copy[i] != '>'; i++)
      r_v_result[j++] = r_v_copy[i];
  else
    {
      if (r_v_copy[0] == '+' || r_v_copy[0] == '-')
	if (r_v_copy[1] == 'x' || r_v_copy[1] == 'y'
	    || r_v_copy[1] == 'z')
	  {
	    for (i=3; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0", NULL);
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0", NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result, NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
      else
	if (r_v_copy[0] == 'x' || r_v_copy[0] == 'y'
	    || r_v_copy[0] == 'z')
	  {
	    for (i=2; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,",r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,",r_v_result,NULL);
										}
      memset(r_v_result, 0, 50);
      i = 0;
      while (*tmp_result2 != '\0')
	r_v_result[i++] = *tmp_result2++;
      r_v_result[i] = '\0';
    }
  printf("\t\trotate: %s\n", r_v_result);
  xml_object_alter_new_char(tree,"scale",r_v_result);} BEGIN(objet);
<rotate_f>({VECT3})|(({NUMBER}|[-+]?{AXES})"*"({NUMBER}|[-+]?{AXES}))   {
  char r_v_result[50];
  char *tmp_result, *tmp_result2;
  int i, j=0;
  char *r_v_copy = strdup ( yytext );
  memset(r_v_result, 0, 50);
  if (yytext[yyleng - 1] == '>')
    for (i=1; r_v_copy[i] != '>'; i++)
      r_v_result[j++] = r_v_copy[i];
  else
    {
      if (r_v_copy[0] == '+' || r_v_copy[0] == '-')
	if (r_v_copy[1] == 'x' || r_v_copy[1] == 'y'
	    || r_v_copy[1] == 'z')
	  {
	    for (i=3; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0", NULL);
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0", NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result, NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
      else
	if (r_v_copy[0] == 'x' || r_v_copy[0] == 'y'
	    || r_v_copy[0] == 'z')
	  {
	    for (i=2; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,",r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,",r_v_result,NULL);
	  }
      memset(r_v_result, 0, 50);
      i = 0;
      while (*tmp_result2 != '\0')
	r_v_result[i++] = *tmp_result2++;
      r_v_result[i] = '\0';
    }
  printf("\t\trotate: %s\n", r_v_result);
  xml_object_alter_new_char(tree,"rotate",r_v_result); } BEGIN(objet);
<translate_f>({VECT3})|(({NUMBER}|[-+]?{AXES})"*"({NUMBER}|[-+]?{AXES}))	{ 
  char r_v_result[50];
  char *tmp_result, *tmp_result2;
  int i, j=0;
  char *r_v_copy = strdup ( yytext );
  memset(r_v_result, 0, 50);
  if (yytext[yyleng - 1] == '>')
    for (i=1; r_v_copy[i] != '>'; i++)
      r_v_result[j++] = r_v_copy[i];
  else
    {
      if (r_v_copy[0] == '+' || r_v_copy[0] == '-')
	if (r_v_copy[1] == 'x' || r_v_copy[1] == 'y'
	    || r_v_copy[1] == 'z')
	  {
	    for (i=3; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0", NULL);
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0", NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result, NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
      else
	if (r_v_copy[0] == 'x' || r_v_copy[0] == 'y'
	    || r_v_copy[0] == 'z')
	  {
	    for (i=2; r_v_copy[i] != '\0'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,", r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,", r_v_result,NULL);
	  }
	else
	  {
	    for (i=0; r_v_copy[i] != '*'; i++)
	      r_v_result[j++] = r_v_copy[i];
	    if (strstr(r_v_copy, "x"))
	      tmp_result2 = g_strconcat(r_v_result, ",0", ",0",NULL); 
	    if (strstr(r_v_copy, "y"))
	      tmp_result2 = g_strconcat("0,",r_v_result, ",0",NULL);
	    if (strstr(r_v_copy, "z"))
	      tmp_result2 = g_strconcat("0,", "0,",r_v_result,NULL);
	  }
      memset(r_v_result, 0, 50);
      i = 0;
      while (*tmp_result2 != '\0')
	r_v_result[i++] = *tmp_result2++;
      r_v_result[i] = '\0';
    }
  printf("\t\trotate: %s\n", r_v_result);
  xml_object_alter_new_char(tree,"translate",r_v_result);} BEGIN(objet);
<pigment_f>"{"
<pigment_f>"checker"{SPACE}+"color"{SPACE}+{COLOR}{SPACE}+"color"{SPACE}+{COLOR}	{
  int i, k, j=0;
  char p_c_result[50];
  char *p_c_copy = strdup( yytext );
  xmlNodePtr tmp;
  memset(p_c_result, 0, 50);
  printf("\t\t\tchecker colors: ");
  pigment=xmlNewNode(NULL,"CHECKER");
  
  for (i=0; p_c_copy[i] != ' '; i++);
  for (i; !isalpha(p_c_copy[i]); i++);
  for (i; p_c_copy[i] != ' '; i++);
  for (i; p_c_copy[i] == ' '; i++);
  for (i; p_c_copy[i] != ' '; i++)
    p_c_result[j++] = p_c_copy[i];
  if (strstr(p_c_result, "rgb"))
    {
      for (k=0; p_c_result[k] == ' '; k++);
      p_c_result[k++] = '\1';
      p_c_result[k++] = '\1';
										       p_c_result[k++] = '\1';
    }
  if (yytext[yyleng - 1] == '>')
    {
      for (k=0; p_c_result[k] != '<'; k++);
      p_c_result[k] ='\1';
      for (k=0; p_c_result[k] != '>'; k++);
      p_c_result[k] ='\0';
    }
  printf("[ color1: %s", p_c_result);
  tmp=xmlNewNode(NULL,"COLOR");
  xmlSetProp(tmp,"value",p_c_result);
  xmlAddChild(pigment,tmp);
  memset(p_c_result, 0, 50);
  j = 0;
  for (i; !isalpha(p_c_copy[i]); i++);
  for (i; p_c_copy[i] != ' '; i++);
  for (i; p_c_copy[i] != '\0'; i++)
    p_c_result[j++] = p_c_copy[i];
  free (p_c_copy);
  if (strstr(p_c_result, "rgb"))
    {
      for (k=0; p_c_result[k] == ' '; k++);
      p_c_result[k++] = '\1';
      p_c_result[k++] = '\1';
      p_c_result[k++] = '\1';
    }
  if (yytext[yyleng - 1] == '>')
    {
      for (k=0; p_c_result[k] != '<'; k++);
      p_c_result[i] ='\1';
      for (k=0; p_c_result[k] != '>'; k++);
										       p_c_result[k] ='\0';
    }
  printf(" color2: %s]\n", p_c_result); 
  tmp=xmlNewNode(NULL,"COLOR");
  xmlSetProp(tmp,"value",p_c_result);
  xmlAddChild(pigment,tmp);
  xmlAddChild(tree,pigment);}
<pigment_f>"color"{SPACE}+{COLOR}	        {
  int i, j=0;
  char p_c_result[50];
  char *p_c_copy = strdup( yytext );
  xmlNodePtr tmp;
  memset(p_c_result, 0, 50);
  for (i=0; p_c_copy[i] != ' '; i++);
  for (i; p_c_copy[i] != '\0'; i++)
    p_c_result[j++] = p_c_copy[i];
  free (p_c_copy);
  if (strstr(p_c_result, "rgb"))
    {
      for (i=0; p_c_result[i] == ' '; i++);
      p_c_result[i++] = '\1';
      p_c_result[i++] = '\1';
      p_c_result[i++] = '\1';
    }
  if (yytext[yyleng - 1] == '>')
    {
      for (i=0; p_c_result[i] != '<'; i++);
      p_c_result[i] ='\1';
      for (i=0; p_c_result[i] != '>'; i++);
      p_c_result[i] ='\0';
    }
  printf("\t\tcolor: %s\n", p_c_result); 
  tmp=xmlNewNode(NULL,"COLOR");
  xmlSetProp(tmp,"value",p_c_result);
  xmlAddChild(tree,tmp);}
<pigment_f>"filter"{SPACE}+{NUMBER}	{ 
  int i, j=0;
  char p_f_result[50];
  char *p_f_copy = strdup( yytext );
  xmlNodePtr tmp;
  memset(p_f_result, 0, 50);
  for (i=0; !isdigit(p_f_copy[i]); i++);
  for (i; p_f_copy[i] != '\0'; i++)
    p_f_result[j++] = p_f_copy[i];
  free (p_f_copy);
  printf("\t\tfilter: %s\n", p_f_result);  
  tmp=xmlNewNode(NULL,"FILTER");
  xmlSetProp(tmp,"value",p_f_result);
  xmlAddChild(tree,tmp);}
<pigment_f>{COMMENT}|{COMMENT2}
<pigment_f>{SLASH}|{SPACE}*
<pigment_f>"}"				BEGIN(objet); 
"difference"({SPACE}*[\t|\n]*[\{])	{printf("\n--- operation: difference ---\n"); in_op++;
 tree=xml_csg_new_char("difference");
 xmlAddChild(current,tree);
 current=tree;}	        operation = operations;	BEGIN(operations);
"union"({SPACE}*[\t|\n]*[\{])	        {printf("\n--- operation: union ---\n");in_op++;
 tree=xml_csg_new_char("union");
 xmlAddChild(current,tree);
 current=tree;}        operation = operations;	BEGIN(operations);
"merge"({SPACE}*[\t|\n]*[\{])	        {printf("\n--- operation: merge ---\n");in_op++;
 tree=xml_csg_new_char("merge");
 xmlAddChild(current,tree);
 current=tree;}        operation = operations;	BEGIN(operations);
"intersection"({SPACE}*[\t|\n]*[\{])	{printf("\n--- operation: intersection ---\n");in_op++;
 tree=xml_csg_new_char("intersection");
 xmlAddChild(current,tree);
 current=tree;} operation = operations;	BEGIN(operations);
<operations>"sphere"({SPACE}*[\t|\n]*[\{])		{printf("\nsphere is detected\n");
 tree=xml_sphere_new_char("0,0,0","0");
 xmlAddChild(current,tree);}	BEGIN(sphere_f);
<operations>"cone"({SPACE}*[\t|\n]*[\{])		{printf("\ncone is detected\n");
 tree=xml_cone_new_char("0,0,0","0","0,0,0","0",0);
 xmlAddChild(current,tree);}	BEGIN(cone_f);
<operations>"cylindre"({SPACE}*[\t|\n]*[\{])		{printf("\ncylinder is detected\n");
 tree=xml_cone_new_char("0,0,0","0","0,0,0","0",0);
 xmlAddChild(current,tree);}	BEGIN(cylindre_f);
<operations>"box"({SPACE}*[\t|\n]*[\{])			{printf("\nbox is detected\n");
 tree=xml_cube_new_char("0,0,0","0,0,0");
 xmlAddChild(current,tree);}	BEGIN(box_f);
<operations>"plane"({SPACE}*[\t|\n]*[\{])		{printf("\nplane is detected\n");
 tree=xml_plane_new_char("0,0,0","0");
 xmlAddChild(current,tree);}	BEGIN(plane_f);
<operations>"sor"({SPACE}*[\t|\n]*[\{])			{printf("\nsor is detected\n");}	BEGIN(sor_f);
<operations>"torus"({SPACE}*[\t|\n]*[\{])		{printf("\ntorus is detected\n");
 tree=xml_torus_new_char("0","0");
 xmlAddChild(current,tree);}	BEGIN(torus_f);
<operations>"pigment"({SPACE}*[\t|\n]*[\{])		{printf("\npigment is detected\n");}	objet = difference_f; BEGIN(pigment_f);
<operations>"texture"({SPACE}*[\t|\n]*[\{])		{printf("\ntexture is detected\n");}	objet = difference_f; BEGIN(texture_f);
<operations>{COMMENT}|{COMMENT2}
<operations>{SLASH}|{SPACE}*
<operations>"}"				{
  in_op = in_op - 1;
  if (in_op)
    {
      printf("\n... end of operation ...\n"); 
      operation = operations;
    }
  else
    {
      printf("\n--- end of operation ---\n"); 
      operation = INITIAL;
    }
  if (current->parent!=NULL)
    current=current->parent;
} BEGIN(operation);
<operations>"difference"({SPACE}*[\t|\n]*[\{])	{printf("\n... operation: difference ...\n"); in_op++; 
 tree=xml_csg_new_char("difference");
 xmlAddChild(current,tree);
 current=tree;}  BEGIN(operations);
<operations>"union"({SPACE}*[\t|\n]*[\{])        {printf("\n... operation: union ...\n"); in_op++;
 tree=xml_csg_new_char("union");
 xmlAddChild(current,tree);
 current=tree;}   BEGIN(operations);
<operations>"merge"({SPACE}*[\t|\n]*[\{])        {printf("\n... operation: merge ...\n"); in_op++;
 tree=xml_csg_new_char("merge");
 xmlAddChild(current,tree);
 current=tree;}    BEGIN(operations);
<operations>"intersection"({SPACE}*[\t|\n]*[\{]) {printf("\n... operation: intersection ...\n"); in_op++;
 tree=xml_csg_new_char("intersection");
 xmlAddChild(current,tree);
 current=tree;} BEGIN(operations);
{SLASH}|{SPACE}*
<<EOF>>					{printf("\n*** parsing terminated... ***\n"); yyterminate ();}
%%



int main (int argc, char **argv)
{
  VECT3D *vect;
  tmp1=1; tmp2=1;
  if (argc > 1)
    yyin = fopen(argv[1], "r");
  else
    {
      printf ("pas de fichier selectionner\n");
      return -1;
    }
  doc = xml_scene_new("Test","Ludo",NULL,"test.xml");
  current=doc->root;
  yylex();
  printf ("\n");  
  xml_scene_save(doc,0);
  return 0; 
}

