#include <stdlib.h>
#include <glib.h>
#include <tree.h>
#include <parser.h>
#include "../types/tree.h"
#include "scene.h"
#include "cube.h"
#include "utils.h"

xmlNodePtr xml_object_add_alter(xmlNodePtr tree, T_alter *alter)
{
  xmlNodePtr subtree, tree2, tree3;

  if (alter==NULL) return NULL;
  if (tree==NULL) return NULL;
  if(tree->childs==NULL)
    tree2=xmlNewChild(tree,NULL,"TRANSFORM",NULL);
  else
    {
      tree2=tree->childs;
      while (tree2->next!=NULL)
	{
	  if (strcmp(tree2->name,"TRANSFORM"))
	    {
	      subtree=xmlNewChild(tree2->next,NULL,
				  alttype2str(alter->type), NULL);
	      xmlSetProp(subtree,"value",
			 vect3d2str(alter->value));
	      return;
	    }
	  tree2=tree2->next;
	}
      tree2=xmlNewChild(tree,NULL,"TRANSFORM",NULL);
      
    }
  
  subtree=xmlNewChild(tree2,NULL, alttype2str(alter->type), NULL);
  xmlSetProp(subtree,"value",vect3d2str(alter->value));

  return subtree;
}

xmlNodePtr xml_object_alter_new_char(xmlNodePtr tree, char *type,
				     char *value)
{
 xmlNodePtr subtree, tree2;
 
  if(tree->childs==NULL)
    tree2=xmlNewChild(tree,NULL,"TRANSFORM",NULL);
  else
    {
      tree2=tree->childs;
      while (tree2->next!=NULL)
	{
	  tree2=tree2->next;
	  if (!strcmp(tree2->name,"TRANSFORM"))
	    {
	      subtree=xmlNewNode(NULL, type);
	      xmlSetProp(subtree,"value", value);
	      xmlAddChild(tree2,subtree);
	      return;
	    }
	  
	}
      puts(tree2->name);
      tree2=xmlNewChild(tree,NULL,"TRANSFORM",NULL);
    }
  subtree=xmlNewNode(NULL, type);
  xmlSetProp(subtree,"value", value);
  xmlAddChild(tree2,subtree);
  return subtree;
}

xmlNodePtr xml_object_alter_new(xmlNodePtr tree, T_alter_type type,
			    VECT3D *value)
{
 xmlNodePtr subtree, tree2, tree3;

  if(tree->childs==NULL)
    tree2=xmlNewChild(tree,NULL,"TRANSFORM",NULL);
  else
    {
      tree2=tree->childs;
      while (tree2->next!=NULL)
	{
	  if (strcmp(tree2->name,"TRANSFORM"))
	    {
	      subtree=xmlNewChild(tree2->next,NULL,
				  alttype2str(type), NULL);
	      xmlSetProp(subtree,"value",
			 vect3d2str(value));
	      return;
	    }
	  tree2=tree2->next;
	}
      tree2=xmlNewChild(tree,NULL,"TRANSFORM",NULL);
      
    }
  
  subtree=xmlNewChild(tree2,NULL, alttype2str(type), NULL);
  xmlSetProp(subtree,"value",vect3d2str(value));

  return subtree;
}

int xml_object_is_alter(xmlNodePtr tree)
{

  if(tree==NULL) return 0;
  if(!strcmp(tree->name,"TRANSFORM"))
    {
      return 1;
    }  
  else
    {
      return 0;
    }
}

xmlNodePtr xml_object_get_alter(xmlNodePtr tree)
{
  xmlNodePtr tree2;

  if (xml_object_is_alter(tree))
    {
      if (tree->next!=NULL)
	tree2=tree->next;
    }
  else
    {  
      if (tree->childs!=NULL)
	tree2=tree->childs;
    }

  while ((tree2->next!=NULL))
    {
      if (xml_object_is_alter(tree2))
	return tree2;
      else
	tree2=tree2->next;
    }
  
  return NULL;
}
