#include <tree.h>
#include <parser.h>
#include "../types/tree.h"

xmlNodePtr add_child(xmlNodePtr father, xmlNodePtr child)
{
  xmlAddChild(father,child);
  return child;
}

xmlNodePtr del_child(xmlNodePtr child)
{
  xmlNodePtr father;
  
  father=child->parent;

  xmlFreeNode(child);

  return father;
}

int parse_tree_recur(xmlNodePtr tree,
		     void (*prefix)(xmlNodePtr tree),
		     void (*infix)(xmlNodePtr))
{
  if (tree==NULL) return 0;
  
  if (prefix!=NULL)  (*prefix)(tree);

  if ((tree->childs)!=NULL)
    {
      xmlNodePtr next;
      
      parse_tree_recur(tree->childs,prefix,infix);
      if (infix!=NULL)  (*infix)(tree);
      next=tree->childs->next;

      while (next!=NULL)
	{
	  parse_tree_recur(next,prefix,infix);
	  if (infix!=NULL)  (*infix)(tree);
	  next=next->next;
	}
    }
}

void parse_tree(xmlDocPtr doc, 
		void (*prefix)(xmlNodePtr tree),
		void (*infix)(xmlNodePtr))
{
  xmlNodePtr root;
  
  root=xmlDocGetRootElement(doc);
  
  parse_tree_recur(root,prefix,infix);
}
  
  












