#include <stdlib.h>
#include <glib.h>
#include <tree.h>
#include <parser.h>
#include "../types/tree.h"
#include "scene.h"
#include "utils.h"
#include "object.h"

xmlNodePtr xml_color_add(xmlNodePtr tree, VECT3D *rgb, char *name)
{
  xmlNodePtr subtree;
  
  subtree=xmlNewNode(NULL,"COLOR");
  if (rgb!=NULL)
    {
      xmlSetProp(subtree,"value",(char *)vect3d2str(rgb));
      xmlSetProp(subtree,"type","rgb");
    }
  else
    {
      xmlSetProp(subtree,"value",name);
      xmlSetProp(subtree,"type","litteral");
    }
  
  xmlAddChild(tree,subtree);
  return subtree;
}

int xml_color_is_rgb(xmlNodePtr tree)
{
  return (strcmp(xmlGetProp(tree,"type"),"rgb")); 
}

int xml_color_is_litteral(xmlNodePtr tree)
{
  return (strcmp(xmlGetProp(tree,"type"),"litteral")); 
}

VECT3D *xml_color_get_rgb(xmlNodePtr tree)
{
  return str2vect3d(xmlGetProp(tree,"rgb"));

}

char *xml_color_get_litteral(xmlNodePtr tree)
{
  return xmlGetProp(tree,"litteral");
}

xmlNodePtr xml_color_set_rgb(xmlNodePtr tree, VECT3D *rgb)
{
  xmlSetProp (tree,"value",(char *)vect3d2str(rgb));
  xmlSetProp (tree,"type","rgb");
  return tree;
}

xmlNodePtr xml_color_set_litteral(xmlNodePtr tree, char *name)
{
  xmlSetProp(tree,"value",name);
  xmlSetProp(tree,"type","litteral");
  return tree;
}
