#include <stdlib.h>
#include <glib.h>
#include <tree.h>
#include <parser.h>
#include "../types/tree.h"
#include "scene.h"
#include "utils.h"
#include "object.h"

xmlNodePtr xml_csg_new(char *name, T_relation_type type)
{
  xmlNodePtr tree;
  
  tree=xmlNewNode(NULL,"OBJECT");
  xmlSetProp(tree,"name",name);
  xmlSetProp(tree,"type","NOD_CSG");
  xmlSetProp(tree,"relation",reltype2str(type));

  return tree;
}

xmlNodePtr xml_csg_new_char(char* type)
{
  xmlNodePtr tree;
  
  tree=xmlNewNode(NULL,"CSG");
  xmlSetProp(tree,"type","NOD_CSG");
  xmlSetProp(tree,"relation",type);

  return tree;
}

xmlNodePtr xml_csg_add_object(xmlNodePtr csg, xmlNodePtr object)
{
  if (csg==NULL) return NULL;
  if (object==NULL) return csg;
  xmlAddChild(csg,object);
  return csg;
}

xmlNodePtr xml_csg_del_object(xmlNodePtr csg, xmlNodePtr object)
{
  object->prev->next=NULL;
  object->next->prev=NULL;
  xmlFreeNode (object);
  return csg;
}
