#include <stdlib.h>
#include <glib.h>
#include <tree.h>
#include <parser.h>
#include "../types/tree.h"
#include "scene.h"
#include "utils.h"
#include "object.h"

xmlNodePtr xml_light_newprop(T_light_prop *prop)
{
  xmlNodePtr tree;
  
  tree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(tree,"location",(char *)vect3d2str(prop->location));

  return tree;
}

xmlNodePtr xml_light_new(VECT3D *location)
{
  xmlNodePtr tree;

  tree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(tree,"location",(char *)vect3d2str(location));

  return tree;
}

xmlNodePtr xml_light_new_char(char *location)
{
  xmlNodePtr tree,subtree;
  
  tree=xmlNewNode(NULL,"OBJECT");
  xmlSetProp(tree,"name","object-light");
  xmlSetProp(tree,"type","light_source");
  subtree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(subtree,"location",location);
  xmlAddChild(tree,subtree);
  return tree;
}

VECT3D *xml_light_get_location(xmlNodePtr tree)
{
  xmlNodePtr tree2=xml_object_select_private(tree);

  return str2vect3d(xmlGetProp(tree2,"location"));
}

xmlNodePtr xml_light_set_location(xmlNodePtr tree, VECT3D *location)
{
  xmlSetProp(tree,"location",(char *)vect3d2str(location));

  return tree;
}


T_prop *xml_light_get_prop(xmlNodePtr tree)
{
  T_prop *prop=(T_prop *)g_malloc(sizeof(T_prop));

  prop->light.location=str2vect3d(xmlGetProp(tree,"location"));

  return prop;
}

void xml_light_freeprop(T_light_prop *prop)
{
#ifdef DEBUG
  if (prop!=NULL)
    printf ("*** DEBUG *** Light prop free'd: %s\n", prop->name);
#endif
  g_free(prop->location);
  g_free(prop);
}
