#include <stdlib.h>
#include <glib.h>
#include <tree.h>
#include <parser.h>
#include "../types/tree.h"
#include "scene.h"
#include "utils.h"


xmlNodePtr xml_plane_newprop(T_plane_prop *prop)
{
  xmlNodePtr tree;
  
  tree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(tree,"normal",
	     (char *)vect3d2str(prop->normal));
  xmlSetProp(tree,"offset",
	     g_strdup_printf("%f",prop->offset));

  return tree;

}

xmlNodePtr xml_plane_new(VECT3D *normal, float offset)
{
   xmlNodePtr tree,subtree;

  tree=xmlNewNode(NULL,"OBJECT");
  xmlSetProp(tree,"name","object-plane");
  xmlSetProp(tree,"type","plane");
  subtree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(subtree,"normal",
	     (char *)vect3d2str(normal));
  xmlSetProp(subtree,"offset",
	     g_strdup_printf("%f",offset));
  xmlAddChild(tree,subtree);

  return tree; 
}

xmlNodePtr xml_plane_new_char(char *normal, char *offset)
{
  xmlNodePtr tree,subtree;
  
  tree=xmlNewNode(NULL,"OBJECT");
  xmlSetProp(tree,"name","object-plane");
  xmlSetProp(tree,"type","plane");
  subtree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(subtree,"normal", normal);
  xmlSetProp(subtree,"offset", offset);
  xmlAddChild(tree,subtree);
  return tree; 
}

xmlNodePtr xml_plane_set_normal(xmlNodePtr tree, VECT3D *normal)
{
  xmlSetProp(tree,"normal", (char *)vect3d2str(normal));
  return tree;
}

VECT3D *xml_plane_get_normal(xmlNodePtr tree)
{
  return str2vect3d(xmlGetProp(tree,"normal"));
}

xmlNodePtr xml_plane_set_offset(xmlNodePtr tree, float *offset)
{
  xmlSetProp(tree,"offset", g_strdup_printf("%f",offset));
  return tree;
}

float xml_plane_get_offset(xmlNodePtr tree)
{
  return atof(xmlGetProp(tree,"offset"));
}

T_prop *xml_plane_get_prop(xmlNodePtr tree)
{
  T_prop *prop=(T_prop *)g_malloc(sizeof(T_prop));

  prop->plane.normal=str2vect3d(xmlGetProp(tree,"normal"));
  prop->plane.offset=atof(xmlGetProp(tree,"offset"));
  
  return prop;
}



