#include <stdlib.h>
#include <glib.h>
#include <tree.h>
#include <parser.h>
#include "../types/tree.h"
#include "scene.h"
#include "utils.h"
#include "object.h"


xmlNodePtr xml_sor_newprop(T_sor_prop *prop)
{
  xmlNodePtr tree,subtree;
  GList *list=prop->list, *list2;
  int i;
  
  puts("xml_sor_newprop");
  
  if (prop==NULL) return NULL;

  tree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(tree,"num_point",g_strdup_printf("%d",prop->num_point));
  list2=list;
  for (i=0;i<prop->num_point;i++)
    {
      VECT2D *data;
      
      list2=g_list_nth(list,i);
      subtree=xmlNewChild(tree,NULL,"POINT",NULL);
      data=(VECT2D *)list2->data;
      xmlSetProp(subtree,"data",(char *)vect2d2str(data));
    }

  return tree;
}

xmlNodePtr xml_sor_new(GList *list, int num_point)
{
  xmlNodePtr tree,subtree,subsubtree;
  GList *list2;
  int i;

  tree=xmlNewNode(NULL,"OBJECT");
  xmlSetProp(tree,"name","object-sor");
  xmlSetProp(tree,"type","sor");
  subtree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(subtree,"num_point",g_strdup_printf("%d",num_point));
  list2=list;
  for (i=0;i<num_point;i++)
    {
      subsubtree=xmlNewChild(subtree,NULL,"POINT",NULL);
      xmlSetProp(subtree,"data",(char *)vect2d2str((VECT2D *)list->data));
      list2=g_list_nth(list2,i);
    }
  
  return tree;
}

xmlNodePtr xml_sor_new_char(char *num_point)
{
  xmlNodePtr tree,subtree;
  
  tree=xmlNewNode(NULL,"OBJECT");
  xmlSetProp(tree,"name","object-sor");
  xmlSetProp(tree,"type","sor");
  subtree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(subtree,"num_point",num_point);
  xmlAddChild( tree, subtree);
  return tree;
}

GList *xml_sor_get_list(xmlNodePtr tree)
{
  GList *list=NULL;
  xmlNodePtr tree2=tree->childs;
  int i,num_point=atoi(xmlGetProp(tree2,"num_point"));
  VECT2D *vect=(VECT2D *)g_malloc(sizeof(VECT2D));

  tree2=tree2->childs;
  if (num_point>=0)
    for (i=0;i<num_point;i++)
      {
	g_list_append(list,(gpointer)str2vect2d(xmlGetProp(tree2,"data")));
	tree2=tree2->next;
      }
  else
    while (tree2!=NULL)
      {
	g_list_append(list,(gpointer)str2vect2d(xmlGetProp(tree2,"data")));
	tree2=tree2->next;
      }
  return list;
}

int xml_sor_get_num_point(xmlNodePtr tree)
{
  return atoi(xmlGetProp(tree->childs,"num_point"));
}

xmlNodePtr xml_sor_set_list(xmlNodePtr tree, GList *glist)
{
  xmlNodePtr tree2=xml_object_select_private(tree),tree3=tree2->childs;
  GList *list2=glist;
  int i,length=g_list_length(glist);
  
  for (i=0;i<length;i++)
    {
      tree3=xmlNewChild(tree2,NULL,"POINT",NULL);
      xmlSetProp(tree3,"data",(char *)vect2d2str((VECT2D *)glist->data));
      list2=g_list_nth(list2,i);
    }
  g_free(list2);
  xmlSetProp(tree,"num_point",g_strdup_printf("%d",length));

  return tree;  

}

T_prop *xml_sor_get_prop(xmlNodePtr tree)
{
  xmlNodePtr point;
  T_prop *prop=(T_prop *)g_malloc(sizeof(T_prop));
  VECT2D *vect;
  GList *list=NULL;
  int i;
  
  if (tree==NULL) return NULL;
  prop->sor.num_point=atoi(xmlGetProp(tree,"num_point"));
  if (prop->sor.num_point==0) return prop;
  vect=(VECT2D *)g_malloc(sizeof(VECT2D));
  point=tree->childs;
  while(point!=NULL)
    {
      g_list_append(list,(gpointer)str2vect2d(xmlGetProp(point,"data")));
      point=point->next;
    }
  prop->sor.list=list;
  
  return prop;
}

void xml_sor_freeprop(T_sor_prop *prop)
{
  int i,length=g_list_length(prop->list);
  GList *list;

  if (prop==NULL) return;
#ifdef DEBUG
  printf ("*** DEBUG *** SOR prop free'd: %s\n",prop->name);
#endif
  for (i=0;i<length;i++)
    {
      prop->list=g_list_nth(prop->list,i);
      
      g_free(prop->list->data);
    }
  g_list_free(prop->list);
  g_free(prop);
}


