#include <stdlib.h>
#include <glib.h>
#include <tree.h>
#include <parser.h>
#include "../types/tree.h"
#include "scene.h"
#include "object.h"

xmlNodePtr xml_torus_newprop(T_torus_prop *prop)
{
  xmlNodePtr tree;
  
  tree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(tree,"major",g_strdup_printf("%f",prop->major));
  xmlSetProp(tree,"minor",g_strdup_printf("%f",prop->minor));

  return tree;
}

xmlNodePtr xml_torus_new(float major, float minor)
{
  xmlNodePtr tree,subtree;
  
  tree=xmlNewNode(NULL,"OBJECT");
  xmlSetProp(tree,"name","object-torus");
  xmlSetProp(tree,"type","torus");
  subtree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(subtree,"major",g_strdup_printf("%f", major));
  xmlSetProp(subtree,"minor",g_strdup_printf("%f", minor));
  xmlAddChild(tree,subtree);
  return tree;
}

xmlNodePtr xml_torus_new_char(char *major, char *minor)
{
  xmlNodePtr tree,subtree;
  
  tree=xmlNewNode(NULL,"OBJECT");
  xmlSetProp(tree,"name","object-torus");
  xmlSetProp(tree,"type","torus");
  subtree=xmlNewNode(NULL,"PRIVATE");
  xmlSetProp(subtree,"major",major);
  xmlSetProp(subtree,"minor",minor);
  xmlAddChild(tree,subtree);
  return tree;
}

float xml_torus_get_major(xmlNodePtr tree)
{
  return atof(xmlGetProp(tree->childs,"major"));
}

xmlNodePtr xml_torus_set_major(xmlNodePtr tree, float major)
{
  xmlSetProp(tree,"major",g_strdup_printf("%f",major));  
  
  return tree;
}

float xml_torus_get_minor(xmlNodePtr tree)
{
  return atof(xmlGetProp(tree->childs,"minor"));
}

xmlNodePtr xml_torus_set_minor(xmlNodePtr tree, float minor)
{
  xmlSetProp(tree,"minor", g_strdup_printf("%f",minor));  
  
  return tree;
}

T_prop *xml_torus_get_prop(xmlNodePtr tree)
{
  T_prop *prop=(T_prop *)g_malloc(sizeof(T_prop));

  prop->torus.major=atof(xmlGetProp(tree,"major"));
  prop->torus.minor=atof(xmlGetProp(tree,"minor"));

  return prop;
}

void xml_torus_freeprop(T_torus_prop *prop)
{
#ifdef DEBUG
  if (prop!=NULL)
    printf ("*** DEBUG *** Torus prop free'd: %s\n",prop->name);
#endif
  g_free(prop);
}





