#include "headers.h"


int test_ext(char *fn)
{
  int	len_fn	= strlen(fn);
  int	len_ext = len_fn;
  char	*ext    = "";
  int i;
  
  if (!len_fn)
    return 0;
  while (fn[--len_ext] != '.')
    ;
  if (!len_ext)
    return 0;
  for (i = len_ext; i < len_fn; i++)
    ext = g_strdup_printf("%s%c", ext, fn[i]);
  if (!strcmp(ext, ".pov") ||
      !strcmp(ext, ".POV"))
    return TRUE;
  return FALSE;
}


void sel_pov_file(GtkWidget *filesel)
{
  char *file_name = gtk_file_selection_get_filename (GTK_FILE_SELECTION (filesel));
  
  if (!test_ext(file_name))
    return;
  gl_scene = scan_pov(file_name);
  gtk_widget_destroy( GTK_WIDGET(filesel));
}

void OpenPovFunc(void)
{
  GtkWidget *filesel;

  filesel = gtk_file_selection_new ("Open POV file");

  gtk_signal_connect (GTK_OBJECT (filesel), 
		      "destroy", 
		      (GtkSignalFunc) close_fileselection, 
		      GTK_OBJECT (filesel));
  
  gtk_signal_connect (GTK_OBJECT (filesel), 
		      "destroy", 
		      (GtkSignalFunc) gtk_widget_destroy, 
		      GTK_OBJECT (filesel));
  
  gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filesel)->ok_button), 
		      "clicked", 
		      (GtkSignalFunc) close_fileselection, 
		      filesel);
  
  gtk_signal_connect_object(GTK_OBJECT (GTK_FILE_SELECTION (filesel)->ok_button), 
		      "clicked", 
		      (GtkSignalFunc) sel_pov_file, 
		      GTK_OBJECT(filesel));
  
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filesel)->cancel_button), 
			     "clicked", 
			     (GtkSignalFunc) close_fileselection, 
			     GTK_OBJECT (filesel)); 
  
  gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filesel)->cancel_button), 
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy, 
			     GTK_OBJECT (filesel));

  gtk_widget_show_all(filesel);
}


void SavePovFunc (void)
{
  printf("Save...\n");
}
