#include "headers.h"

extern struct windows_view_struct windows_view;

void so_init(struct plugins* a)
{
  DIR *fd;
  int i=0;
  gchar *current,*current_full;
  struct dirent* directory;

  current=g_get_current_dir();
  current_full=g_strconcat(current,"/",PLUG_DIR,"/",NULL);
  fd=opendir(current_full);
  if (fd != NULL)
    {
      directory=readdir(fd);
      directory=readdir(fd);
      directory=readdir(fd);
      while( directory != NULL)
	{
	  a->handle[i]=dlopen(g_strconcat(current_full,directory->d_name,NULL),RTLD_LAZY);
	  strncpy(a->name[i],directory->d_name,64);
	  if (dlerror() == NULL)
	    {
	      a->create[i]=dlsym(a->handle[i],"create");
	      if(dlerror() != NULL)
		{
		  g_print("Warning: the file %s does not contain a required function(create).\n",
			  directory->d_name);
		  directory=readdir(fd);
		  continue;
		}
	      a->on_click[i]=dlsym(a->handle[i],"on_click");
	      if(dlerror() != NULL)
		{
		  g_print("Warning: the file %s does not contain a required function(on_click).\n",
			  directory->d_name);
		  directory=readdir(fd);
		  continue;
		}
	      i++;
	    }
	  else
	    g_print("Warning: the file %s is not a valid ELF plugin.\n",directory->d_name);
	  directory=readdir(fd);
	}
    }
  closedir(fd);
  a->nb_plugs=i;
  g_print("Loaded modules: %d\n",a->nb_plugs);
}

void so_core_init(GtkWidget *button,gchar *name)
{
  int sig[2]={0,0};
  gchar *current_core;
  char *error;

  current_core=g_strconcat(g_get_current_dir(),"/",COREPLUG_DIR,"/","core_",name,NULL);
  if (core.handle!=NULL)
    dlclose(core.handle);
  core.handle=dlopen(current_core,RTLD_LAZY);
  if((error=dlerror()) != NULL)
    {
      g_print("Error in %s: %s\n",name,error);
    }
  core.on_press=dlsym(core.handle,"on_press");
  if((error=dlerror()) != NULL)
    {
      g_print("Error in %s: %s\n",name,error);
    }
  core.on_release=dlsym(core.handle,"on_release");
  if((error=dlerror()) != NULL)
    {
      g_print("Error in %s: %s\n",name,error);
    }
  if (sig[0])
    gtk_signal_disconnect(GTK_OBJECT(glarea_CAM),sig[0]);
  if (sig[1])
    gtk_signal_disconnect(GTK_OBJECT(glarea_CAM),sig[1]);
  
  if (!windows_view.vu3d)
    {
      sig[0]=gtk_signal_connect(GTK_OBJECT(windows_view.vu3d), "button-press-event",
			    GTK_SIGNAL_FUNC(core.on_press),(gpointer)&point);
      sig[1]=gtk_signal_connect(GTK_OBJECT(windows_view.vu3d), "button-release-event",
				GTK_SIGNAL_FUNC(core.on_release),(gpointer)&point);
    }
}

void so_close(struct plugins* a)
{
  int i;

  for(i=0;i<a->nb_plugs;i++)
    {
      dlclose(a->handle[i]);
    }
}












