#include "headers.h"

GtkWidget	*menu_XY;
GLdouble	z_camXY = 1;
gboolean	ON_MOVE_OBJECT_XY;
gboolean	ON_RESIZE_OBJECT_XY;
gboolean	ON_ROTATE_OBJECT_XY;
VECT2D		real_start_pos;
VECT2D		real_end_pos;
t_menu_popup	*menu_popup_XY[NB_MENU_POPUP_XY];
t_features_menu	prop_menu_XY[NB_MENU_POPUP_XY] = 
{
  {
    "File",
    3,
  },
  {
    "Edit",
    3,
  },
  {
    "View",
    2,
  },
  {
    "Object",
    5,
  },
  {
    "Light",
    1,
  },
};

gboolean make_expose_on_viewXY(void)
{
  GdkEventExpose *expose;
  gboolean *return_val;

  expose = (GdkEventExpose *)g_malloc(sizeof(GdkEventExpose));
  expose->type = GDK_EXPOSE;
  expose->window = glarea_XY->window;
  expose->send_event = FALSE;
  expose->area.x = 0;
  expose->area.y = 0;
  expose->area.width = SIZE_X_WIN_XY;
  expose->area.height = SIZE_Y_WIN_XY;
  expose->count = 0;
  gtk_signal_emit_by_name(GTK_OBJECT(glarea_XY), "expose-event", glarea_XY,
			  expose, NULL, return_val);
  g_free(expose);
  return TRUE;
}

void draw_scene_on_viewXY(T_obj *obj, GLenum render_mode)
{
  int i;
  T_face *face;
  
  glPushMatrix();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glRotatef(obj->prop_base->rotate->x, 1, 0, 0);
  glRotatef(obj->prop_base->rotate->y, 0, 1, 0);
  glRotatef(obj->prop_base->rotate->z, 0, 0, 1);
  glTranslatef(obj->prop_base->translate->x,
	       obj->prop_base->translate->y,
	       obj->prop_base->translate->z);
  glScalef(obj->prop_base->scale->x,
	   obj->prop_base->scale->y,
	   obj->prop_base->scale->z);
  if (render_mode == GL_SELECT)
    {
      glLoadName(obj->prop_base->id);
      glBegin(GL_TRIANGLES);
    }
  else
    {
      CalculateNormal(obj);
      glBegin(GL_LINE_LOOP);
    }
  for (i = 0; i < obj->prop_base->nb_face; i++)
    {
      if (obj->prop_base->is_selected == 1)
	glColor3f(1.0, 0.0, 0.0);
      else
	glColor3f(0.0, 0.0, 0.0);
      if (render_mode == GL_RENDER)
	glNormal3f(obj->prop_base->normal[i].x,
		   obj->prop_base->normal[i].y,
		   obj->prop_base->normal[i].z);
      face = ReadTriangleOfMesh(obj->prop_base->list_vertex, i);
      glVertex3f(face->A->x, face->A->y, face->A->z);
      glVertex3f(face->B->x, face->B->y, face->B->z);      
      glVertex3f(face->C->x, face->C->y, face->C->z);
    }
  glEnd();
  glPopMatrix();
}

int  processHitsOnXY(GLint hits, GLuint buffer[])
{
  unsigned int i, j;
  GLuint names, *ptr;
  
  ptr = (GLuint *) buffer;
  for (i = 0; i < hits; i++) 
    { 
      names = *ptr;
      ptr += 3;
      for (j = 0; j < names; j++) 
	return ( *ptr);
    }
  return 0;
}

int pickObject_XY(float x, float y)
{
  GLuint selectBuf[BUFSIZE];
  GLint hits;
  GLint viewport[4];
  
  glGetIntegerv(GL_VIEWPORT, viewport);
  glSelectBuffer(BUFSIZE, selectBuf);
  glRenderMode(GL_SELECT);
  glInitNames();
  glPushName(-1);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluPickMatrix((GLdouble)x, (GLdouble) (viewport[3] - y), 2.0, 2.0, viewport);
  glOrtho(-50.0/z_camXY, 50.0/z_camXY, -50.0/z_camXY, 50.0/z_camXY, 1.0, 2000.0);
  gluLookAt(0.0, 0.0, 100.0, 0.0, 0.0, 0.0 ,0.0,1.0,0.0);
  parse_level1(gl_scene->root, DrawViewXYfromTreeSelect);
  glPopMatrix();
  hits = glRenderMode(GL_RENDER);
  return processHitsOnXY(hits, selectBuf);
}

gboolean glarea_display_XY(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  GtkGLArea *glarea_XY = (GtkGLArea *) widget;

  if (gtk_gl_area_make_current(glarea_XY))
    {
      glViewport(0, 0, SIZE_X_WIN_XY, SIZE_Y_WIN_XY);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      glOrtho(-50.0/z_camXY, 50.0/z_camXY, -50.0/z_camXY, 50.0/z_camXY, 1.0, 2000.0);
      gluLookAt(0.0, 0.0, 100.0, 0.0, 0.0, 0.0 ,0.0,1.0,0.0);
      glMatrixMode(GL_MODELVIEW);
      glClearColor (1.0, 1.0, 1.0, 1.0);
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      glLoadIdentity();
      glBegin(GL_LINES);
      glColor3f(0.0, 0.0, 0.0);
      glVertex3f(-50.0/z_camXY, 0.0, 0.0);
      glVertex3f(50.0/z_camXY, 0.0, 0.0);
      glVertex3f(0.0, 50.0/z_camXY, 0.0);
      glVertex3f(0.0, -50.0/z_camXY, 0.0);
      glEnd();
      if (gl_scene->root->childs)
	parse_level1(gl_scene->root, DrawViewXYfromTreeRender);
      gtk_gl_area_swapbuffers(glarea_XY);
    }
  return TRUE;
}


gint ObjectOperationGetId_XY(GdkEventMotion *mevent)
{
  real_start_pos.x = (mevent->x - SIZE_X_WIN_XY/2) / (z_camXY * 5);
  real_start_pos.y = (-mevent->y+ SIZE_Y_WIN_XY/2) / (z_camXY * 5);
  return pickObject_XY(mevent->x, mevent->y);
}

gint ObjectOnMove_XY(GdkEventMotion *mevent)
{
  float Xreal = (mevent->x - SIZE_X_WIN_XY/2) / (z_camXY * 5);
  float Yreal = (-mevent->y+ SIZE_Y_WIN_XY/2) / (z_camXY * 5);
  t_list_obj_select *obj_select;
  int i;

  obj_select = GetSelectedObject(gl_scene->root);
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->translate->x += Xreal - real_start_pos.x;
      obj_select->mem_obj[i]->prop_base->translate->y += Yreal - real_start_pos.y;
      obj_select->mem_obj[i]->prop_base->translate->z += 0;
    }
  real_start_pos.x = Xreal;
  real_start_pos.y = Yreal;
  gtk_widget_queue_draw(glarea_XY);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.vu3d_b)
    gtk_widget_queue_draw(glarea_CAM);
  return TRUE;
}

gint ObjectOnResize_XY(GdkEventMotion *mevent)
{
  float Xreal = (mevent->x - SIZE_X_WIN_XY/2) / (z_camXY * 5);
  float Yreal = (-mevent->y+ SIZE_Y_WIN_XY/2) / (z_camXY * 5);
  static VECT2D scale = {0.0, 0.0};
  int i;
  t_list_obj_select *obj_select;
  
  obj_select = GetSelectedObject(gl_scene->root);
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->scale->x *= (-scale.x + Xreal)/10 + 1;
      obj_select->mem_obj[i]->prop_base->scale->y *= (-scale.y + Yreal)/10 + 1;
    }
  gtk_widget_queue_draw(glarea_XY);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.vu3d_b)
    gtk_widget_queue_draw(glarea_CAM);
  scale.x = Xreal;
  scale.y = Yreal;
  return TRUE;
}

gint ObjectOnRotate_XY(GdkEventMotion *mevent)
{
  VECT2D real_current_pos;
  VECT2D center;
  float angle;
  float alkashi_denum;
  t_list_obj_select *obj_select;
  int i;
  
  obj_select = GetSelectedObject(gl_scene->root);
  center.x = 0;
  center.y = 0;
  real_current_pos.x = (mevent->x - SIZE_X_WIN_XY/2) / (z_camXY * 5);
  real_current_pos.y = (-mevent->y+ SIZE_Y_WIN_XY/2) / (z_camXY * 5);
  alkashi_denum = (2*sqrt(SqrNorme2D(center, real_start_pos))*
		   sqrt(SqrNorme2D(center, real_current_pos)));

  if (real_current_pos.x != 0 &&
      real_current_pos.y != 0 &&
      real_start_pos.x != 0 &&
      real_start_pos.y != 0 && alkashi_denum != 0)
    {
      angle = RAD2DEG * (acos((-SqrNorme2D(real_current_pos, real_start_pos) +
			       SqrNorme2D(center, real_start_pos) + 
			       SqrNorme2D(center, real_current_pos)) / alkashi_denum));
      /* printf("%f\n", angle); */
      if ((ComputeAngle(real_start_pos)
	   -ComputeAngle(real_current_pos)) > 0)
	angle = -angle;
      for (i = 0; i < obj_select->size; i++)
	obj_select->mem_obj[i]->prop_base->rotate->z += angle;
      gtk_widget_queue_draw(glarea_XY);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
      if (open_windows.vu3d_b)
	gtk_widget_queue_draw(glarea_CAM);
    }
  real_start_pos.x = real_current_pos.x;
  real_start_pos.y = real_current_pos.y;
  return TRUE;
}

gboolean update_position_mouse_on_XY(GtkWidget *widget, GdkEventMotion *mevent)
{
  gdouble Xreal;
  gdouble Yreal;
  gchar *tmp;
  
  Xreal = (mevent->x - SIZE_X_WIN_XY/2) / (z_camXY * 5);
  Yreal = (-mevent->y+ SIZE_Y_WIN_XY/2) / (z_camXY * 5);
  tmp = g_strdup_printf("%f", Xreal);
  gtk_label_set_text(GTK_LABEL(lblX_on_XY), (const gchar *)tmp);
  tmp = g_strdup_printf("%f", Yreal);
  gtk_label_set_text(GTK_LABEL(lblY_on_XY), (const gchar *)tmp);
  return TRUE;
}

/*
** Manage all operations = {select, rotate, move, resize}
*/
gint ButtonPressedDispatcher_XY(GtkWidget *window, GdkEventButton *event,
				    GtkWidget *glarea_XY)
{
  GdkEventMotion *mevent = (GdkEventMotion *)event;
  t_list_obj_select *obj_select;
  float Xreal = (mevent->x - SIZE_X_WIN_XY/2) / (z_camXY * 5);
  float Yreal = (-mevent->y+ SIZE_Y_WIN_XY/2) / (z_camXY * 5);
  int i;

  obj_select = GetSelectedObject(gl_scene->root);
  switch (op_select)
    {
    case SELECT:
      current_id = pickObject_XY(mevent->x, mevent->y);
      printf("%ld\n", current_id);
      if (current_id)
	{
	  for (i = 0; i < obj_select->size; i++)
	    {
	      if (obj_select->mem_obj[i]->prop_base->id != current_id)
		obj_select->mem_obj[i]->prop_base->is_selected = 0;
	    }
	  parse_level1(gl_scene->root, ChangeIdObjSel);
	}
      break;
    case MOVE:
      if (obj_select->size)
	ON_MOVE_OBJECT_XY = ObjectOperationGetId_XY(mevent);
      break;
    case RESIZE:
      if (obj_select->size)
	ON_RESIZE_OBJECT_XY = ObjectOperationGetId_XY(mevent);
      break;
    case ROTATE:
      if (obj_select->size)
	ON_ROTATE_OBJECT_XY = ObjectOperationGetId_XY(mevent);
      break;
    case SET_LIGHT:
      return SetColorLight(Xreal, Yreal, 0);
      break;
    case BOX:
      CreateBox(Xreal, Yreal, 0);
      break;
    case CONE:
      CreateCone(Xreal, Yreal, 0);
      break;
    case CYLINDRE:
      CreateCylindre(Xreal, Yreal, 0);
      break;
    case SPHERE:
      CreateSphere(Xreal, Yreal, 0);
      break;
    case PLANE:
      CreatePlane(Xreal, Yreal, 0);
      break;
    case TORUS:
      CreateTorus(Xreal, Yreal, 0);
      break;
    case TUBE:
      CreateTube(Xreal, Yreal, 0);
      break;
    case OPEN_CONE:
      CreateOpenCone(Xreal, Yreal, 0);
      break;
    case SOR:
      CreateSor(Xreal, Yreal, 0);
      break;
    default:
      return FALSE;
    }
  gtk_widget_queue_draw(glarea_XY);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.vu3d_b)
    gtk_widget_queue_draw(glarea_CAM);
  return TRUE;
}

gboolean ViewEventDispatcher_XY(GtkWidget *glarea_XY, GdkEvent *event,
				GtkWidget *window)
{
  switch (event->type)
    {
    case GDK_BUTTON_PRESS:
      {
	GdkEventButton *bevent = (GdkEventButton *)event;
	
	if (bevent->button == 1)
	  ButtonPressedDispatcher_XY(window, bevent, glarea_XY);
	if (bevent->button == 3)
	  gtk_menu_popup(GTK_MENU(menu_XY), NULL, NULL, NULL, NULL,
			 bevent->button, bevent->time);
	break;
      }
    case GDK_MOTION_NOTIFY:
      {
	if (ON_MOVE_OBJECT_XY)
	  ObjectOnMove_XY((GdkEventMotion *)event);
	if (ON_RESIZE_OBJECT_XY)
	  ObjectOnResize_XY((GdkEventMotion *)event);
	if (ON_ROTATE_OBJECT_XY)
	  ObjectOnRotate_XY((GdkEventMotion *)event);
	update_position_mouse_on_XY(glarea_XY, (GdkEventMotion *)event);
	break;
      }
    case GDK_BUTTON_RELEASE:
      if (ON_MOVE_OBJECT_XY)
	ON_MOVE_OBJECT_XY = !ON_MOVE_OBJECT_XY;
      if (ON_RESIZE_OBJECT_XY)
	  ON_RESIZE_OBJECT_XY = !ON_RESIZE_OBJECT_XY;
      if (ON_ROTATE_OBJECT_XY)
	ON_ROTATE_OBJECT_XY = !ON_ROTATE_OBJECT_XY;
      break;
    case GDK_EXPOSE:
      glarea_display_XY(glarea_XY, (GdkEventExpose *)event, NULL);
      break;
    default:
      return FALSE;
    }
  return TRUE;
}

void ZoomIn_XY(void)
{
  z_camXY += 0.1;
  gtk_widget_queue_draw(glarea_XY);
}

void ZoomOut_XY(void)
{
  z_camXY -= 0.1;
  if (z_camXY <= 0)
    z_camXY = 0.1;
  gtk_widget_queue_draw(glarea_XY);
}

void WindowXYCreateGL (void)
{
  GtkWidget	*vbox;
  GtkWidget     *hbox;
  GtkWidget     *label;
  GtkWidget	*menu_items;
  GtkWidget	*SubMenu;
  GtkWidget	*SubMenuOperation;
  GtkWidget	*XXXMenu;
  GtkWidget	*XXXMenuOperation;
  int		i, j;
  
  gtk_window_set_title (GTK_WINDOW(WFace), "View XY");
  glarea_XY = gtk_gl_area_new_vargs(NULL,
				    GDK_GL_RGBA,
				    GDK_GL_DOUBLEBUFFER,
				    GDK_GL_DEPTH_SIZE,1,
				    GDK_GL_NONE);  
  
  gtk_widget_set_events(glarea_XY,
			GDK_EXPOSURE_MASK|
			GDK_BUTTON_PRESS_MASK|
			GDK_BUTTON_RELEASE_MASK| 
			GDK_POINTER_MOTION_MASK|
 			GDK_KEY_PRESS_MASK);
  gtk_widget_set_usize(GTK_WIDGET(glarea_XY), SIZE_X_WIN_XY, SIZE_Y_WIN_XY);
  gtk_signal_connect(GTK_OBJECT(glarea_XY), "event",
		     GTK_SIGNAL_FUNC(ViewEventDispatcher_XY), WFace);
  /*    gtk_signal_connect(GTK_OBJECT(glarea_XY), "expose-event", */
  /*    		     GTK_SIGNAL_FUNC(glarea_display_XY), NULL); */
  gtk_container_set_border_width(GTK_CONTAINER(WFace), 5);
  
  vbox=gtk_vbox_new(0,0);
  gtk_container_add(GTK_CONTAINER(WFace),vbox);
  gtk_widget_show(vbox);

  gtk_box_pack_start(GTK_BOX(vbox),glarea_XY,1,1,0);
  gtk_widget_show(glarea_XY); 

  hbox = gtk_hbox_new(0,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,1,1,0);
  gtk_widget_show(hbox);

  vbox=gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), 10, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(vbox);

  label = gtk_label_new("X:");
  gtk_box_pack_start(GTK_BOX(vbox),label,1,1,0);
  gtk_widget_show(label);

  vbox=gtk_vbox_new(0,0);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(vbox);

  lblX_on_XY = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(vbox), lblX_on_XY, 1, 1, 0);
  gtk_widget_show(lblX_on_XY);

  vbox = gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), 10, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);

  label = gtk_label_new("Y:");
  gtk_box_pack_start(GTK_BOX(vbox),label,1,1,0);
  gtk_widget_show(label);

  vbox = gtk_vbox_new(0,0);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);

  lblY_on_XY = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(vbox), lblY_on_XY, 1, 1, 0);
  gtk_widget_show(lblY_on_XY);

  vbox=gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), SIZE_X_WIN_XY/2, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);

  /* set popup in this view XY*/
  for (i = 0; i < NB_MENU_POPUP_XY; i++)
    menu_popup_XY[i] = (t_menu_popup *)malloc(sizeof(t_menu_popup) * 
					      prop_menu_XY[i].nb_submenu);
  menu_popup_XY[0][0].item = "Open POV";	menu_popup_XY[0][0].fcn = OpenPovFunc;
  menu_popup_XY[0][1].item = "Save POV";	menu_popup_XY[0][1].fcn = SavePovFunc;
  menu_popup_XY[0][2].item = "Close";		menu_popup_XY[0][2].fcn = close_construct_face;
  
  /* Edit File */
  menu_popup_XY[1][0].item = "Cut";		menu_popup_XY[1][0].fcn = CutFunc;
  menu_popup_XY[1][1].item = "Copy";		menu_popup_XY[1][1].fcn = CopyFunc;
  menu_popup_XY[1][2].item = "Paste";		menu_popup_XY[1][2].fcn = PasteFunc;

  /* View Menu */
  menu_popup_XY[2][0].item = "Zoom In";		menu_popup_XY[2][0].fcn = ZoomIn_XY;
  menu_popup_XY[2][1].item = "Zoom Out";	menu_popup_XY[2][1].fcn = ZoomOut_XY;

  menu_popup_XY[3][0].item = "Color";		menu_popup_XY[3][0].fcn = SetColorObject;
  menu_popup_XY[3][1].item = "Delete";		menu_popup_XY[3][1].fcn = DeleteObject;
  menu_popup_XY[3][2].item = "Rotate";		menu_popup_XY[3][2].fcn = RotateObject;
  menu_popup_XY[3][3].item = "Translate";	menu_popup_XY[3][3].fcn = TranslateObject;
  menu_popup_XY[3][4].item = "Scale";		menu_popup_XY[3][4].fcn = ScaleObject;

  menu_popup_XY[4][0].item = "Properties";	menu_popup_XY[4][0].fcn = ChangeColorLight;
  /* set popup */
  menu_XY = gtk_menu_new();
  menu_items = gtk_tearoff_menu_item_new();
  gtk_widget_show(menu_items);
  gtk_menu_append(GTK_MENU(menu_XY), menu_items);
  
  SubMenuOperation = gtk_menu_new();      
  
  for (i = 0 ; i < NB_MENU_POPUP_XY; i++)
    {
      SubMenu = gtk_menu_new();
      if (i == 3)
	{
	  for (j = 0; j < prop_menu_XY[i].nb_submenu; j++)
	    {
	      if (j == 0 || j == 1)
		{
		  menu_items = gtk_menu_item_new_with_label(menu_popup_XY[i][j].item);
		  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
		  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					    GTK_SIGNAL_FUNC(menu_popup_XY[i][j].fcn), NULL);
		  gtk_widget_show(menu_items);
		}
	      else
		{
		  menu_items = gtk_menu_item_new_with_label(menu_popup_XY[i][j].item);
		  gtk_menu_append(GTK_MENU(SubMenuOperation), menu_items);
		  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					    GTK_SIGNAL_FUNC(menu_popup_XY[i][j].fcn), NULL);
		  gtk_widget_show(menu_items);		  
		}
	    }
	  free(menu_popup_XY[i]);
	  /* XXXMenu <=> FileMenu, EditMenu, ToolMenu....XXX={file, edit, ...} */
	  XXXMenu = gtk_menu_item_new_with_label(prop_menu_XY[i].name_menu);
	  gtk_widget_show(XXXMenu);
	  XXXMenuOperation = gtk_menu_item_new_with_label("Operation");
	  gtk_widget_show(XXXMenuOperation);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenu), SubMenu);
	  gtk_menu_append(GTK_MENU(menu_XY), XXXMenu);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenuOperation), SubMenuOperation);
	  gtk_menu_append(GTK_MENU(SubMenu), XXXMenuOperation);
	  
	}
      else
	{
	  for (j = 0; j < prop_menu_XY[i].nb_submenu; j++)
	    {
	      menu_items = gtk_menu_item_new_with_label(menu_popup_XY[i][j].item);
	      gtk_menu_append(GTK_MENU(SubMenu), menu_items);
	      gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					GTK_SIGNAL_FUNC(menu_popup_XY[i][j].fcn), NULL);
	      gtk_widget_show(menu_items);
	    }
	  free(menu_popup_XY[i]);
	  /* XXXMenu <=> FileMenu, EditMenu, ToolMenu....XXX={file, edit, ...} */
	  XXXMenu = gtk_menu_item_new_with_label(prop_menu_XY[i].name_menu);
	  gtk_widget_show(XXXMenu);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenu), SubMenu);
	  gtk_menu_append(GTK_MENU(menu_XY), XXXMenu);
	}
    }
}

void WindowXY_new(void)
{
  windows_view.face= gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect (GTK_OBJECT (windows_view.face), 
		      "delete_event", 
		      GTK_SIGNAL_FUNC (close_construct_face), 
		      NULL);
  gtk_container_set_border_width (GTK_CONTAINER (WFace), 3);
  
  WindowXYCreateGL ();
  gtk_widget_show_all(WFace);
}
