#include "headers.h"

GtkWidget	*menu_XZ;
GLdouble	y_camXZ = 1;
gboolean	ON_MOVE_OBJECT_XZ;
gboolean	ON_RESIZE_OBJECT_XZ;
gboolean	ON_ROTATE_OBJECT_XZ;
VECT2D		real_start_pos;
t_menu_popup	*menu_popup_XZ[NB_MENU_POPUP_XZ];
t_features_menu	prop_menu_XZ[NB_MENU_POPUP_XZ] = 
{
  {
    "File",
    3,
  },
  {
    "Edit",
    3,
  },
  {
    "View",
    2,
  },
  {
    "Object",
    5,
  },
  {
    "Light",
    1,
  },
};

gboolean make_expose_on_viewXZ(void)
{
  GdkEventExpose *expose;
  gboolean *return_val;

  expose = (GdkEventExpose *)g_malloc(sizeof(GdkEventExpose));
  expose->type = GDK_EXPOSE;
  expose->window = glarea_XZ->window;
  expose->send_event = FALSE;
  expose->area.x = 0;
  expose->area.y = 0;
  expose->area.width = SIZE_X_WIN_XZ;
  expose->area.height = SIZE_Y_WIN_XZ;
  expose->count = 0;
  gtk_signal_emit_by_name(GTK_OBJECT(glarea_XZ), "expose_event", glarea_XZ,
			  expose, NULL, return_val);
  g_free(expose);
  return TRUE;
}

void draw_scene_on_viewXZ(T_obj *obj, GLenum render_mode)
{
  int i;
  T_face *face;
  
  glPushMatrix();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glRotatef(obj->prop_base->rotate->x, 1, 0, 0);
  glRotatef(obj->prop_base->rotate->y, 0, 1, 0);
  glRotatef(obj->prop_base->rotate->z, 0, 0, 1);
  glTranslatef(obj->prop_base->translate->x,
	       obj->prop_base->translate->y,
	       obj->prop_base->translate->z);
  glScalef(obj->prop_base->scale->x,
	   obj->prop_base->scale->y,
	   obj->prop_base->scale->z);
 if (render_mode == GL_SELECT)
    {
      glLoadName(obj->prop_base->id);
      glBegin(GL_TRIANGLES);
    }
  else
    {
      CalculateNormal(obj);
      glBegin(GL_LINE_LOOP);
    }
  for (i = 0; i < obj->prop_base->nb_face; i++)
    {
      if (obj->prop_base->is_selected)
	glColor3f(1.0, 0.0, 0.0);
      else
	glColor3f(0.0, 0.0, 0.0);
      glNormal3f(obj->prop_base->normal[i].x,
		 obj->prop_base->normal[i].y,
		 obj->prop_base->normal[i].z);
      face = ReadTriangleOfMesh(obj->prop_base->list_vertex, i);
      glVertex3f(face->A->x, face->A->y, face->A->z);
      glVertex3f(face->B->x, face->B->y, face->B->z);      
      glVertex3f(face->C->x, face->C->y, face->C->z);
    }
  glEnd();
  glPopMatrix();
}

int  processHitsOnXZ(GLint hits, GLuint buffer[])
{
  unsigned int i, j;
  GLuint names, *ptr;
  
  ptr = (GLuint *) buffer;
  for (i = 0; i < hits; i++) 
    { 
      names = *ptr;
      ptr += 3;
      for (j = 0; j < names; j++) 
	return ( *ptr);
    }
  return 0;
}

int pickObject_XZ(float x, float y)
{
  GLuint selectBuf[BUFSIZE];
  GLint hits;
  GLint viewport[4];
  
  glGetIntegerv(GL_VIEWPORT, viewport);
  glSelectBuffer(BUFSIZE, selectBuf);
  glRenderMode(GL_SELECT);
  glInitNames();
  glPushName(-1);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluPickMatrix((GLdouble)x, (GLdouble) (viewport[3] - y), 2.0, 2.0, viewport);
  glOrtho(-50.0/y_camXZ, 50.0/y_camXZ, -50.0/y_camXZ, 50.0/y_camXZ, 1.0, 2000.0);
  gluLookAt(0.0, 100.0, 0.0, 0.0, 0.0, 0.0 ,1.0,0.0,0.0);
  parse_level1(gl_scene->root, DrawViewXZfromTreeSelect);
  glPopMatrix();
  hits = glRenderMode(GL_RENDER);
  return processHitsOnXZ(hits, selectBuf);
}

gboolean glarea_display_XZ(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  GtkGLArea *glarea_XZ = (GtkGLArea *) widget;

  if (gtk_gl_area_make_current(glarea_XZ))
    {
      glViewport(0, 0, SIZE_X_WIN_XZ, SIZE_Y_WIN_XZ);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      glOrtho(-50.0/y_camXZ, 50.0/y_camXZ, -50.0/y_camXZ, 50.0/y_camXZ, 1.0, 2000.0);
      gluLookAt(0.0, 100.0, 0.0, 0.0, 0.0, 0.0 ,1.0,0.0,0.0);
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      glClearColor (1.0, 1.0, 1.0, 1.0);
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      glBegin(GL_LINES);
      glColor3f(0.0, 0.0, 0.0);
      glVertex3f( 50.0/y_camXZ, 0.0, 0.0);
      glVertex3f(-50.0/y_camXZ, 0.0, 0.0);
      glVertex3f(0.0, 0.0, 50.0/y_camXZ);
      glVertex3f(0.0, 0.0,-50.0/y_camXZ);
      glEnd();
      if (gl_scene->root->childs)
	parse_level1(gl_scene->root, DrawViewXZfromTreeRender);
      gtk_gl_area_swapbuffers(glarea_XZ);
    }
  return TRUE;
}

gint ObjectOperationGetId_XZ(GdkEventMotion *mevent)
{
  real_start_pos.x = (mevent->x - SIZE_X_WIN_XZ/2) / (y_camXZ * 5);
  real_start_pos.y = (-mevent->y+ SIZE_Y_WIN_XZ/2) / (y_camXZ * 5);
  return pickObject_XZ(mevent->x, mevent->y);
}

gint ObjectOnMove_XZ(GdkEventMotion *mevent)
{
  float Xreal = (mevent->x - SIZE_X_WIN_XZ/2) / (y_camXZ * 5);
  float Zreal = (-mevent->y+ SIZE_Y_WIN_XZ/2) / (y_camXZ * 5);
  t_list_obj_select *obj_select;
  int i;

  obj_select = GetSelectedObject(gl_scene->root);
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->translate->x += Zreal - real_start_pos.y;
      obj_select->mem_obj[i]->prop_base->translate->y += 0;
      obj_select->mem_obj[i]->prop_base->translate->z += Xreal - real_start_pos.x;
    }
  real_start_pos.x = Xreal;
  real_start_pos.y = Zreal;
  gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.vu3d_b)
    gtk_widget_queue_draw(glarea_CAM);
  return TRUE;
}

gint ObjectOnResize_XZ(GdkEventMotion *mevent)
{
  float Xreal = (mevent->x - SIZE_Y_WIN_XZ/2) / (y_camXZ * 5);
  float Zreal = (-mevent->y+ SIZE_X_WIN_XZ/2) / (y_camXZ * 5);
  static VECT2D scale = {0.0, 0.0};
  int i;
  t_list_obj_select *obj_select;
  
  obj_select = GetSelectedObject(gl_scene->root);
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->scale->x *= (-scale.x + Xreal)/10 + 1;
      obj_select->mem_obj[i]->prop_base->scale->z *= (-scale.y + Zreal)/10 + 1;
    }
  gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.vu3d_b)
    gtk_widget_queue_draw(glarea_CAM);
  scale.x = Xreal;
  scale.y = Zreal;
  return TRUE;
}

gint ObjectOnRotate_XZ(GdkEventMotion *mevent)
{
  VECT2D real_current_pos;
  VECT2D center;
  float angle;
  float alkashi_denum;
  t_list_obj_select *obj_select;
  int i;
  
  obj_select = GetSelectedObject(gl_scene->root);
  center.x = 0;
  center.y = 0;
  real_current_pos.x = (mevent->x - SIZE_X_WIN_XZ/2) / (y_camXZ * 5);
  real_current_pos.y = (-mevent->y+ SIZE_Y_WIN_XZ/2) / (y_camXZ * 5);
  alkashi_denum = (2*sqrt(SqrNorme2D(center, real_start_pos))*
		   sqrt(SqrNorme2D(center, real_current_pos)));
  
  if (real_current_pos.x != 0 &&
      real_current_pos.y != 0 &&
      real_start_pos.x != 0 &&
      real_start_pos.y != 0 && alkashi_denum != 0)
    {
      angle = RAD2DEG* (acos((-SqrNorme2D(real_current_pos, real_start_pos) +
			      SqrNorme2D(center, real_start_pos) + 
			      SqrNorme2D(center, real_current_pos)) / alkashi_denum));
      if ((ComputeAngle(real_start_pos)
	   -ComputeAngle(real_current_pos)) > 0)
	angle = -angle;
      for (i = 0; i < obj_select->size; i++)
	obj_select->mem_obj[i]->prop_base->rotate->y += angle;    
      gtk_widget_queue_draw(glarea_XZ);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.vu3d_b)
	gtk_widget_queue_draw(glarea_CAM);
    }
  real_start_pos.x = real_current_pos.x;
  real_start_pos.y = real_current_pos.y;
  return TRUE;
}

gboolean update_position_mouse_on_XZ(GtkWidget *widget, GdkEventMotion *mevent)
{
  gdouble Xreal;
  gdouble Zreal;
  gchar *tmp;
  
  Xreal = (mevent->x - SIZE_X_WIN_XZ/2) / (y_camXZ * 5);
  Zreal = (-mevent->y+ SIZE_Y_WIN_XZ/2) / (y_camXZ * 5);
  tmp = g_strdup_printf("%f", Xreal);
  gtk_label_set_text(GTK_LABEL(lblZ_on_XZ), (const gchar *)tmp);
  tmp = g_strdup_printf("%f", Zreal);
  gtk_label_set_text(GTK_LABEL(lblX_on_XZ), (const gchar *)tmp);
  return TRUE;
}

gint ButtonPressedDispatcher_XZ(GtkWidget *window, GdkEventButton *event,
				GtkWidget *glarea_XZ)
{
  GdkEventMotion *mevent = (GdkEventMotion *)event;
  float Xreal = (mevent->x - SIZE_X_WIN_XZ/2) / (y_camXZ * 5);
  float Zreal = (-mevent->y+ SIZE_Y_WIN_XZ/2) / (y_camXZ * 5);
  t_list_obj_select *obj_select;
  int i;
  
  obj_select = GetSelectedObject(gl_scene->root);
  switch (op_select)
    {
    case SELECT:
      current_id = pickObject_XZ(mevent->x, mevent->y);
      if (current_id)
	{
	  for (i = 0; i < obj_select->size; i++)
	    {
	      if (obj_select->mem_obj[i]->prop_base->id != current_id)
		obj_select->mem_obj[i]->prop_base->is_selected = 0;
	    }
	  parse_level1(gl_scene->root, ChangeIdObjSel);
	}
      break;
    case MOVE:
      if (obj_select->size)
	ON_MOVE_OBJECT_XZ = ObjectOperationGetId_XZ(mevent);
      break;
    case RESIZE:
      if (obj_select->size)
	ON_RESIZE_OBJECT_XZ = ObjectOperationGetId_XZ(mevent);
      break;
    case ROTATE:
      if (obj_select->size)
	ON_ROTATE_OBJECT_XZ = ObjectOperationGetId_XZ(mevent);
      break;
    case SET_LIGHT:
      return SetColorLight(Xreal, 0, Zreal);
      break;
    case BOX:
      CreateBox(Zreal, 0, Xreal);
      break;
    case CONE:
      CreateCone(Xreal, 0, Zreal);
      break;
    case CYLINDRE:
      CreateCylindre(Xreal, 0, Zreal);
      break;
    case SPHERE:
      CreateSphere(Xreal, 0, Zreal);
      break;
    case PLANE:
      CreatePlane(Xreal, 0, Zreal);
      break;
    case TORUS:
      CreateTorus(Xreal, 0, Zreal);
      break;
    case TUBE:
      CreateTube(Xreal, 0, Zreal);
      break;
    case OPEN_CONE:
      CreateOpenCone(Xreal, 0, Zreal);
      break;
    case SOR:
      CreateSor(Xreal, 0, Zreal);
      break;
    default:
      return FALSE;
    }
  gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.vu3d_b)
  gtk_widget_queue_draw(glarea_CAM);
  return TRUE;
}

gboolean ViewEventDispatcher_XZ(GtkWidget *glarea_XZ, GdkEvent *event,
				GtkWidget *window)
{
  switch (event->type)
    {
    case GDK_BUTTON_PRESS:
      {
	GdkEventButton *bevent = (GdkEventButton *)event;
	
	if (bevent->button == 1)
	  ButtonPressedDispatcher_XZ(window, bevent, glarea_XZ);
	if (bevent->button == 3)
	  gtk_menu_popup(GTK_MENU(menu_XZ), NULL, NULL, NULL, NULL,
			 bevent->button, bevent->time);
	break;
      }
    case GDK_MOTION_NOTIFY:
      {
	if (ON_MOVE_OBJECT_XZ)
	  ObjectOnMove_XZ((GdkEventMotion *)event);
	if (ON_RESIZE_OBJECT_XZ)
	  ObjectOnResize_XZ((GdkEventMotion *)event);
	if (ON_ROTATE_OBJECT_XZ)
	  ObjectOnRotate_XZ((GdkEventMotion *)event);
	update_position_mouse_on_XZ(glarea_XZ, (GdkEventMotion *)event);
	break;
      }
    case GDK_BUTTON_RELEASE:
      if (ON_MOVE_OBJECT_XZ)
	ON_MOVE_OBJECT_XZ = !ON_MOVE_OBJECT_XZ;
      if (ON_RESIZE_OBJECT_XZ)
	ON_RESIZE_OBJECT_XZ = !ON_RESIZE_OBJECT_XZ;
      if (ON_ROTATE_OBJECT_XZ)
	ON_ROTATE_OBJECT_XZ = !ON_ROTATE_OBJECT_XZ;
      break;
    case GDK_EXPOSE:
      glarea_display_XZ(glarea_XZ, (GdkEventExpose *)event, NULL);
    default:
      return FALSE;
    }
  return TRUE;
}

void ZoomIn_XZ(void)
{
  y_camXZ += 0.1;
  gtk_widget_queue_draw(glarea_XZ);
}

void ZoomOut_XZ(void)
{
  y_camXZ -= 0.1;
  if (y_camXZ <= 0)
    y_camXZ = 0.1;
  gtk_widget_queue_draw(glarea_XZ);
}

void WindowXZCreateGL (void)
{
  GtkWidget	*vbox;
  GtkWidget	*hbox;
  GtkWidget	*label;
  GtkWidget	*menu_items;
  GtkWidget	*SubMenu;
  GtkWidget	*SubMenuOperation;
  GtkWidget	*XXXMenu;
  GtkWidget	*XXXMenuOperation;
  int		i, j;
  
  glarea_XZ = gtk_gl_area_new_vargs(NULL,
				    GDK_GL_RGBA,
				    GDK_GL_DOUBLEBUFFER,
				    GDK_GL_DEPTH_SIZE,1,
				    GDK_GL_NONE);  
  gtk_widget_set_usize(GTK_WIDGET(glarea_XZ), SIZE_X_WIN_XZ, SIZE_Y_WIN_XZ);
  gtk_widget_set_events(GTK_WIDGET(glarea_XZ),
			GDK_EXPOSURE_MASK|
			GDK_BUTTON_PRESS_MASK|
			GDK_BUTTON_RELEASE_MASK| 
			GDK_POINTER_MOTION_MASK|
 			GDK_KEY_PRESS_MASK);
  gtk_window_set_title (GTK_WINDOW(WOver), "View XZ");
  gtk_signal_connect(GTK_OBJECT(glarea_XZ), "event",
		     GTK_SIGNAL_FUNC(ViewEventDispatcher_XZ), WOver);
  gtk_container_set_border_width(GTK_CONTAINER(WOver), 5);
  
  vbox = gtk_vbox_new(0,0);
  gtk_container_add(GTK_CONTAINER(WOver),vbox);
  gtk_widget_show(vbox);

  gtk_box_pack_start(GTK_BOX(vbox),glarea_XZ,1,1,0);
  gtk_widget_show(glarea_XZ); 

  hbox = gtk_hbox_new(0,0);
  gtk_container_add(GTK_CONTAINER(vbox), hbox);
  gtk_widget_show(hbox);
  
  vbox=gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), 10, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(vbox); /* show vbox */

  label = gtk_label_new("X:");
  gtk_box_pack_start(GTK_BOX(vbox),label,1,1,0);
  gtk_widget_show(label);

  vbox=gtk_vbox_new(0,0);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(vbox);/* show vbox */

  lblX_on_XZ = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(vbox), lblX_on_XZ, 1, 1, 0);
  gtk_widget_show(lblX_on_XZ);

  vbox=gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), 10, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);

  label = gtk_label_new("Z:");
  gtk_box_pack_start(GTK_BOX(vbox),label,1,1,0);
  gtk_widget_show(label);

  vbox = gtk_vbox_new(0,0);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);

  lblZ_on_XZ = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(vbox), lblZ_on_XZ, 1, 1, 0);
  gtk_widget_show(lblZ_on_XZ);

  vbox = gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), SIZE_X_WIN_XZ/2, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);
  /* set popup in this view XZ*/
  for (i = 0; i < NB_MENU_POPUP_XZ; i++)
    menu_popup_XZ[i] = (t_menu_popup *)malloc(sizeof(t_menu_popup) * 
					      prop_menu_XZ[i].nb_submenu);
  menu_popup_XZ[0][0].item = "Open POV";	menu_popup_XZ[0][0].fcn = OpenPovFunc;
  menu_popup_XZ[0][1].item = "Save POV";	menu_popup_XZ[0][1].fcn = SavePovFunc;
  menu_popup_XZ[0][2].item = "Close";		menu_popup_XZ[0][2].fcn = close_construct_face;
  
  /* Edit File */
  menu_popup_XZ[1][0].item = "Cut";		menu_popup_XZ[1][0].fcn = CutFunc;
  menu_popup_XZ[1][1].item = "Copy";		menu_popup_XZ[1][1].fcn = CopyFunc;
  menu_popup_XZ[1][2].item = "Paste";		menu_popup_XZ[1][2].fcn = PasteFunc;

  /* View Menu */
  menu_popup_XZ[2][0].item = "Zoom In";		menu_popup_XZ[2][0].fcn = ZoomIn_XZ;
  menu_popup_XZ[2][1].item = "Zoom Out";	menu_popup_XZ[2][1].fcn = ZoomOut_XZ;

  menu_popup_XZ[3][0].item = "Color";		menu_popup_XZ[3][0].fcn = SetColorObject;
  menu_popup_XZ[3][1].item = "Delete";		menu_popup_XZ[3][1].fcn = DeleteObject;
  menu_popup_XZ[3][2].item = "Rotate";		menu_popup_XZ[3][2].fcn = RotateObject;
  menu_popup_XZ[3][3].item = "Translate";	menu_popup_XZ[3][3].fcn = TranslateObject;
  menu_popup_XZ[3][4].item = "Scale";		menu_popup_XZ[3][4].fcn = ScaleObject;

  menu_popup_XZ[4][0].item = "Properties";	menu_popup_XZ[4][0].fcn = ChangeColorLight;
  /* set popup */
  menu_XZ = gtk_menu_new();
  menu_items = gtk_tearoff_menu_item_new();
  gtk_widget_show(menu_items);
  gtk_menu_append(GTK_MENU(menu_XZ), menu_items);

  SubMenuOperation = gtk_menu_new();   

  for (i = 0 ; i < NB_MENU_POPUP_XZ; i++)
    {
      SubMenu = gtk_menu_new();
      if (i == 3)
	{
	  for (j = 0; j < prop_menu_XZ[i].nb_submenu; j++)
	    {
	      if (j == 0 || j == 1)
		{
		  menu_items = gtk_menu_item_new_with_label(menu_popup_XZ[i][j].item);
		  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
		  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					    GTK_SIGNAL_FUNC(menu_popup_XZ[i][j].fcn), NULL);
		  gtk_widget_show(menu_items);
		}
	      else
		{
		  menu_items = gtk_menu_item_new_with_label(menu_popup_XZ[i][j].item);
		  gtk_menu_append(GTK_MENU(SubMenuOperation), menu_items);
		  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					    GTK_SIGNAL_FUNC(menu_popup_XZ[i][j].fcn), NULL);
		  gtk_widget_show(menu_items);		  
		}
	    }
	  free(menu_popup_XZ[i]);
	  /* XXXMenu <=> FileMenu, EditMenu, ToolMenu....XXX={file, edit, ...} */
	  XXXMenu = gtk_menu_item_new_with_label(prop_menu_XZ[i].name_menu);
	  gtk_widget_show(XXXMenu);
	  XXXMenuOperation = gtk_menu_item_new_with_label("Operation");
	  gtk_widget_show(XXXMenuOperation);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenu), SubMenu);
	  gtk_menu_append(GTK_MENU(menu_XZ), XXXMenu);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenuOperation), SubMenuOperation);
	  gtk_menu_append(GTK_MENU(SubMenu), XXXMenuOperation);
	  
	}
      else
	{
	  for (j = 0; j < prop_menu_XZ[i].nb_submenu; j++)
	    {
	      menu_items = gtk_menu_item_new_with_label(menu_popup_XZ[i][j].item);
	      gtk_menu_append(GTK_MENU(SubMenu), menu_items);
	      gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					GTK_SIGNAL_FUNC(menu_popup_XZ[i][j].fcn), NULL);
	      gtk_widget_show(menu_items);
	    }
	  free(menu_popup_XZ[i]);
	  /* XXXMenu <=> FileMenu, EditMenu, ToolMenu....XXX={file, edit, ...} */
	  XXXMenu = gtk_menu_item_new_with_label(prop_menu_XZ[i].name_menu);
	  gtk_widget_show(XXXMenu);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenu), SubMenu);
	  gtk_menu_append(GTK_MENU(menu_XZ), XXXMenu);
	}
    }
}

void WindowXZ_new(void)
{
  windows_view.over= gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect (GTK_OBJECT (windows_view.over), 
		      "delete_event", 
		      GTK_SIGNAL_FUNC (close_construct_over), 
		      NULL);
      
  gtk_container_set_border_width (GTK_CONTAINER (WOver), 3);
  WindowXZCreateGL();
  gtk_widget_show_all(WOver);
}
