#include "headers.h"

GtkWidget	*menu_YZ;
GLdouble	x_camYZ = 1;
gboolean	ON_MOVE_OBJECT_YZ;
gboolean	ON_RESIZE_OBJECT_YZ;
gboolean	ON_ROTATE_OBJECT_YZ;
VECT2D		real_start_pos;
t_menu_popup	*menu_popup_YZ[NB_MENU_POPUP_YZ];
t_features_menu	prop_menu_YZ[NB_MENU_POPUP_YZ] = 
{
  {
    "File",
    3,
  },
  {
    "Edit",
    3,
  },
  {
    "View",
    2,
  },
  {
    "Object",
    5,
  },
  {
    "Light",
    1,
  },
};

gboolean make_expose_on_viewYZ(void)
{
  GdkEventExpose *expose;
  gboolean *return_val;

  expose = (GdkEventExpose *)g_malloc(sizeof(GdkEventExpose));
  expose->type = GDK_EXPOSE;
  expose->window = glarea_YZ->window;
  expose->send_event = FALSE;
  expose->area.x = 0;
  expose->area.y = 0;
  expose->area.width = 500;
  expose->area.height = 500;
  expose->count = 0;
  gtk_signal_emit_by_name(GTK_OBJECT(glarea_YZ), "expose_event", glarea_YZ,
			  expose, NULL, return_val);
  g_free(expose);
  return TRUE;
}

void draw_scene_on_viewYZ(T_obj *obj, GLenum render_mode)
{
  int i;
  T_face *face;
  
  glPushMatrix();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glRotatef(obj->prop_base->rotate->x, 1, 0, 0);
  glRotatef(obj->prop_base->rotate->y, 0, 1, 0);
  glRotatef(obj->prop_base->rotate->z, 0, 0, 1);
  glTranslatef(obj->prop_base->translate->x,
	       obj->prop_base->translate->y,
	       obj->prop_base->translate->z);
  glScalef(obj->prop_base->scale->x,
	   obj->prop_base->scale->y,
	   obj->prop_base->scale->z);

  if (render_mode == GL_SELECT)
    {
      glLoadName(obj->prop_base->id);
      glBegin(GL_TRIANGLES);
    }
  else
    {
      CalculateNormal(obj);
      glBegin(GL_LINE_LOOP);
    }
  for (i = 0; i < obj->prop_base->nb_face; i++)
    {
      if (obj->prop_base->is_selected)
	glColor3f(1.0, 0.0, 0.0);
      else
	glColor3f(0.0, 0.0, 0.0);
      if (render_mode == GL_RENDER)
	glNormal3f(obj->prop_base->normal[i].x,
		   obj->prop_base->normal[i].y,
		   obj->prop_base->normal[i].z);
      face = ReadTriangleOfMesh(obj->prop_base->list_vertex, i);
      glVertex3f(face->A->x, face->A->y, face->A->z);
      glVertex3f(face->B->x, face->B->y, face->B->z);      
      glVertex3f(face->C->x, face->C->y, face->C->z);
    }
  glEnd();
  glPopMatrix();
}

int  processHitsOnYZ(GLint hits, GLuint buffer[])
{
  unsigned int i, j;
  GLuint names, *ptr;
  
  ptr = (GLuint *) buffer;
  for (i = 0; i < hits; i++) 
    { 
      names = *ptr;
      ptr += 3;
      for (j = 0; j < names; j++) 
	return ( *ptr);
    }
  return 0;
}

int pickObject_YZ(float x, float y)
{
  GLuint selectBuf[BUFSIZE];
  GLint hits;
  GLint viewport[4];
  
  glGetIntegerv(GL_VIEWPORT, viewport);
  glSelectBuffer(BUFSIZE, selectBuf);
  glRenderMode(GL_SELECT);
  glInitNames();
  glPushName(-1);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluPickMatrix((GLdouble)x, (GLdouble) (viewport[3] - y), 2.0, 2.0, viewport);
  glOrtho(-50.0/x_camYZ, 50.0/x_camYZ, -50.0/x_camYZ, 50.0/x_camYZ, 1.0, 2000.0);
  gluLookAt(-100.0, 0.0, 0.0, 0.0, 0.0, 0.0 ,0.0,1.0,0.0);
  parse_level1(gl_scene->root, DrawViewYZfromTreeSelect);
  glPopMatrix();
  hits = glRenderMode(GL_RENDER);
  return processHitsOnYZ(hits, selectBuf);
}


gboolean glarea_display_YZ(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  GtkGLArea *glarea_YZ = (GtkGLArea *) widget;

  if (gtk_gl_area_make_current(glarea_YZ))
    {
      glViewport(0, 0, 500, 500);
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      glOrtho(-50.0/x_camYZ, 50.0/x_camYZ, -50.0/x_camYZ, 50.0/x_camYZ, 1.0, 2000.0);
      gluLookAt(-100.0, 0.0, 0.0, 0.0, 0.0, 0.0 ,0.0,1.0,0.0);
      glMatrixMode(GL_MODELVIEW);
      glClearColor (1.0, 1.0, 1.0, 1.0);
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      glLoadIdentity();
      glBegin(GL_LINES);
      glColor3f(0.0, 0.0, 0.0);
      glVertex3f(0.0, 50.0/x_camYZ, 0.0);
      glVertex3f(0.0, -50.0/x_camYZ, 0.0);
      glVertex3f(0.0, 0.0, 50.0/x_camYZ);
      glVertex3f(0.0, 0.0,-50.0/x_camYZ);
      glEnd();
      if (gl_scene->root->childs)
	parse_level1(gl_scene->root, DrawViewYZfromTreeRender);
      gtk_gl_area_swapbuffers(glarea_YZ);
    }
  return TRUE;
}

gint ObjectOperationGetId_YZ(GdkEventMotion *mevent)
{
  real_start_pos.x = (mevent->x - SIZE_X_WIN_YZ/2) / (x_camYZ * 5);
  real_start_pos.y = (-mevent->y+ SIZE_Y_WIN_YZ/2) / (x_camYZ * 5);
  return pickObject_YZ(mevent->x, mevent->y);
}

gint ObjectOnMove_YZ(GdkEventMotion *mevent)
{
  float Yreal = (mevent->x - SIZE_X_WIN_YZ/2) / (x_camYZ * 5);
  float Zreal = (-mevent->y+ SIZE_Y_WIN_YZ/2) / (x_camYZ * 5);
  t_list_obj_select *obj_select;
  int i;
  
  obj_select = GetSelectedObject(gl_scene->root);
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->translate->x += 0;
      obj_select->mem_obj[i]->prop_base->translate->y += Zreal - real_start_pos.y;
      obj_select->mem_obj[i]->prop_base->translate->z += Yreal - real_start_pos.x;
    } 
  real_start_pos.x = Yreal;
  real_start_pos.y = Zreal;
  gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.vu3d_b)
    gtk_widget_queue_draw(glarea_CAM);
  return TRUE;
}

gint ObjectOnResize_YZ(GdkEventMotion *mevent)
{
  float Yreal = (mevent->x - SIZE_X_WIN_YZ/2) / (x_camYZ * 5);
  float Zreal = (-mevent->y+ SIZE_Y_WIN_YZ/2) / (x_camYZ * 5);
  static VECT2D scale = {0.0, 0.0};
  int i;
  t_list_obj_select *obj_select;
  
  obj_select = GetSelectedObject(gl_scene->root);
  for (i = 0; i < obj_select->size; i++)
    {
      obj_select->mem_obj[i]->prop_base->scale->y *= (-scale.y + Zreal)/10 + 1;
      obj_select->mem_obj[i]->prop_base->scale->z *= (-scale.x + Yreal)/10 + 1;
    } 
  gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.vu3d_b)
    gtk_widget_queue_draw(glarea_CAM);
  scale.x = Yreal;
  scale.y = Zreal;
  return TRUE;
}

gint ObjectOnRotate_YZ(GdkEventMotion *mevent)
{
  VECT2D real_current_pos;
  VECT2D center;
  float angle;
  float alkashi_denum;
  t_list_obj_select *obj_select;
  int i;
  
  obj_select = GetSelectedObject(gl_scene->root);
  center.x = 0;
  center.y = 0;
  real_current_pos.x = (mevent->x - SIZE_X_WIN_YZ/2) / (x_camYZ * 5);
  real_current_pos.y = (-mevent->y+ SIZE_Y_WIN_YZ/2) / (x_camYZ * 5);
  alkashi_denum = (2*sqrt(SqrNorme2D(center, real_start_pos))*
		   sqrt(SqrNorme2D(center, real_current_pos)));

  if (real_current_pos.x != 0 &&
      real_current_pos.y != 0 &&
      real_start_pos.x != 0 &&
      real_start_pos.y != 0 && alkashi_denum != 0)
    {
      angle = RAD2DEG* (acos((-SqrNorme2D(real_current_pos, real_start_pos) +
			      SqrNorme2D(center, real_start_pos) + 
			      SqrNorme2D(center, real_current_pos)) / alkashi_denum));
      if ((ComputeAngle(real_start_pos)
	   -ComputeAngle(real_current_pos)) < 0)
	angle = -angle;
      for (i = 0; i < obj_select->size; i++)
	obj_select->mem_obj[i]->prop_base->rotate->x += angle;
      gtk_widget_queue_draw(glarea_YZ);
      if (open_windows.right_b)
	gtk_widget_queue_draw(glarea_XY);
      if (open_windows.over_b)
	gtk_widget_queue_draw(glarea_XZ);
      if (open_windows.vu3d_b)
	gtk_widget_queue_draw(glarea_CAM);
    }
  real_start_pos.x = real_current_pos.x;
  real_start_pos.y = real_current_pos.y;
  return TRUE;
}

gboolean update_position_mouse_on_YZ(GtkWidget *widget, GdkEventMotion *mevent)
{
  gdouble Yreal;
  gdouble Zreal;
  gchar *tmp;

  Yreal = (mevent->x - SIZE_X_WIN_YZ/2) / (x_camYZ * 5);
  Zreal = (-mevent->y+ SIZE_Y_WIN_YZ/2) / (x_camYZ * 5);
  tmp = g_strdup_printf("%f", Yreal);
  gtk_label_set_text(GTK_LABEL(lblY_on_YZ), (const gchar *)tmp);
  tmp = g_strdup_printf("%f", Zreal);
  gtk_label_set_text(GTK_LABEL(lblZ_on_YZ), (const gchar *)tmp);
  return TRUE;
}

gint ButtonPressedDispatcher_YZ(GtkWidget *window, GdkEventButton *event,
				GtkWidget *glarea_YZ)
{
  GdkEventMotion *mevent = (GdkEventMotion *)event;
  float Yreal = (mevent->x - SIZE_X_WIN_YZ/2) / (x_camYZ * 5);
  float Zreal = (-mevent->y+ SIZE_Y_WIN_YZ/2) / (x_camYZ * 5);
  t_list_obj_select *obj_select;
  int i;
  
  obj_select = GetSelectedObject(gl_scene->root);
  switch (op_select)
    {
    case SELECT:
      current_id = pickObject_YZ(mevent->x, mevent->y);
      if (current_id)
	{
	  for (i = 0; i < obj_select->size; i++)
	    {
	      if (obj_select->mem_obj[i]->prop_base->id != current_id)
		obj_select->mem_obj[i]->prop_base->is_selected = 0;
	    }
	  parse_level1(gl_scene->root, ChangeIdObjSel);
	} 
      break;
    case MOVE:
      if (obj_select->size)
	ON_MOVE_OBJECT_YZ = ObjectOperationGetId_YZ(mevent);
      break;
    case RESIZE:
      if (obj_select->size)
	ON_RESIZE_OBJECT_YZ = ObjectOperationGetId_YZ(mevent);
      break;
    case ROTATE:
      if (obj_select->size)
	ON_ROTATE_OBJECT_YZ = ObjectOperationGetId_YZ(mevent);
      break;
    case SET_LIGHT:
      return SetColorLight(0, Zreal, Yreal);
    case BOX:
      CreateBox(0, Zreal, Yreal);
      break;
    case CONE:
      CreateCone(0, Zreal, Yreal);
      break;
    case CYLINDRE:
      CreateCylindre(0, Zreal, Yreal);
      break;
    case SPHERE:
      CreateSphere(0, Zreal, Yreal);
      break;
    case PLANE:
      CreatePlane(0, Zreal, Yreal);
      break;
    case TORUS:
      CreateTorus(0, Zreal, Yreal);
      break;
    case TUBE:
      CreateTube(0, Zreal, Yreal);
      break;
    case OPEN_CONE:
      CreateOpenCone(0, Zreal, Yreal);
      break;
    case SOR:
      CreateSor(0, Zreal, Yreal);
      break;
    default:
      return FALSE;
    }
  gtk_widget_queue_draw(glarea_YZ);
  if (open_windows.right_b)
    gtk_widget_queue_draw(glarea_XY);
  if (open_windows.over_b)
    gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.vu3d_b)
    gtk_widget_queue_draw(glarea_CAM);
  return TRUE;
}

gboolean ViewEventDispatcher_YZ(GtkWidget *glarea_YZ, GdkEvent *event,
				GtkWidget *window)
{
  switch (event->type)
    {
    case GDK_BUTTON_PRESS:
      {
	GdkEventButton *bevent = (GdkEventButton *)event;
      
	if (bevent->button == 1)
	  ButtonPressedDispatcher_YZ(window, bevent, glarea_YZ);
	if (bevent->button == 3)
	  gtk_menu_popup(GTK_MENU(menu_YZ), NULL, NULL, NULL, NULL,
			 bevent->button, bevent->time);
	break;
      }
    case GDK_MOTION_NOTIFY:
      if (ON_MOVE_OBJECT_YZ)
	ObjectOnMove_YZ((GdkEventMotion *)event);
      if (ON_RESIZE_OBJECT_YZ)
	ObjectOnResize_YZ((GdkEventMotion *)event);
      if (ON_ROTATE_OBJECT_YZ)
	ObjectOnRotate_YZ((GdkEventMotion *)event);
      update_position_mouse_on_YZ(glarea_YZ, (GdkEventMotion *)event);
      break;
    case GDK_BUTTON_RELEASE:
      if (ON_MOVE_OBJECT_YZ)
	ON_MOVE_OBJECT_YZ = !ON_MOVE_OBJECT_YZ;
      if (ON_RESIZE_OBJECT_YZ)
	ON_RESIZE_OBJECT_YZ = !ON_RESIZE_OBJECT_YZ;
      if (ON_ROTATE_OBJECT_YZ)
	ON_ROTATE_OBJECT_YZ = !ON_ROTATE_OBJECT_YZ;
      break;
    case GDK_EXPOSE:
      glarea_display_YZ(glarea_YZ, (GdkEventExpose *)event, NULL);
      break;
    default:
      return FALSE;
    }
  return TRUE;
}

void ZoomIn_YZ(void)
{
  x_camYZ += 0.1;
  gtk_widget_queue_draw(glarea_YZ);
}

void ZoomOut_YZ(void)
{
  x_camYZ -= 0.1;
  if (x_camYZ <= 0)
    x_camYZ = 0.1;
  gtk_widget_queue_draw(glarea_YZ);
}


void WindowYZCreateGL (void)
{
  GtkWidget	*hbox;
  GtkWidget	*vbox;
  GtkWidget	*label;
  GtkWidget	*menu_items;
  GtkWidget	*SubMenu;
  GtkWidget	*SubMenuOperation;
  GtkWidget	*XXXMenu;
  GtkWidget	*XXXMenuOperation;
  int		i, j;
  
  glarea_YZ = gtk_gl_area_new_vargs(NULL,
				    GDK_GL_RGBA,
				    GDK_GL_DOUBLEBUFFER,
				    GDK_GL_DEPTH_SIZE,1,
				    GDK_GL_NONE);  
  gtk_widget_set_usize(GTK_WIDGET(glarea_YZ), 500, 500);
  gtk_widget_set_events(GTK_WIDGET(glarea_YZ),
			GDK_EXPOSURE_MASK|
			GDK_BUTTON_PRESS_MASK|
			GDK_BUTTON_RELEASE_MASK|
			GDK_POINTER_MOTION_MASK|
			GDK_KEY_PRESS_MASK);
  gtk_window_set_title (GTK_WINDOW(WRight), "View YZ");
  gtk_signal_connect (GTK_OBJECT(glarea_YZ),"event",
		      GTK_SIGNAL_FUNC (ViewEventDispatcher_YZ), WRight); 
  gtk_container_set_border_width(GTK_CONTAINER(WRight), 5);
  
  vbox = gtk_vbox_new(0,0);
  gtk_container_add(GTK_CONTAINER(WRight), vbox);
  gtk_widget_show(vbox);

  gtk_box_pack_start(GTK_BOX(vbox),glarea_YZ,1,1,0);
  gtk_widget_show(glarea_YZ); 

  hbox = gtk_hbox_new(0,0);
  gtk_container_add(GTK_CONTAINER(vbox), hbox);
  gtk_widget_show(hbox);
  
  vbox = gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), 10, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(vbox); /* show vbox */

  label = gtk_label_new("Y:");
  gtk_box_pack_start(GTK_BOX(vbox),label,1,1,0);
  gtk_widget_show(label);

  vbox = gtk_vbox_new(0,0);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(vbox);/* show vbox */

  lblY_on_YZ = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(vbox), lblY_on_YZ, 1, 1, 0);
  gtk_widget_show(lblY_on_YZ);

  vbox=gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), 10, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);

  label = gtk_label_new("Z:");
  gtk_box_pack_start(GTK_BOX(vbox),label,1,1,0);
  gtk_widget_show(label);

  vbox = gtk_vbox_new(0,0);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);

  lblZ_on_YZ = gtk_label_new("");
  gtk_box_pack_start(GTK_BOX(vbox), lblZ_on_YZ, 1, 1, 0);
  gtk_widget_show(lblZ_on_YZ);

  vbox = gtk_vbox_new(0,0);
  gtk_widget_set_usize (GTK_WIDGET(vbox), SIZE_X_WIN_YZ/2, 20);
  gtk_box_pack_start(GTK_BOX(hbox),vbox,1,1,0);
  gtk_widget_show(hbox);

  /* set popup in this view YZ */
  for (i = 0; i < NB_MENU_POPUP_YZ; i++)
    menu_popup_YZ[i] = (t_menu_popup *)malloc(sizeof(t_menu_popup) * 
					      prop_menu_YZ[i].nb_submenu);
  menu_popup_YZ[0][0].item = "Open POV";	menu_popup_YZ[0][0].fcn = OpenPovFunc;
  menu_popup_YZ[0][1].item = "Save POV";	menu_popup_YZ[0][1].fcn = SavePovFunc;
  menu_popup_YZ[0][2].item = "Close";		menu_popup_YZ[0][2].fcn = close_construct_face;
  
  /* Edit File */
  menu_popup_YZ[1][0].item = "Cut";		menu_popup_YZ[1][0].fcn = CutFunc;
  menu_popup_YZ[1][1].item = "Copy";		menu_popup_YZ[1][1].fcn = CopyFunc;
  menu_popup_YZ[1][2].item = "Paste";		menu_popup_YZ[1][2].fcn = PasteFunc;

  /* View Menu */
  menu_popup_YZ[2][0].item = "Zoom In";		menu_popup_YZ[2][0].fcn = ZoomIn_YZ;
  menu_popup_YZ[2][1].item = "Zoom Out";	menu_popup_YZ[2][1].fcn = ZoomOut_YZ;

  menu_popup_YZ[3][0].item = "Color";		menu_popup_YZ[3][0].fcn = SetColorObject;
  menu_popup_YZ[3][1].item = "Delete";		menu_popup_YZ[3][1].fcn = DeleteObject;
  menu_popup_YZ[3][2].item = "Rotate";		menu_popup_YZ[3][2].fcn = RotateObject;
  menu_popup_YZ[3][3].item = "Translate";	menu_popup_YZ[3][3].fcn = TranslateObject;
  menu_popup_YZ[3][4].item = "Scale";		menu_popup_YZ[3][4].fcn = ScaleObject;

  menu_popup_YZ[4][0].item = "Properties";	menu_popup_YZ[4][0].fcn = ChangeColorLight;
  /* set popup */
  menu_YZ = gtk_menu_new();
  menu_items = gtk_tearoff_menu_item_new();
  gtk_widget_show(menu_items);
  gtk_menu_append(GTK_MENU(menu_YZ), menu_items);

  SubMenuOperation = gtk_menu_new();   
    
  for (i = 0 ; i < NB_MENU_POPUP_YZ; i++)
    {
      SubMenu = gtk_menu_new();
      if (i == 3)
	{
	  for (j = 0; j < prop_menu_YZ[i].nb_submenu; j++)
	    {
	      if (j == 0 || j == 1)
		{
		  menu_items = gtk_menu_item_new_with_label(menu_popup_YZ[i][j].item);
		  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
		  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					    GTK_SIGNAL_FUNC(menu_popup_YZ[i][j].fcn), NULL);
		  gtk_widget_show(menu_items);
		}
	      else
		{
		  menu_items = gtk_menu_item_new_with_label(menu_popup_YZ[i][j].item);
		  gtk_menu_append(GTK_MENU(SubMenuOperation), menu_items);
		  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					    GTK_SIGNAL_FUNC(menu_popup_YZ[i][j].fcn), NULL);
		  gtk_widget_show(menu_items);		  
		}
	    }
	  free(menu_popup_YZ[i]);
	  /* XXXMenu <=> FileMenu, EditMenu, ToolMenu....XXX={file, edit, ...} */
	  XXXMenu = gtk_menu_item_new_with_label(prop_menu_YZ[i].name_menu);
	  gtk_widget_show(XXXMenu);
	  XXXMenuOperation = gtk_menu_item_new_with_label("Operation");
	  gtk_widget_show(XXXMenuOperation);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenu), SubMenu);
	  gtk_menu_append(GTK_MENU(menu_YZ), XXXMenu);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenuOperation), SubMenuOperation);
	  gtk_menu_append(GTK_MENU(SubMenu), XXXMenuOperation);
	  
	}
      else
	{
	  for (j = 0; j < prop_menu_YZ[i].nb_submenu; j++)
	    {
	      menu_items = gtk_menu_item_new_with_label(menu_popup_YZ[i][j].item);
	      gtk_menu_append(GTK_MENU(SubMenu), menu_items);
	      gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
					GTK_SIGNAL_FUNC(menu_popup_YZ[i][j].fcn), NULL);
	      gtk_widget_show(menu_items);
	    }
	  free(menu_popup_YZ[i]);
	  /* XXXMenu <=> FileMenu, EditMenu, ToolMenu....XXX={file, edit, ...} */
	  XXXMenu = gtk_menu_item_new_with_label(prop_menu_YZ[i].name_menu);
	  gtk_widget_show(XXXMenu);
	  gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenu), SubMenu);
	  gtk_menu_append(GTK_MENU(menu_YZ), XXXMenu);
	}
    }
}

void WindowYZ_new(void)
{
  windows_view.right= gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect (GTK_OBJECT (windows_view.right), 
		      "delete_event", 
		      GTK_SIGNAL_FUNC (close_construct_right), 
		      NULL);
      
  gtk_container_set_border_width (GTK_CONTAINER (WRight), 3);
  WindowYZCreateGL ();
  gtk_widget_show_all (WRight);
}
