#include "headers.h"

int angle = 0;
int rot_x = 0;
int rot_y = 0;
int rot_z = 0; 
int z_cam = 130;
int rot_cam = 180;
float pos_camX;
float pos_camZ;
float pos_camY = 40;
GLenum	mode		= GL_TRIANGLES;


t_menu_popup	*menu_popup[NB_MENU];
t_features_menu	fm[NB_MENU] = 
{
  {
    "File",
    3,
  },
  {
    "Edit",
    3,
  },
  {
    "View",
    2,
  }
};

gboolean make_expose_on_viewCAM(void)
{
  GdkEventExpose *expose;
  gboolean *return_val;

  expose = (GdkEventExpose *)g_malloc(sizeof(GdkEventExpose));
  expose->type = GDK_EXPOSE;
  expose->window = glarea_CAM->window;
  expose->send_event = FALSE;
  expose->area.x = 0;
  expose->area.y = 0;
  expose->area.width = SIZE_X_WIN_CAM;
  expose->area.height = SIZE_Y_WIN_CAM;
  expose->count = 0;
  gtk_signal_emit_by_name(GTK_OBJECT(glarea_CAM), "expose-event", 
			  glarea_CAM, expose, NULL, return_val);
  g_free(expose);
  return TRUE;
}


void draw_grid(int max_length)
{
  int i;
  
  if (max_length < 100)
    max_length = 100;
  for (i =-max_length; i<=max_length; i += 10)
    {
      if (i == 0)
	glLineWidth(2);
      else
	glLineWidth(1);
      glColor3f(0.0, 0.0, 0.0);
      glBegin(GL_LINES);
      glVertex3f(i,0,max_length);
      glVertex3f(i,0,-max_length);
      glVertex3f(-max_length,0,i);
      glVertex3f(max_length,0,i);
      glEnd();
    }
  glColor3f(1.0, 0.0, 0.0);
  glBegin(GL_TRIANGLES);
  glVertex3f(max_length+10, 0.0, 0.0);
  glVertex3f(max_length, 0.0, -5.0);
  glVertex3f(max_length, 0.0, 5.0);
  glEnd();
}


/*
**   pour l'instant on passe un seul objet en parametre, mais plus tard
**   on passera l'ABR contenant tout les objets 
*/
void draw_scene_on_viewCAM(T_obj *obj, GLenum render_mode)
{
  int i;
  T_face *face;
  
  if (render_mode == GL_SELECT)
    glLoadName(100);		/* reference this object */

  glPushMatrix();
  glLoadIdentity();
  glRotatef(obj->prop_base->rotate->x, 1, 0, 0);
  glRotatef(obj->prop_base->rotate->y, 0, 1, 0);
  glRotatef(obj->prop_base->rotate->z, 0, 0, 1);
  glTranslatef(obj->prop_base->translate->x,
	       obj->prop_base->translate->y,
	       obj->prop_base->translate->z);
  glScalef(obj->prop_base->scale->x,
	   obj->prop_base->scale->y,
	   obj->prop_base->scale->z);
  CalculateNormal(obj);
  glBegin(mode);
  for (i = 0; i < obj->prop_base->nb_face; i++)
    {
      glColor3f(obj->prop_base->color[i].x, 
		obj->prop_base->color[i].y, 
		obj->prop_base->color[i].z);
      glNormal3f(obj->prop_base->normal[i].x,
		 obj->prop_base->normal[i].y,
		 obj->prop_base->normal[i].z);
      face = ReadTriangleOfMesh(obj->prop_base->list_vertex, i);
      glVertex3f(face->A->x, face->A->y, face->A->z);
      glVertex3f(face->B->x, face->B->y, face->B->z);      
      glVertex3f(face->C->x, face->C->y, face->C->z);
    }
  glEnd();
  glPopMatrix();
}

void initGL(GtkGLArea *glarea)
{
  glClearColor(1.0, 1.0, 1.0, 1.0);  
  
  glDisable(GL_CULL_FACE);
  glEnable(GL_DEPTH_TEST);

  glEnable(GL_DITHER);
  glShadeModel(GL_SMOOTH);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
  glHint(GL_POLYGON_SMOOTH_HINT, GL_FASTEST);
  
  glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
  glEnable(GL_COLOR_MATERIAL);  

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(90,1,1,2000);
  gluLookAt(0, 40, z_cam, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
  
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  draw_grid(abs(z_cam - 30));
  gtk_gl_area_swapbuffers(glarea);
}

void update_view(GtkWidget *widget, guint key, int width, int height)
{
  switch (key)
    {
    case 65361:		// LEFT
      rot_cam -= 2 % 360;
      break;
    case 65362:		// UP
      pos_camY++;
      break;
    case 65363:		// RIGHT
      rot_cam += 2 % 360;
      break;
    case 65364:		// DOWN
      pos_camY--;
      break;
    case 97:		// A
      z_cam += 10;
      break;
    case 122:		// Z
      z_cam -= 10;
      break;
    case 65470:		// F1
      mode = GL_POINTS;
      break;
    case 65471:		// F2
      glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
      break;
    case 65472:		// F3
      mode = GL_TRIANGLES;
      break;
    case 32:
      glMatrixMode(GL_MODELVIEW);
      glLoadIdentity();
      gtk_widget_queue_draw(glarea_CAM);
      break;
    } 

  if (key == 65361 || key == 65362 || key == 65363 || key == 65364 ||
      key == 97 || key == 122)
    {
      glMatrixMode(GL_MODELVIEW);
      glPushMatrix();
      glLoadIdentity();
      gtk_widget_queue_draw(glarea_CAM);
      glPopMatrix();
    }
    /* update other view */
  if (open_windows.face_b == 1)
      gtk_widget_queue_draw(glarea_XY);
  if (open_windows.over_b == 1)
    gtk_widget_queue_draw(glarea_XZ);
  if (open_windows.right_b == 1)
    gtk_widget_queue_draw(glarea_YZ);
}


int glarea_display_CAM(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  GtkGLArea *glarea = GTK_GL_AREA(widget);

  pos_camX = sin(DEG2RAD*rot_cam) * z_cam;
  pos_camZ = -cos(DEG2RAD*rot_cam) * z_cam;
  if (gtk_gl_area_make_current(glarea))
    {
      if (!gl_scene->root->childs)
	{
	  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	  initGL(glarea);
	  gtk_gl_area_swapbuffers(glarea);
	  return TRUE;
	}
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      gluPerspective(90,1,1,2000);
      gluLookAt(pos_camX, pos_camY, pos_camZ,0.0,0,0.0,0.0,1.0,0.0);
      glMatrixMode(GL_MODELVIEW);
      glClearColor(1.0, 1.0, 1.0, 1.0);  
      glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
      glLoadIdentity();
      draw_grid(/*  SIZE_GRID */abs(z_cam - 30));
      parse_level1(gl_scene->root, DrawViewCAMfromTreeRender);
      gtk_gl_area_swapbuffers(glarea);
    }
  return TRUE;
}


gboolean on_keypress (GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
  update_view(user_data,event->keyval,0,0);
  return TRUE;
}


void CutFunc(void)
{
  printf("Cut...\n");
}

void CopyFunc(void)
{
  printf("Copy...\n");
}

void PasteFunc(void)
{
  printf("Paste...\n");
}

void ZoomInFunc(void)
{
  printf("Zoom in...\n");
}

void ZoomOutFunc(void)
{
  printf("Zoom out...\n");
}


gint CameraViewEventDispatcher(GtkWidget *window, GdkEvent *event, 
                               gpointer Menu)
{ 
  switch (event->type)
  {
    case GDK_BUTTON_PRESS:
      {
        GdkEventButton *bevent = (GdkEventButton *) event;
        if (bevent->button == 3) /* Right Button ==> Popup Menu */
        {
          gtk_menu_popup(GTK_MENU(Menu), NULL, NULL, NULL, NULL,
                         bevent->button, bevent->time);
        }
        return TRUE;
      }
    default:
      return FALSE;
  }
}


gint show_gtkGL(char *name_object, GtkWidget *window)
{
  GtkWidget	*menu;
  GtkWidget	*SubMenu;
  GtkWidget	*menu_items;
  GtkWidget	*XXXMenu;
  int		i, j;
  
  /* create new OpenGL widget */
  glarea_CAM = gtk_gl_area_new_vargs(NULL,   /*,  no sharing */  
				 GDK_GL_RGBA,
				 GDK_GL_DOUBLEBUFFER,
				 GDK_GL_DEPTH_SIZE,1,
				 GDK_GL_NONE);  /* last argument must be GDK_GL_NONE */
  
  gtk_widget_set_events(glarea_CAM,
			GDK_EXPOSURE_MASK|
			GDK_BUTTON_PRESS_MASK|
			GDK_BUTTON_RELEASE_MASK|
			GDK_POINTER_MOTION_MASK|
			GDK_POINTER_MOTION_HINT_MASK|
			GDK_KEY_PRESS);
  
  gtk_signal_connect (GTK_OBJECT(glarea_CAM), "expose_event",
		      GTK_SIGNAL_FUNC(glarea_display_CAM), NULL);
  gtk_signal_connect (GTK_OBJECT(window),"key-press-event",
		      GTK_SIGNAL_FUNC(on_keypress), glarea_CAM);
  gtk_widget_set_usize(GTK_WIDGET(glarea_CAM), SIZE_X_WIN_CAM, SIZE_Y_WIN_CAM);
  gtk_window_set_title(GTK_WINDOW(window),name_object);
  gtk_container_set_border_width(GTK_CONTAINER(window), 5);
  
  gtk_container_add(GTK_CONTAINER(window), glarea_CAM);
  gtk_widget_show(glarea_CAM);

  for (i = 0; i < NB_MENU; i++)
    menu_popup[i] = (t_menu_popup *)malloc(sizeof(t_menu_popup) * fm[i].nb_submenu);

  /* Menu File */
  menu_popup[0][0].item = "Open POV";	menu_popup[0][0].fcn = OpenPovFunc;
  menu_popup[0][1].item = "Save POV";	menu_popup[0][1].fcn = SavePovFunc;
  menu_popup[0][2].item = "Close";	menu_popup[0][2].fcn = close_construct_vu3d;
  
  /* Edit File */
  menu_popup[1][0].item = "Cut";	menu_popup[1][0].fcn = CutFunc;
  menu_popup[1][1].item = "Copy";	menu_popup[1][1].fcn = CopyFunc;
  menu_popup[1][2].item = "Paste";	menu_popup[1][2].fcn = PasteFunc;

  /* View Menu */
  menu_popup[2][0].item = "Zoom In";	menu_popup[2][0].fcn = ZoomInFunc;
  menu_popup[2][1].item = "Zoom Out";	menu_popup[2][1].fcn = ZoomOutFunc;
  
  /* set popup */
  menu = gtk_menu_new();
  menu_items = gtk_tearoff_menu_item_new();
  gtk_widget_show(menu_items);
  gtk_menu_append(GTK_MENU(menu), menu_items);
  
  for (i = 0 ; i < NB_MENU; i++)
    {
      SubMenu = gtk_menu_new();      
      for (j = 0; j < fm[i].nb_submenu; j++)
	{
	  menu_items = gtk_menu_item_new_with_label(menu_popup[i][j].item);
	  gtk_menu_append(GTK_MENU(SubMenu), menu_items);
	  gtk_signal_connect_object(GTK_OBJECT(menu_items), "activate",
                            GTK_SIGNAL_FUNC(menu_popup[i][j].fcn), NULL);
	  gtk_widget_show(menu_items);
	}
      free(menu_popup[i]);
      /* XXXMenu <=> FileMenu, EditMenu, ToolMenu....XXX={file, edit, ...} */
      XXXMenu = gtk_menu_item_new_with_label(fm[i].name_menu);
      gtk_widget_show(XXXMenu);
      gtk_menu_item_set_submenu(GTK_MENU_ITEM(XXXMenu), SubMenu);
      gtk_menu_append(GTK_MENU(menu), XXXMenu);
    }
  gtk_signal_connect(GTK_OBJECT(window), "event",
		     GTK_SIGNAL_FUNC(CameraViewEventDispatcher), menu);
  return TRUE;
}
